#include <bits/stdc++.h>
#include "bits_and_tree.h"
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn = 200;

vector<pii> encode(int n, vector<bool> data) {
    int cnt = 0;
    vector<pii> out;
    out.push_back(pii(0, 1));
    out.push_back(pii(0, 2));
    out.push_back(pii(0, 3));
    out.push_back(pii(0, 4));
    out.push_back(pii(0, 5));
    cnt = 6; int me = 0, l = 4, r = 5, num_b = 0;
    for (;cnt < n; num_b++) {
        int bit = data[num_b];
        int new_cnt = cnt + 2 + bit * 2;
        if (new_cnt > n)
            break;
        out.push_back(pii(l, cnt++));
        out.push_back(pii(l, cnt++));

        if (bit)
            out.push_back(pii(r, cnt++)), out.push_back(pii(r, cnt++));
        
        me = l, l = cnt - 2 - bit * 2, r = cnt - 1 - bit * 2;
    }
    return out;
}

vector<bool> leaf, deleted;
vector<int> subt_size;
vector<vector<int> > gra;
void get_subt(int curr, int p = -1) {
    subt_size[curr] = 1;
    for (int i : gra[curr])
    {
        if (i == p)
            continue;
        get_subt(i, curr);
        subt_size[curr] += subt_size[i];
    }
}

vector<bool> decode(int n, vector<pii> tree) {
    gra = vector<vector<int> > (n + 1);
    subt_size = vector<int>(n + 1);
    leaf = deleted = vector<bool>(n + 1);

    vector<bool> out;
    for (auto [a, b] : tree) {
        gra[b].push_back(a);
        gra[a].push_back(b);
    }
    int strt = 0;
    for (int i = 0; i <= n; i++) {
        if (gra[i].size() >= 5)
            strt = i;
        
        if (gra[i].size() == 1)
            leaf[i] = true;
    }

    for (int i= 0; i <= n; i++) {
        if (gra[i].size() % 2 == 0) {
            for (int j = 0; j < gra[i].size(); j++) {
                if (gra[gra[i][j]].size() == 1) {
                    gra[i].erase(gra[i].begin() + j);
                    break;
                }
            }
        }
    }
    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < gra[strt].size(); j++) {
            if (gra[gra[strt][j]].size() == 1) {
                gra[strt].erase(gra[strt].begin() + j);
                break;
            }
        }
    }

    get_subt(strt);

    int par = -1;
    while (gra[strt].size() != 1) {
        vector<int> sizs;
        for (int i : gra[strt])
            if (i != par)
                sizs.push_back(gra[i].size());
        sort(all(sizs));
        if (sizs[0] == sizs[1] and sizs[0] == 1)
            break;
        if (sizs[0] == 1)
            out.push_back(false);
        else
            out.push_back(true);
        
        int neww;
        for (int i : gra[strt])
            if (i != par)
                neww = i;
        for (int i : gra[strt])
            if (i != par and subt_size[i] > subt_size[neww])
                neww = i;
        par = strt; 
        strt = neww;
    }

    return out;
}