#include <bits/stdc++.h>
#include "bits_and_tree.h"

using namespace std;

const int nmax = 200;

vector<pair<int,int>> encode(int n, vector<bool> data)
{
    int nr0 = 0;
    vector<int> v;
    for(auto it : data)
    {
        if(it == 0)
        {
            ++nr0;
        }
        else
        {
            v.push_back(nr0);
            nr0 = 0;
        }
    }
    vector<pair<int,int>> e;
    int poz = 0;
    int cnt = v[poz];

    int nod = 8;
    e.push_back({8, 0});
    e.push_back({0, 1});
    e.push_back({1, 2});
    e.push_back({2, 3});

    e.push_back({8, 4});
    e.push_back({4, 5});
    e.push_back({5, 6});
    e.push_back({6, 7});
    int nr = 8;
    while(true)
    {
        if(cnt == 0)
        {
            ++poz;
            cnt = v[poz];
            if(nr + 3 + 6 < n)
            {
                ++nr;
                e.push_back({nod, nr});
                nod = nr;
            }
            else
            {
                e.push_back({nod, nr + 1});
                e.push_back({nr + 1, nr + 2});
                e.push_back({nr + 2, nr + 3});
                e.push_back({nr + 3, nr + 4});
                e.push_back({nr + 4, nr + 5});
                e.push_back({nr + 5, nr + 6});
                nr += 6;
                while(nr < n - 1)
                {
                    ++nr;
                    e.push_back({nr - 1, nr});
                }
                break;
            }
            continue;
        }
        if(nr + 2 + 6 < n)
        {
            --cnt;
            ++nr;
            e.push_back({nod, nr});
            e.push_back({nr, nr + 1});
            ++nr;
        }
        else
        {
            e.push_back({nod, nr + 1});
            e.push_back({nr + 1, nr + 2});
            e.push_back({nr + 2, nr + 3});
            e.push_back({nr + 3, nr + 4});
            e.push_back({nr + 4, nr + 5});
            e.push_back({nr + 5, nr + 6});
            nr += 6;
            while(nr < n - 1)
            {
                ++nr;
                e.push_back({nr - 1, nr});
            }
            break;
        }
    }
    return e;
}

vector<int> G[nmax + 5];

int w[nmax + 5];

void dfs(int nod, int dad = -1)
{
    w[nod] = 1;
    for(auto it : G[nod])
    {
        if(it == dad)
        {
            continue;
        }
        dfs(it, nod);
        w[nod] += w[it];
    }
}

vector<bool> decode(int n, vector<pair<int,int>> tree)
{
    //cerr<<'\n';
    for(auto it : tree)
    {
        int x = it.first;
        int y = it.second;
        //cerr<<x<<' '<<y<<'\n';
        G[x].push_back(y);
        G[y].push_back(x);
    }
    int root = -1;
    for(int i=0; i<=n; i++)
    {
        dfs(i);
        int nr34 = 0;
        for(auto it : G[i])
        {
            if(w[it] == 4 || w[it] == 5)
            {
                ++nr34;
            }
        }
        if(nr34 == 2)
        {
            root = i;
            break;
        }
    }
    int nod = root;
    int dad = -1;
    vector<bool> rez;
    bool done = false;
    while(!done)
    {
        int nr0 = 0;
        int son = 0;
        for(auto it : G[nod])
        {
            if(it == dad)
            {
                continue;
            }
            if(w[it] >= 6 && w[it] <= 9)
            {
                done = true;
            }
            if(w[it] == 2 || w[it] == 3)
            {
                ++nr0;
            }
            if(w[it] > 9)
            {
                son = it;
            }
        }
        for(int i=1; i<=nr0; i++)
        {
            rez.push_back(0);
        }
        if(done)
        {
            break;
        }
        rez.push_back(1);
        dad = nod;
        nod = son;
    }
    for(int i=0;i<=n;i++)
    {
        G[i].clear();
        w[i] = 0;
    }
    return rez;
}
