#include <vector>
#include <iostream>
#include "tunnels.h"
using namespace std;
const int inf=1e9;
const int NMAX=105;
int dp[NMAX][NMAX][NMAX],sp[NMAX][NMAX];
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for (int l=n-1;l>=0;--l)
    {
    sp[l][0]=blocked[l][0];
        for (int i=1;i<m;++i)
            sp[l][i]=sp[l][i-1]+blocked[l][i];
    }
    for (int l=n-1;l>=0;--l)
    {
        for (int i=0;i<m;++i)
        {
            if (blocked[l][i]==0) dp[l][i][i]=dp[l+1][i][i];
            else dp[l][i][i]=inf;
        }
        for (int i=0;i<m;++i)
            for (int j=i+1;j<m;++j)
        {
            dp[l][i][j]=inf;
            if (sp[l][j]-(i==0 ? 0 : sp[l][i-1])>0) continue;
            if (sp[l+1][j]-(i==0 ? 0 : sp[l+1][i-1])==j-i) {
                for (int t=i;t<=j;++t)
                if (blocked[l+1][t]==0) {dp[l][i][j]=dp[l+1][i][j]; break;}
            }
            else{
            for (int t=i;t<j;++t)
                dp[l][i][j]=min(dp[l][i][j],1+max(dp[l][i][t],dp[l][t+1][j]));}
        }
    }
    for (int l=0;l<=n-1;++l)
    {
        int st=0,dr=0;
        for (st=k;;--st)
        {
            if (st==0) break;
            if (blocked[l][st-1]==1) break;
        }
        for (dr=k;;++dr)
        {
            if (dr==m-1) break;
            if (blocked[l][dr+1]==1) break;
        }
        while (sp[l+1][dr]-(st==0 ? 0 : sp[l+1][st-1])!=dr-st)
        {
            for (int t=st;t<dr;++t)
            {
                if (dp[l][st][dr]==1+max(dp[l][st][t],dp[l][t+1][dr]))
                {
                    if (t<k) {int ok=investigate(t); if (ok==1) dr=t; else st=t+1; break;}
                    else {int ok=investigate(t+1); if (ok==1) st=t+1; else dr=t; break;}
                }
            }
        }
        if (l==n-1) {goDeeper(st); return ;}
        for (int t=st;t<=dr;++t)
        {
        if (blocked[l+1][t]==0)
        {goDeeper(t); k=t; break;}
        }
    }
}
///dp[i][j]=min(1+max(dp[i][t],dp[t+1][j]));
