#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 3e5;
const int Q = 5e5;
const int logN = 20;
int prv[N][logN];
int prcalc[N];
int last[N + 1];
set <pair<int, int>> occ;
vector <pair<int, int>> intervals;
int n, q;
ll ans = 0;
void init(int _n, int _q, const vector <int> &v){
    n = _n; q = _q;
    for(int i = 0;i <= n;i++){
        last[i] = -1;
    }
    for(int i = 0;i < n;i++){
        prv[i][0] = last[v[i]];
        last[v[i]] = i;
    }
    for(int i = 0;i < n;i++){
        for(int j = 1;j < logN;j++){
            if(prv[i][j - 1] == -1)prv[i][j] = -1;
            else prv[i][j] = prv[prv[i][j - 1]][j - 1];
        }
    }
    for(int i = 0;i < n;i++){
        int p = i;
        for(int j = logN - 1;j >= 0;j--){
            if(((v[i] - 1)>>j&1) && p != -1){
                p = prv[p][j];
            }
        }
        prcalc[i] = p;
    }
    for(int i = 0;i <= n;i++){
        last[i] = -1;
    }
    for(int i = 0;i < n;i++){
        if(last[v[i]] != -1){
            occ.erase({last[v[i]], v[i]});
        }
        occ.insert({i, v[i]});
        last[v[i]] = i;
        auto it = occ.end();
        it--;
        int rpart = i, sum = 0;
        while(1){
            /// move response
            sum+=it->second;
            int p = prcalc[it->first];
            if(p == -1)break;
            rpart = min(rpart, p);
            /// check and do i
            if(i - rpart + 1 == sum){
                /// complete
                //cout<<"valid:"<<rpart<<' '<<i<<'\n';
                ans++;
                intervals.push_back({rpart, i});
            }
            if(it == occ.begin())break;
            it--;
        }
    }
}
int query(int l, int r){
    if(l == 0 && r == n - 1){
        return ans;
    }else{
        int ans2 = 0;
        for(int i = 0;i < intervals.size();i++){
            if(l <= intervals[i].first && intervals[i].second <= r)ans2++;
        }
        return ans2;
    }
}
/*
int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}


*/
