#include "tunnels.h"
#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <cassert>
#include <map>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;


void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
   for(int i = 0; i < n; i++) {
      if(blocked[i][k ^ 1]) {
	 goDeeper(k);
      }
      else if(i < n - 1 && blocked[i + 1][k ^ 1]) {
	 goDeeper(k);
      }
      else if(i < n - 1 && blocked[i + 1][k]) {
	 goDeeper(k ^ 1); k ^= 1;
      }
      else {
	 if(investigate(k ^ 1)) { goDeeper(k ^ 1); k ^= 1; }
	 else { goDeeper(k); }
      }
   }
   return;
   
}
