#include "tunnels.h"
#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <cassert>
#include <map>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

const int inf = 1e9 + 5;

using pii = pair<int, int>;
using tii = tuple<int, int, int>;


// map<int, int> atr;
// int query(int a) {
   // if(atr.count(a)) return atr[a];
   // return atr[a] = investigate(a);
// }

// int dp[nmax][]

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
   for(int i = 0; i < n; i++) {
      int l = 0, r = m - 1;
      auto eval = [&](int a) {
	 if(a == k) return inf;
	 if(a < k)
	    return abs((a - l + 1) - (r - a));
	 else return abs((r - a + 1) - (a - l));
      };
      while(l < r) {
	 int closest = l;
	 for(int i = l; i <= r; i++)
	    if(eval(i) < eval(closest)) closest = i;
	 int mid = closest;
	 
	 if(investigate(mid)) {
	    if(mid < k) r = mid;
	    else l = mid;
	 }
	 else {
	    if(mid < k) l = mid + 1;
	    else r = mid - 1;
	 }
      }
      goDeeper(l);
      k = l;
   }
   return;
   
}
