#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int, int>> tree;
    int i=0, curr=0, add=4+2*data[0];
    while(curr+add<n)
    {
        for(int i=curr+1;i<=curr+add;i++)
            tree.push_back({curr, i});
        curr+=add;
        i++;
        add=4+add-2*data[i-1]+2*data[i];
        if(curr==4)
            add--;
    }
    int un=1;
    while(curr<n-1)
    {
        curr++;
        tree.push_back({un, curr});
        un=curr;
    }
    //for(auto p:tree)
    //    cout<<p.first<<" "<<p.second<<'\n';
    return tree;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector<int> adj[n+5];
    vector<bool> ans;
    for(auto p:tree)
    {
        adj[p.first].push_back(p.second);
        adj[p.second].push_back(p.first);
    }
    int maxg=0, curn;
    for(int i=0;i<=n;i++)
        if((int)adj[i].size()>maxg)
        {
            maxg=adj[i].size();
            curn=i;
        }
    ans.push_back((maxg%4-maxg%2)/2);
    while(true)
    {
        maxg=0;
        int ncur;
        for(auto x:adj[curn])
            if(maxg<(int)adj[x].size() && adj[x].size()<adj[curn].size())
            {
                maxg=adj[x].size();
                ncur=x;
            }
        if(maxg<4)
            break;
        curn=ncur;
        ans.push_back((maxg%4-maxg%2)/2);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}