#include "tunnels.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#define MAXN 5003
#define TEST 0
using namespace std;

vector <int> caut[2];

int GoDeeperStanga(int st,int dr,bool ver){
  int mij;

  st=0;
  dr=caut[0].size();

  while(dr-st>1){
    mij=(st+dr)/2;
    if(investigate(caut[0][mij])){
      st=mij;
    }else{
      dr=mij;
    }
  }

  goDeeper(caut[0][st]);
  return caut[0][st];
}

int GoDeeperDreapta(int st,int dr,bool ver){
  int mij;
  st=0;
  dr=caut[1].size();

  while(dr-st>1){
    mij=(st+dr)/2;
    if(investigate(caut[1][mij])){
      st=mij;
    }else{
      dr=mij;
    }
  }

  goDeeper(caut[1][st]);
  return caut[1][st];
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
  int i,j,st,dr,ord[3];
  int pos[MAXN];

  i=0;
  while(i<n){
    caut[0].clear();
    caut[1].clear();
    caut[0].shrink_to_fit();
    caut[1].shrink_to_fit();

    st=k-1;
    while(st>=0 && blocked[i][st]==0){
      if(i<n-1){
        if(blocked[i+1][st]==0){
          pos[j]=1;
          caut[0].push_back(st);
        }else{
          pos[j]=0;
        }
      }else{
        caut[0].push_back(st);
      }
      st--;
    }

    dr=k+1;
    while(dr<m && blocked[i][dr]==0){
      if(i<n-1){
        if(blocked[i+1][dr]==0){
          pos[j]=1;
          caut[1].push_back(dr);
        }else{
          pos[j]=0;
        }
      }else{
        caut[1].push_back(dr);
      }
      dr++;
    }

    for(j=0;j<caut[0].size()/2;j++){
      swap(caut[0][j],caut[0][j-caut[0].size()-1]);
    }

    if(TEST==1){
      printf("\nPOZ STANGA : ");
      for(int aux : caut[0]){
        printf("%2d ",aux);
      }
      printf("\nPOZ DREAPT : ");
      for(int aux : caut[1]){
        printf("%2d ",aux);
      }
      printf("\nst:%2d dr:%2d k:%2d \n",st,dr,k);
    }

    ord[0]=0;
    ord[1]=0;
    ord[2]=0;

    if(caut[0].size()==0){
      ord[0]=0;
    }else{
      ord[0]=1;
    }

    if(i<n-1 && blocked[i][k]==1){
      pos[k]=0;
      ord[1]=0;
    }else{
      pos[k]=1;
      ord[1]=1;
    }
    if(caut[1].size()==0){
      ord[2]=0;
    }else{
      ord[2]=1;
    }


    if(ord[0]==0){
      if(ord[1]==0){
        ///Cautam pe Dreapta
        k=GoDeeperDreapta(0,caut[1].size(),false);
      }else{
        if(ord[2]==0){
          ///Sigur e pe Mij
          goDeeper(k);
        }else{
          ///Verificam pe Mij si Dreapta
          if(investigate(caut[1][0])==0){
            goDeeper(k);
          }else{
            ///!!!PUTEM SALVA O OPERATIE TEORETIC
            k=GoDeeperDreapta(0,caut[1].size(),true);
          }
        }
      }
    }else{
      if(ord[1]==0){
        if(ord[2]==0){
          ///Cautam pe Stanga
          k=GoDeeperStanga(0,caut[0].size(),false);
        }else{
          ///Verificam pe Stanga si Dreapta
          ///!!!PUTEM BAGA RANDOM
          if(investigate(caut[1][0])==0){
            k=GoDeeperStanga(0,caut[0].size(),false);
          }else{
            ///!!!PUTEM SALVA O OPERATIE TEORETIC
            k=GoDeeperDreapta(0,caut[1].size(),true);
          }
        }
      }else{
        if(ord[2]==0){
          ///Verificam pe Stanga si Mij
          if(investigate(caut[0][0])==0){
            goDeeper(k);
          }else{
            ///!!!PUTEM SALVA O OPERATIE TEORETIC
            k=GoDeeperStanga(0,caut[0].size(),true);
          }
        }else{
          ///Verificam pe Stanga,Mij si Dreapta

          ///!!!PUTEM BAGA RANDOM
          if(investigate(caut[0][0])==0){
            if(investigate(caut[1][0])==0){
              goDeeper(k);
            }else{
              k=GoDeeperDreapta(0,caut[1].size(),true);
            }
          }else{
            k=GoDeeperStanga(0,caut[0].size(),true);
          }
        }
      }
    }

    i++;
  }

}