#include "bits_and_tree.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#define MAXN 220
using namespace std;

vector<std::pair<int, int>> graf;
int t;

void ConectNumberToNod(int val,int nr){
  while(nr>0){
    graf.push_back({val,t});
    t++;
    nr--;
  }
}

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data){
  int i,st,dr,l;

  graf.clear();

  st=0;
  t=1;
  ConectNumberToNod(st,10);
  l=st;

  for(i=0;i<70;i+=2){ ///De schimbat
    graf.push_back({l,t});
    t++;
    l=t-1;
    if((data[i]^i)%2==1){
      if((data[i+1]^(i+1))%2==1){
        ConectNumberToNod(l,6);
      }else{
        ConectNumberToNod(l,4);
      }
    }else{
      if((data[i+1]^(i+1))%2==1){
        ConectNumberToNod(l,2);
      }
    }
  }

  dr=t;
  t++;

  graf.push_back({l,dr});

  ConectNumberToNod(dr,n-t);
  return graf;
}

int vf[MAXN];
int tip[MAXN];
int adanMa[MAXN];
vector <int> grafBet[MAXN];
vector <bool> decod;
int adanMAXIMA;
int starting,ending;

void DFSAdanMa(int node,int adan,int fath){
  adanMa[node]=adan;

  if(node==ending){
    return;
  }

  for(int neigh : grafBet[node]){
    if(neigh!=fath){
      DFSAdanMa(neigh,adan+1,node);
      adanMa[node]=max(adanMa[node],adanMa[neigh]);
    }
  }
}

void DFS(int node,int adan,int fath){
  int pozUrm;

  pozUrm=-1;
  for(int neigh : grafBet[node]){
    if(neigh!=fath){
      if(adanMa[neigh]==adanMAXIMA){
        pozUrm=neigh;
      }
    }
  }

  if(pozUrm!=ending && pozUrm!=-1){
    decod.push_back(((tip[pozUrm]>>1)^adan    )%2);
    decod.push_back(((tip[pozUrm]%2)^(adan+1))%2);
    DFS(pozUrm,adan+2,node);
  }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree){
  int i;

  decod.clear();
  for(i=0;i<=n;i++){
    vf[i]=0;
    tip[i]=-1;
    adanMa[i]=0;
    grafBet[i].clear();
  }

  for(auto val : tree){
    vf[val.first]++;
    vf[val.second]++;
    grafBet[val.first].push_back(val.second);
    grafBet[val.second].push_back(val.first);
  }

  for(i=0;i<=n;i++){
    if(vf[i]<=1){
      tip[i]=-1;
    }else{
      if(vf[i]<=3){
        tip[i]=0;
      }else{
        if(vf[i]<=5){
          tip[i]=1;
        }else{
          if(vf[i]<=7){
            tip[i]=2;
          }else{
            if(vf[i]<=9){
              tip[i]=3;
            }else{
              if(vf[i]<=12){
                starting=i;
              }else{
                ending=i;
              }
            }
          }
        }
      }
    }
  }

  DFSAdanMa(starting,0,-1);
  adanMAXIMA=adanMa[starting];
  DFS(starting,0,-1);

  return decod;
}

