#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using ll = long long;
#define debug(x) #x << " = " << x << '\n'

const std::vector<int> hard = {0,1,0,0,0,0,0,1,1,0,1,1,0,1,0,1,0,1,1,0,0,0,1,1,1,0,1,0,0,0,0,1,1,1,0,0,1,0,0,1,0,1,0,1,1,1,0,0,0,0,1,1,0,0,1,0,1,0,0,1,0,1,0,1,0,0,0,0,1,0,0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,0,1,1,0,1,1,1,0,1,1,1,0,0,0,1,0,0,1,1,1,0,1,1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,0,1,0,1,1,0,0,1,0,1,1,1,1,0,1,0,1,0,0,1,1,0,1,1,1,0,1,1,1,1,0,0,1,1,0,0,1,0,0,0,1,0,1,1,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,0,1,0,1,1,0,0,0,1,0,0,0,1,0,0,0,1,0,1,1,1,1,0,1,1,1,1,0,0,1,1,1,1,1,0,0,1,1,1,0,1,0,0,0,1,1,1,0,1,0,0,1,1,1,0,1,1,0,0,0,1,0,1,1,0,0,1,1,1,1,1,0,1,1,1,0,1,1,0,0,0,1,1,0,0,1,0,0,0,1,0,1,1,1,0,1,1,1,0,0,0,0,1,0,1,1,1,1,0,1,1,1,1,1,1,0,0,1,0,0,1,0,1,1,1,1,1,1,0,1,1,1,0,0,0,1,1,0,1,0,0,1,0,1,1,0,0,0,0,1,1,1,1,1,0,1,0,1,1,1,0,0,1,0,0,1,0,0,0,0,0,1,1,0,1,0,0,0,1,1,0,1,0,1,0,1,1,0,0,0,1,0,1,1,0,0,1,0,0,1,1,0,0};

const int LEFT = 199;
const int LEFT1 = 198;
const int LEFT2 = 197;
const int LEFT3 = 196;
const int LEFT4 = 195;
const int LEFT5 = 194;
const int RIGHT = 193;
const int RIGHT1 = 192;
const int RIGHT2 = 191;
const int RIGHT3 = 190;
const int RIGHT4 = 189;
const int RIGHT5 = 188;
const int RIGHT6 = 187;
const int RIGHT7 = 186;
const int MAX_ONES = 80;
const int BULAN = 30;
const int NMAX = 200;
const std::vector<bool> emp = {};

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
  // sa fac nodu din stanga
  // std::vector<std::pair<int, int>> ret;
  // for (int i = 1; i < RIGHT; i++) {
  //   ret.push_back({LEFT, i});
  // }
  // for (int i = RIGHT + 1; i <= RIGHT + 7; i++) {
  //   ret.push_back({RIGHT, i});
  // }
  // // raman nodurile 14, 15, ..., n - 1

  // std::vector<int> id(n, 0);
  // std::vector<int> pt1;
  // int remaining = n - 14;
  // for (int i = 0; i < n / 2 + BULAN; i++) {
  //   pt1.push_back(n - 14 - i);
  // }
  // for (int i = 0; i < n; i++) {
  //   id[i] = i + 14;
  // }
  
  // ret.push_back({LEFT, id[0]});

  // for (int i = 0; i + 1 < remaining; i++) {
  //   ret.push_back({id[i], id[i + 1]});
  // }
  // ret.push_back({id[remaining - 1], RIGHT});

  std::vector<std::pair<int, int>> ret;
  ret.push_back({LEFT, LEFT1});
  ret.push_back({LEFT, LEFT2});
  ret.push_back({LEFT, LEFT3});
  ret.push_back({LEFT, LEFT4});
  ret.push_back({LEFT, LEFT5});
  ret.push_back({RIGHT, RIGHT1});
  ret.push_back({RIGHT, RIGHT2});
  ret.push_back({RIGHT, RIGHT3});
  ret.push_back({RIGHT, RIGHT4});
  ret.push_back({RIGHT, RIGHT5});
  ret.push_back({RIGHT, RIGHT6});
  ret.push_back({RIGHT, RIGHT7});
  std::vector<int> pt1;
  for (int i = 0; i < MAX_ONES; i++) {
    pt1.push_back(185 - i);
  }
  
  int am_voie = pt1.back() - 1;
  ret.push_back({LEFT, 0});
  ret.push_back({am_voie, RIGHT});
  for (int i = 0; i < (int) data.size(); i++) {
    if (hard[i]) {
      data[i] = !data[i];
    }
  }
  for (int i = 0; i < am_voie; i++) {
    ret.push_back({i, i + 1});
  }
  for (int i = 0; i <= am_voie; i++) {
    if (data[i] == 1) {
      ret.push_back({i, pt1.back()});
      pt1.pop_back();
      ret.push_back({i, pt1.back()});
      pt1.pop_back();
    }
  }
  std::vector<int> deg(n, 0);
  for (const auto &[x, y] : ret) {
    deg[x]++;
    deg[y]++;
  }
  for (int i = 0; i < n; i++) {
    if (deg[i] == 0) {
      ret.push_back({RIGHT, i});
    }
  }
  assert(deg[LEFT] == 6);
  assert(deg[RIGHT] >= 8);
  for (int i = 0; i <= am_voie; i++) {
    if (data[i] == 1) {
      assert(deg[i] == 4);
    } else {
      assert(deg[i] == 2);
    }
  }
  return ret;
}

std::vector<int> g[NMAX + 100];
std::vector<int> order;
bool vis[NMAX + 100];

void dfs(int u, int p) {
  vis[u] = true;
  order.push_back(u);
  for (const auto &v : g[u]) {
    if (!vis[v]) {
      dfs(v, u);
    }
  }
}


std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
  std::vector<int> deg(n + 1, 0);
  for (const auto &[x, y] : tree) {
    deg[x]++;
    deg[y]++;
    g[x].push_back(y);
    g[y].push_back(x);
  }
  assert((int) tree.size() == n);
  int st = -1, dr = -1;
  for (int i = 0; i <= n; i++) {
    if (deg[i] == 6 || deg[i] == 7) {
      assert(st == -1);
      st = i;
    } else if (deg[i] >= 8) {
      assert(dr == -1);
      dr = i;
    }
  }
  dfs(st, -1);
  // std::cout << " ! " << st << ' ' << dr << '\n';
  // return emp;
  std::vector<bool> answer;
  // return answer;
  for (const auto &u : order) {
    if (deg[u] == 2 || deg[u] == 3) {
      answer.push_back(0);
    } else if (deg[u] == 4 || deg[u] == 5) {
      answer.push_back(1);
    }
  }
  for (int i = 0; i < (int) answer.size(); i++) {
    if (hard[i]) {
      answer[i] = !answer[i];
    }
  }
  return answer;
}