#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);


int cbDr( int st, int dr ) {
    while ( st < dr - 1 ) {
        int mij = ( st + dr ) / 2;
        if ( investigate( mij ) ) {
            st = mij;
        } else {
            dr = mij;
        }
    }
    return st;
}

int cbSt( int st, int dr ) {
    while ( st < dr - 1 ) {
        int mij = ( st + dr ) / 2;
        if ( investigate( mij ) ) dr = mij;
        else st = mij;
    }
    return dr;
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& a) {
    if ( m == 2 ) {
        for ( int i = 0; i < n; i ++ ) {
            if ( !a[i][1 - k] && ( i + 1 == n || !a[i + 1][1 - k] ) ) {
                if ( (i + 1 < n && a[i + 1][k] ) || investigate( 1 - k ) ) {
                    goDeeper( 1 - k );
                    k = 1 - k;
                } else goDeeper( k );
            } else {
                goDeeper( k );
            }
        }
    } else {
        for ( int i = 0; i < n; i ++ ) {
            if ( k == 0 ) {
                k = cbDr( k, m );
                goDeeper( k );
            } else if ( k == m - 1 ) {
                k = cbSt( -1, k );
                goDeeper( k );
            } else {
                if ( m - k > k + 1 ) {
                    if ( investigate( k + 1 ) ) {
                        k = cbDr( k + 1, m );
                        goDeeper( k );
                    } else {
                        k = cbSt( -1, k );
                        goDeeper( k );
                    }
                } else {
                    if ( investigate( k - 1 ) ) {
                        k = cbSt( -1, k - 1 );
                        goDeeper( k );
                    } else {
                        k = cbDr( k, m );
                        goDeeper( k );
                    }
                }
            }
        }
    }
}
