#include "bits_and_tree.h"
#include <unordered_map>
using namespace std;

vector<pair<int,int>> encode(int n,vector<bool> data){
  vector<pair<int,int>> edges;

  int parent=0,curent=1;
  n--;

  if(data[0]){
    while(n--){
      edges.push_back({parent,curent++});
    }
  }else{
    while(n--){
      edges.push_back({parent,curent});
      parent=curent++;
    }
  }

  return edges;
}

vector<bool> decode(int n,vector<pair<int,int>> tree){
  vector<bool> data;
  unordered_map<int,int> nredge;

  for(auto edge:tree){
    nredge[edge.first]++;
    nredge[edge.second]++;
  }

  int nr1=0,nr2=0,nr3=0;
  for(int u=0;u<=n;u++){
    if(nredge[u]==2){
      nr2++;
    }else if(nredge[u]==1){
      nr1++;
    }else if(nredge[u]==3){
      nr3++;
    }
  }

  if((nr1==2&&nr2==n-1)||(nr1==3&&nr2==n-3&&nr3==1)){
    data.push_back(0);
  }else{
    data.push_back(1);
  }

  return data;
}