#include "self-describing.h"
#include <cstdio>
using namespace std;

#define MAXN 300000

int v[MAXN];
int n,maxnr;
int frecv[MAXN+1];

void init(int N,int Q,const vector<int>& a){
  n=maxnr=0;
  for(auto nr:a){
    v[n++]=nr;
    maxnr=max(maxnr,nr);
  }
}

long long query(int l,int r){
  int st=l,dr=r;
  long long nrsecv=0;
  for(l=st;l<=dr;l++){
    for(r=l;r<=dr;r++){
      for(int i=l;i<=r;i++){
        frecv[v[i]]++;
      }

      int nr=1;
      while(nr<=maxnr&&(frecv[nr]==nr||frecv[nr]==0)){
        nr++;
      }

      if(nr>maxnr){
        nrsecv++;
      }

      for(int i=l;i<=r;i++){
        frecv[v[i]]=0;
      }
    }
  }

  return nrsecv;
}