#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

//#define DEFINES 1
#ifdef DEFINES
    #define DEBUG           1
    #define STATISTICS_TREE 1

    #define DEBUG_LOG_ONLY if(DEBUG)

    #ifdef STATISTICS_TREE
        #include <ext/pb_ds/assoc_container.hpp>
        #include <ext/pb_ds/tree_policy.hpp>

        using namespace __gnu_pbds;

        template<class type, class comarator = less<type>>
        using OrderedSet = tree<type, null_type, less<type>, rb_tree_tag, tree_order_statistics_node_update>;
    #endif // STATISTICS_TREE
#endif // DEFINES


void solve(int n, int m, int k, const vector<vector<bool>>& bloc) {
    goDeeper(k);
    for(int i = 1; i < n; i++) {
        int pozUrm = 0;
        for(int j = 0; j < m; j++) {
            if(bloc[i][j]) continue;

            if(investigate(j)) {
                pozUrm = j;
                break;
            }
        }
        goDeeper(pozUrm);
    }
}
