#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

#define DEFINES 1
#if DEFINES
    #define DEBUG           1
    #define STATISTICS_TREE 0

    #define DEBUG_LOG_ONLY if(DEBUG)
    #define DEBUG_PAUSE_SYSTEM system("pause");
    #define DEBUG_CLEAR system("cls");
    #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";

    #if STATISTICS_TREE
        #include <ext/pb_ds/assoc_container.hpp>
        #include <ext/pb_ds/tree_policy.hpp>

        using namespace __gnu_pbds;

        template<class type, class comarator = less<type>>
        using OrderedSet = tree<type, null_type, less<type>, rb_tree_tag, tree_order_statistics_node_update>;
    #endif // STATISTICS_TREE
#endif // DEFINES

void solve(int n, int m, int k, const vector<vector<bool>>& bloc) {
    /// Workflow
    /// 1) determine where did the bunny go to so he could be able to jump down
    /// 2) jump down

    /// determining coud easily be done greedely with O(M) between closest rocks

    /// TODO:
    /// add binary search for $st and $dr

    goDeeper(k);
    for(int i = 1; i < n; i++) {
        int st = k;
        while(0 <= st && !bloc[i][st]) st--;
        st++;

        int dr = k;
        while(dr < m && !bloc[i][dr]) dr++;
        dr--;

        DEBUG_LOG_ONLY DEBUG_PRINT_VAR_BOLD("st", st);
        DEBUG_LOG_ONLY DEBUG_PRINT_VAR_BOLD("dr", dr);

        short dir = 0;    /// nu o ia pe nicaieri

        bool areLocSt = (st != k);
        bool areLocDr = (k != dr);

        bool areLoc = (areLocSt | areLocDr);

        if(areLocSt) {
            if(investigate(k - 1)) {
                dr = k - 2;
                dir = -1;
            }
        }
        if(areLocDr && dir == 0) {
            if(investigate(k + 1)) {
                st = k + 2;
                dir = 1;
            }
        }

        int poz = k + dir;
        if(dir == 1) {
            while(st <= dr) {
                int mij = st + (dr - st) / 2;

                if(investigate(mij)) {
                    poz = mij;
                    st = mij + 1;
                }
                else dr = mij - 1;
            }
        }
        else if(dir == -1) {
            while(st <= dr) {
                int mij = st + (dr - st) / 2;

                if(investigate(mij)) {
                    poz = mij;
                    dr = mij - 1;
                }
                else st = mij + 1;
            }
        }

        goDeeper(k = poz);
    }
}
