#include "tunnels.h"

#include <bits/stdc++.h>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    srand(time(0));

    int curr = k;
    for (int i = 0; i < n; ++i) {
        int dir = (rand() % 2) * 2 - 1;
        if (curr == 0 || blocked[i][curr - 1])
            dir = 1;
        else if (curr == n - 1 || blocked[i][curr + 1])
            dir = -1;

        int lim = (dir == -1 ? 0 : m - 1);
        for (;; curr += dir) {
            if (curr == lim || blocked[i][curr + dir] || !investigate(curr + dir)) {
                goDeeper(curr);
                break;
            }
        }
    }
}
