#include <bits/stdc++.h>

using namespace std;

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    vector<vector<vector<bool>>> dp(n, vector<vector<bool>>(m, vector<bool>(3, false)));

    for (int j = 0; j < m; ++j) {
        if (blocked[n - 1][j]) continue;
        dp[n - 1][j][0] = (j > 0 && !blocked[n - 1][j - 1]);
        dp[n - 1][j][1] = (j < m - 1 && !blocked[n - 1][j + 1]);
        dp[n - 1][j][2] = true;
    }

    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (blocked[i][j]) continue;
            dp[i][j][2] = (dp[i + 1][j][0] || dp[i + 1][j][1] || dp[i + 1][j][2]);
        }

        for (int j = 0; j < m; ++j) {
            if (j == 0 || blocked[i][j]) continue;
            dp[i][j][0] = (dp[i][j - 1][0] || dp[i][j - 1][2]);
        }

        for (int j = m - 1; j >= 0; --j) {
            if (j == m - 1 || blocked[i][j]) continue;
            dp[i][j][1] = (dp[i][j + 1][1] || dp[i][j + 1][2]);
        }
    }

    int curr = k;
    for (int i = 0; i < n; ++i) {
        int dir = 0;
        if (dp[i][curr][0]) {
            if (!dp[i][curr][1]) dir = -1;
            else if (investigate(curr + 1)) dir = 1, ++curr;
            else dir = -1;
        } else if (dp[i][curr][1]) dir = 1;
        else {
            goDeeper(curr);
            continue;
        }

        vector<int> pos;
        for (int p = curr;; p += dir) {
            if (dp[i][p][2] && p != curr) pos.push_back(p);
            if (!dp[i][p][(dir + 1) / 2]) break;
        }
        if (dir == -1) reverse(pos.begin(), pos.end());

        int ans = curr;

        if (dir == 1) {
            int low = 0, high = pos.size() - 1;
            while (low <= high) {
                int mid = (low + high) >> 1;
                if (investigate(pos[mid])) low = mid + 1, ans = mid;
                else high = mid - 1;
            }
        } else {
            int low = 0, high = pos.size() - 1;
            while (low <= high) {
                int mid = (low + high) >> 1;
                if (investigate(pos[mid])) high = mid - 1, ans = mid;
                else low = mid + 1;
            }
        }

        curr = pos[ans];
        goDeeper(pos[ans]);
    }
}
