#include <iostream>
#include <vector>

constexpr int LIM = 3e5;
int N, Q, freq[LIM + 1];
std::vector<int> a;

void init(int n, int q, const std::vector<int> &input) {
    N = n, Q = q, a = input;
}

long long query(int l, int r) {
    int ans = 0;

    for (int i = l; i <= r; ++i) {
        int cnt = 0, cnt_ok = 0;
        for (int j = i; j <= r; ++j) {
            ++freq[a[j]];
            if (freq[a[j]] == 1) ++cnt;
            if (freq[a[j]] == a[j]) ++cnt_ok;
            if (freq[a[j]] == a[j] + 1) --cnt_ok;
            if (cnt == cnt_ok) ++ans;
        }
        for (int j = i; j <= r; ++j)
            --freq[a[j]];
    }

    return ans;
}
