#include<bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> a;

void init(int N, int Q, const std::vector<int>& a_) {
    a = a_;
    for (int &x : a) {
        x -= 1;
    }
    vector<vector<int>> adj(N);
    set<pair<int, int>, greater<>> st; // {start, x}
    vector<vector<int>> best(N);
    int cnt = 0;
    for (int i = 0; i < N; ++i) {
        int x = a[i];
        adj[x].push_back(i);
        if (adj[x].size() >= x) {
            int rem = adj[x].size() == x ? -1 : adj[x].rbegin()[x];
            if (rem != -1) {
                st.erase({rem, x});
            }
            st.emplace(adj[x].rbegin()[x - 1], x);
        }
        vector<pair<int, int>> s(st.begin(), st.end());
        int sum = 0;
        for (auto [start, y] : s) {
            sum += y;
            if (i - sum == start) {
                best[i].push_back(start);
                cnt += 1;
            }
        }
    }
    assert(cnt <= N * 20);
}

long long query(int l, int r) {
    int N = a.size();
    vector<vector<int>> adj(N);
    set<pair<int, int>, greater<>> st; // {start, x}
    int cnt = 0;
    for (int i = l; i <= r; ++i) {
        int x = a[i];
        adj[x].push_back(i);
        if (adj[x].size() >= x) {
            int rem = adj[x].size() == x ? -1 : adj[x].rbegin()[x];
            if (rem != -1) {
                st.erase({rem, x});
            }
            st.emplace(adj[x].rbegin()[x - 1], x);
        }
        vector<pair<int, int>> s(st.begin(), st.end());
        int sum = 0;
        for (auto [start, y] : s) {
            sum += y;
            if (i - sum == start) {
                cnt += 1;
            }
        }
    }
    return cnt;
}

//int main(){
//	std::ios_base::sync_with_stdio(false);
//	std::cin.tie(nullptr); std::cout.tie(nullptr);
//	int n, q; std::cin >> n >> q;
//	std::vector<int> input(n);
//	for(int i = 0; i < n; i ++){
//		std::cin >> input[i];
//	}
//	init(n, q, input);
//	for(int i = 0; i < q; i ++){
//		int l, r;
//		std::cin >> l >> r;
//		std::cout << query(l, r) << " ";
//	}
//	std::cout << std::endl;
//}
