#include<bits/stdc++.h>
#include"tunnels.h"

using namespace std;


const int inf = 1e9;

int numq(int x) {
	int ret = 0;
	while (x > 1) {
		ret++;
		x = (x + 1) / 2;
	}
	return ret;
}

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
	vector<vector<int>> mn(n + 1, vector<int>(m, inf));
	fill(mn[n].begin(), mn[n].end(), 0);
	for (int i = n - 1; i >= 0; --i) {
		for (int j = 0; j < m; ++j) {
			if (blocked[i][j]) continue;
			mn[i][j] = mn[i + 1][j] + 1;
		}
		for (int j = 0; j < m; ++j) {
			if (blocked[i][j]) continue;
			for (int k = j; k < m && !blocked[i][k]; ++k) {
				mn[i][j] = min(mn[i][j], mn[i][k] + abs(j - k));
			}
			for (int k = j; k >= 0 && !blocked[i][k]; --k) {
				mn[i][j] = min(mn[i][j], mn[i][k] + abs(j - k));
			}
		}
	}
	vector<vector<int>> mx(n + 1, vector<int>(m, -1));
	fill(mx[n].begin(), mx[n].end(), 0);
	for (int i = n - 1; i >= 0; --i) {
		for (int k = 0; k < m; ++k) {
			if (mx[i + 1][k] == inf || blocked[i][k]) continue;
			int d = mx[i + 1][k] + 1;
			for (int j = k; j < m && !blocked[i][j]; ++j) {
				mx[i][j] = max(mx[i][j], d + abs(j - k));
			}
			for (int j = k; j >= 0 && !blocked[i][j]; --j) {
				mx[i][j] = max(mx[i][j], d + abs(j - k));
			}
		}
		for (int j = 0; j < m; ++j) {
			if (blocked[i][j]) mx[i][j] = inf;
			else if (mx[i][j] == -1) mx[i][j] = inf;
		}
	}
	for (int i = 0; i < n; ++i) {
		vector<int> lft, rgt;
		for (int j = k; j < m && !blocked[i][j]; ++j) {
			if (abs(j - k) + mn[i + 1][j] + 1 <= mx[i][k]) rgt.push_back(j);
		}
		for (int j = k; j >= 0 && !blocked[i][j]; --j) {
			if (abs(j - k) + mn[i + 1][j] + 1 <= mx[i][k]) lft.push_back(j);
		}
		if (mn[i + 1][k] + 1 <= mx[i][k]) {
			if (lft.size() == 1) lft.clear();
			else rgt.clear();
		}
		if (lft.size() > rgt.size()) swap(lft, rgt);
		vector<int> vec;
		if (lft.size() && investigate(vec.back() < k ? k - 1 : k + 1)) {
			vec = lft;
		} else {
			vec = rgt;
		}
		assert(vec.size() > 0);
		int L = 0, R = vec.size() - 1;
		while (L != R) {
			int M = (L + R) / 2 + 1;
			if (investigate(vec[M])) L = M;
			else R = M - 1;
		}
		k = vec[L];
		goDeeper(k);
	}
}