#include"tunnels.h"
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve(ll n, ll m, ll k, const vector<vector<bool>>& blocked) {
	vector<vector<bool>> b = blocked;
	b.emplace_back(m, false);
	ll now = k;
	ll nl = 0;
	while (nl < n) {
		ll l = 0, r = m;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			if (mid == now) {
				mid++;
			}
			if (investigate(mid)) {
				if (mid > now) {
					l = mid;
				} else {
					r = mid + 1;
				}
			} else {
				if (mid > now) {
					r = mid;
				} else {
					l = mid + 1;
				}
			}
		}
		goDeeper(l);
		now = l;
		nl++;
	}
	//vector<vector<ll>> dp(n + 1, vector<ll>(m, 0));
	//vector<vector<vector<ll>>> dpsegl(n + 1, vector<ll>(m, vector<ll>(m, 0)));
	//vector<vector<vector<ll>>> dpsegr(n + 1, vector<ll>(m, vector<ll>(m, 0)));
	//vector<vector<vector<ll>>> dpl(n + 1, vector<ll>(m, vector<ll>(m, 0)));
	//vector<vector<vector<ll>>> dpr(n + 1, vector<ll>(m, vector<ll>(m, 0)));
	//for (ll i = n - 1; i >= 0; i--) {
	//}
}

#ifdef LOCAL

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
#endif
