#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<pair<ll, ll>> encode(ll n, vector<bool> data) {
	vector<pair<ll, ll>> ans;
	for (ll i = 0; i < 6; i++) {
		ans.emplace_back(0, i + 1);
	}
	ll nv = 1;
	ll nfn = 7;
	ll nu = 0;
	bool nx = false;
	while (nfn + 2 < n) {
		if (data[nu] != nx) {
			ans.emplace_back(nv, nfn);
			nv = nfn;
			nfn++;
		} else {
			ans.emplace_back(nv, nfn);
			ans.emplace_back(nv, nfn + 1);
			ans.emplace_back(nv, nfn + 2);
			nv = nfn;
			nfn += 3;
		}
		nu++;
		nx = !nx;
	}
	while (nfn < n) {
		ans.emplace_back(0, nfn);
		nfn++;
	}
	return ans;
}

void dfs(ll v, ll p, vector<vector<ll>>& to, vector<ll>& sz) {
	for (auto i : to[v]) {
		if (i != p) {
			dfs(i, v, to, sz);
			sz[v] += sz[i];
		}
	}
}

vector<bool> decode(ll n, vector<pair<ll, ll>> tree) {
	ll root = 0;
	ll ms = 0;
	vector<vector<ll>> to(n + 1);
	for (ll i = 0; i < n; i++) {
		to[tree[i].first].push_back(tree[i].second);
		to[tree[i].second].push_back(tree[i].first);
	}
	for (ll i = 0; i <= n; i++) {
		if (assign_max(ms, (ll)to[i].size())) {
			root = i;
		}
	}
	vector<ll> sz(n + 1, 1);
	dfs(root, root, to, sz);
	vector<bool> ans;
	ll nv = root;
	ll np = root;
	bool nx = false;
	while (sz[nv] != 1) {
		if (nv != root) {
			if (to[nv].size() <= 3) {
				ans.push_back(true != nx);
			} else {
				ans.push_back(false != nx);
			}
			nx = !nx;
		}
		ll bs = 0, vbs = 0;
		for (auto i : to[nv]) {
			if (i != np) {
				if (assign_max(vbs, sz[i])) {
					bs = i;
				}
			}
		}
		np = nv;
		nv = bs;
	}
	return ans;
}
