//#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

constexpr ll K = 1024, LK = 10, KM1 = 1023;
constexpr ll K2 = 32, LK2 = 5, K2M1 = 31;

vector<vector<ll>> gsf, gss;
vector<vector<ll>> gsf2, gss2, gsc2;
vector<vector<ll>> psgs, psgs2;
vector<vector<long long>> psb;

void init(ll n, ll q, const vector<ll>& a) {
	vector<deque<ll>> all(n + 1);
	set<pair<ll, ll>> lpos;
	gsf.resize(n);
	gss.resize(n);
	gsf2.resize((n + K2 - 1) >> LK2);
	gss2.resize((n + K2 - 1) >> LK2);
	gsc2.resize((n + K2 - 1) >> LK2);
	psgs.resize(n);
	psgs2.resize((n + K2 - 1) >> LK2);
	psb.resize((n + K - 1) >> LK, vector<long long>(n + 1, 0));
	vector<vector<pair<ll, ll>>> adds((n + K2 - 1) >> LK2);
	for (ll i = n - 1; i >= 0; i--) {
		ll nx = a[i];
		if (!all[nx].empty()) {
			lpos.erase(make_pair(all[nx].front(), nx));
		}
		lpos.insert(make_pair(i, nx));
		all[nx].push_front(i);
		ll fb = n;
		vector<pair<ll, ll>> bs;
		for (auto[st, num] : lpos) {
			if (st >= fb) {
				break;
			}
			if (all[num].size() < num) {
				assign_min(fb, st);
			} else {
				bs.emplace_back(make_pair(st, all[num][num - 1]));
				if (all[num].size() > num) {
					assign_min(fb, all[num][num]);
				}
			}
		}
		sort(bs.begin(), bs.end());
		vector<pair<ll, ll>> nbs;
		ll now = 0;
		while (now < bs.size()) {
			auto[nl, nr] = bs[now];
			now++;
			while (now < bs.size() && bs[now].first <= nr) {
				assign_max(nr, bs[now].second);
				now++;
			}
			nbs.emplace_back(nl, nr);
		}
		nbs.emplace_back(n, n);
		ll nst = i;
		for (auto[l, r] : nbs) {
			if (nst >= fb) {
				break;
			}
			gsf[i].push_back(nst);
			gss[i].push_back(min(l, fb));
			nst = r;
		}
		psgs[i].push_back(0);
		for (ll j = 0; j < gsf[i].size(); j++) {
			ll l = gsf[i][j], r = gss[i][j];
			adds[i >> LK2].emplace_back(l, 1);
			adds[i >> LK2].emplace_back(r, -1);
			psb[i >> LK][l]++;
			psb[i >> LK][r]--;
			psgs[i].push_back(psgs[i].back() + r - l);
		}
	}
	for (ll i = 0; i < gsf2.size(); i++) {
		sort(adds[i].begin(), adds[i].end());
		ll ns = 0;
		ll nl = i << LK2;
		for (auto[x, c] : adds[i]) {
			if (x > nl) {
				if (ns > 0) {
					gsf2[i].push_back(nl);
					gss2[i].push_back(x);
					gsc2[i].push_back(ns);
				}
				nl = x;
			}
			ns += c;
		}
		psgs2[i].push_back(0);
		for (ll j = 0; j < gsf2[i].size(); j++) {
			psgs2[i].push_back(psgs2[i].back() + (gss2[i][j] - gsf2[i][j]) * gsc2[i][j]);
		}
	}
	for (auto& i : psb) {
		ll nps = 0;
		ll nsps = 0;
		for (auto& j : i) {
			nps += j;
			nsps += nps;
			j = nsps;
		}
	}
	for (ll j = 0; j <= n; j++) {
		for (ll i = 1; i < psb.size(); i++) {
			psb[i][j] += psb[i - 1][j];
		}
	}
}

long long query(ll l, ll r) {
	r++;
	ll sr = r;
	long long ans = 0;
	while (l < r && (l & K2M1) != 0) {
		ll st = l;
		ll fnf = lower_bound(gsf[st].begin(), gsf[st].end(), sr) - gsf[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs[st][fnf] + min(sr, gss[st][fnf]) - gsf[st][fnf];
		}
		l++;
	}
	while (r > l && (r & K2M1) != 0) {
		ll st = r - 1;
		ll fnf = lower_bound(gsf[st].begin(), gsf[st].end(), sr) - gsf[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs[st][fnf] + min(sr, gss[st][fnf]) - gsf[st][fnf];
		}
		r--;
	}
	while (l < r && (l & KM1) != 0) {
		ll st = l >> LK2;
		ll fnf = lower_bound(gsf2[st].begin(), gsf2[st].end(), sr) - gsf2[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs2[st][fnf] + (min(sr, gss2[st][fnf]) - gsf2[st][fnf]) * gsc2[st][fnf];
		}
		l += K2;
	}
	while (r > l && (r & KM1) != 0) {
		ll st = (r - 1) >> LK2;
		ll fnf = lower_bound(gsf2[st].begin(), gsf2[st].end(), sr) - gsf2[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs2[st][fnf] + (min(sr, gss2[st][fnf]) - gsf2[st][fnf]) * gsc2[st][fnf];
		}
		r -= K2;
	}
	if ((r >> LK) != 0) {
		ans += psb[(r >> LK) - 1][sr - 1] - ((l >> LK) == 0 ? 0 : psb[l >> LK][sr - 1]);
	}
	return ans;
}

#ifdef LOCAL
int main(){
        std::ios_base::sync_with_stdio(false);
        std::cin.tie(nullptr); std::cout.tie(nullptr);
        int n, q; std::cin >> n >> q;
        std::vector<int> input(n);
        for(int i = 0; i < n; i ++){
                std::cin >> input[i];
        }
        init(n, q, input);
        for(int i = 0; i < q; i ++){
                int l, r;
                std::cin >> l >> r;
                std::cout << query(l, r) << " ";
        }
        std::cout << std::endl;
}
#endif
