#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    int cell = k;
    for(int i = 0;i < n;++i)
    {
        vector<int> cells;
        for(int j = cell;j >= 0;--j)
        {
            if(blocked[i][j])
                break;
            if((i+1 == n) || !blocked[i+1][j])
                cells.push_back(j);
        } 
        reverse(cells.begin(),cells.end());
        for(int j = cell+1;j < m;++j)
        {
            if(blocked[i][j])
                break;
            if((i+1 == n) || !blocked[i+1][j])
                cells.push_back(j);
        } 
    //    cout << cells.size() << endl;
        int l = 0,r = cells.size()-1;
        //cout << ind << endl;
        while(l < r)
        {
            int mb = (l+r)/2;
            if(cells[mb] > cell)
                mb = (l+r+1)/2;
            else if(cells[mb] == cell)
            {
                mb = (l+r)/2 + 1;
            }
            if(investigate(cells[mb]))
            {
                if(cells[mb] > cell)
                    l = mb;
                else
                    r = mb;
            }
            else
            {
                if(cells[mb] > cell)
                    r = mb-1;
                else
                    l = mb+1;
            }
        }
        goDeeper(cells[l]);
        cell = cells[l];
    }
}