#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

const int maxn = 405;

pair<int,int> dp[maxn][maxn][maxn];
pair<int,int> lr[maxn][maxn];
int nex[maxn][maxn];

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    dp[n][0][m-1] = {0,-1};
    for(int j = 0;j < m;++j)
    {
        lr[n][j] = {0,m-1};
    }
    for(int j = n-1;j >= 0;--j)
    {
        for(int i = 0;i < m;++i)
        {
            if(blocked[j][i] || (j+1 < n && blocked[j+1][i]) || dp[j+1][lr[j+1][i].first][lr[j+1][i].second].first == -1)
            {
                dp[j][i][i] = {-1,-1};
            }
            else
            {
                dp[j][i][i] = {dp[j+1][lr[j+1][i].first][lr[j+1][i].second].first,-i-1};
            }
        }
        for(int i = m-1;i >= 0;--i)
        {
            int last_max = i;
            int c_good = 0;
            for(int l = i;l < m;++l)
            {
                if(dp[j][l][l].first != -1)
                {
                    c_good++;
                }
                if(c_good == 0)
                    dp[j][i][l] = {-1,-1};
                else if(c_good == 1)
                {
                    dp[j][i][l] = ((dp[j][l][l].first != -1) ? dp[j][l][l] : dp[j][i][l-1]);
                    last_max = l; 
                }
                else
                {
                    while(last_max+1 < l && dp[j][i][last_max+1].first <= dp[j][last_max+2][l].first)
                        last_max++;
                    int ans = max(dp[j][i][last_max].first,dp[j][last_max+1][l].first)+1;
                    int ans2 = (last_max == l-1 ? 1e9 : max(dp[j][i][last_max+1].first,dp[j][last_max+2][l].first)+1);
                    //dp[j][i][l] = {max(dp[j][i][last_max].first,dp[j][last_max+1][l].first)+1,last_max};
                    //if(j == 3 && i == 0)
                    //    cout << last_max << ' ' << ans << ' ' << ans2 << endl;
                    if(ans <= ans2)
                        dp[j][i][l] = {ans,last_max};
                    else
                        dp[j][i][l] = {ans2,last_max+1};
                }
            }
        }
        int last = -1;
        for(int i = m-1;i >= 0;--i)
        {
            nex[j][i] = last;
            if(dp[j][i][i].first != -1)
                last = i;
        }
        for(int i = 0;i < m;++i)
        {
            lr[j][i].first = (blocked[j][i] ? i+1 : (i == 0 ? 0 : lr[j][i-1].first));
        }
        for(int i = m-1;i >= 0;--i)
        {
            lr[j][i].second = (blocked[j][i] ? i-1 : (i == m-1 ? m-1 : lr[j][i+1].second));
        }
    }
    int cell = k;
    for(int i = 0;i < n;++i)
    {
        int l = lr[i][cell].first,r = lr[i][cell].second;
        while(dp[i][l][r].second >= 0)
        {
            int pos = dp[i][l][r].second;
            bool ans = 0;
            if(pos < cell)
                ans = investigate(pos);
            else if(pos >= cell)
                ans = !investigate(nex[i][pos]);
            if(ans)
                r = pos;
            else
                l = pos+1;
        }
        goDeeper(-dp[i][l][r].second-1);
        cell = -dp[i][l][r].second-1;
    }
}