#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 5000 + 2;
const ll llinf = 1e18 + 1000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool used[N][N];
bool investigate(int s);
bool goDeeper(int s);
//vector<vector<bool>> b = { {1, 1, 1, 1 }, {1, 1, 1, 1 }, {1, 1, 1, 1 } };
//int cur = 0, cnt = 0;
//bool investigate(int s) {
//    ++cnt;
//    return b[cur][s];
//}
//bool goDeeper(int s) {
//    cout << s << '\n';
//    ++cur;
//    return true;
//}
int getmx(int cnt) {
    int s = 1;
    for (int ans = 0; 1; ++ans) {
        if (s >= cnt) return ans;
        s *= 2;
    }
}

void solve(int n, int m, int pos, const vector<vector<bool>>& a) {
    for (int i = 0; i < m; ++i) {
        used[n][i] = true;
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (!a[i][j] && used[i + 1][j]) used[i][j] = true;
        }
        for (int j = 1; j < m; ++j) {
            if(!a[i][j]) used[i][j] |= used[i][j - 1];
        }
        for (int j = m - 2; j >= 0; --j) {
            if(!a[i][j]) used[i][j] |= used[i][j + 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        vector<int> gol, gor;
        for (int j = pos - 1; j >= 0; --j) {
            if (a[i][j]) break;
            if (used[i + 1][j]) gol.push_back(j);
        }
        for (int j = pos + 1; j < m; ++j) {
            if (a[i][j]) break;
            if(used[i + 1][j]) gor.push_back(j);
        }
        if (gol.size() == 0 && gor.size() == 0) {
            goDeeper(pos);
            continue;
        }
        int add = used[i + 1][pos];
        int get0 = min(getmx(gor.size() + add) + getmx(gol.size() - 1) + 1, getmx(gor.size()) + getmx(gol.size() + add - 1) + 1);
        int get1 = min(getmx(gol.size() + add) + getmx(gor.size() - 1) + 1, getmx(gol.size()) + getmx(gor.size() + add - 1) + 1);
        if (get1 <= get0) {
            swap(gol, gor);
        }
        if (add) {
            if (getmx(gor.size() + add) + getmx(gol.size() - 1) + 1 > getmx(gor.size()) + getmx(gol.size() + add - 1) + 1) {
                reverse(all(gor));
                gor.push_back(pos);
                reverse(all(gor));
            }
            else {
                reverse(all(gol));
                gol.push_back(pos);
                reverse(all(gol));
            }
        }
        if (!gol.empty() && (gor.empty() || investigate(gol[0]))) {
            int l = 0, r = gol.size();
            while (r - l > 1) {
                int x = (l + r) >> 1;
                if (investigate(gol[x])) l = x;
                else
                    r = x;
            }
            pos = gol[l];
            goDeeper(pos);
        }
        else {
            int l = 0, r = gol.size();
            while (r - l > 1) {
                int x = (l + r) >> 1;
                if (investigate(gol[x])) l = x;
                else
                    r = x;
            }
            if (l != -1) pos = gol[l];
            goDeeper(pos);
        }
    }
}

//void solve() {
//    solve(3, 4, 0, { {0, 0, 0, 0 }, {0, 0, 0, 0 }, {0, 0, 0, 0 } });
//    cout << cnt;
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}