#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 5000 + 2;
const ll llinf = 1e18 + 1000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool used[N][N];
bool investigate(int s);
bool goDeeper(int s);
//vector<vector<bool>> b = { {0, 1, 1, 1, 1, 1, 1, 1 }, {0, 1, 1, 1, 1, 1, 1, 1 }, {1, 1, 1, 1, 1, 1, 1, 1} };
//int cur = 0, cnt = 0;
//bool investigate(int s) {
//    ++cnt;
//    return b[cur][s];
//}
//bool goDeeper(int s) {
//    cout << s << '\n';
//    ++cur;
//    return true;
//}

void solve(int n, int m, int pos, const vector<vector<bool>>& a) {
    for (int i = 0; i < m; ++i) {
        used[n][i] = true;
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (!a[i][j] && used[i + 1][j]) used[i][j] = true;
        }
        for (int j = 1; j < m; ++j) {
            if(!a[i][j]) used[i][j] |= used[i][j - 1];
        }
        for (int j = m - 2; j >= 0; --j) {
            if(!a[i][j]) used[i][j] |= used[i][j + 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        vector<int> go, gor;
        for (int j = pos - 1; j >= 0; --j) {
            if (a[i][j]) break;
            if (used[i + 1][j]) go.push_back(j);
        }
        for (int j = pos; j < m; ++j) {
            if (a[i][j]) break;
            if(used[i + 1][j]) gor.push_back(j);
        }
        reverse(all(go));
        for (auto j : gor) go.push_back(j);
        int l = 0, r = go.size() - 1;
        while (l < r) {
            int x = (l + r) >> 1;
            if (pos > go[x]) {
                if (investigate(go[x])) r = x;
                else
                    l = x + 1;
            }
            else {
                if (investigate(go[x + 1])) l = x + 1;
                else
                    r = x;
            }
        }
        pos = go[l];
        goDeeper(pos);
    }
}

//void solve() {
//    solve(3, 8, 7, { {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0} });
//    cout << cnt;
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}