#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "bits_and_tree.h"

using namespace std;
using ll = long long;
using ld = long double;

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//
//}

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
	mt19937 real_rnd(0x05082009);
	auto a = data;
	/*for (auto i : a)
	{
		if (real_rnd() % 2 == 0)
		{
			i = !i;
		}
	}*/
	a.resize(n - 30);
	a.push_back(0);
	vector <pair<int, int>> ans;
	int lst_vertex = 0;
	auto create_vertex = [&]()
	{
		return lst_vertex++;
	};
	auto add_leaf = [&](int v)
	{
		int x = create_vertex();
		ans.emplace_back(x, v);
		return x;
	};
	auto add_leafs = [&](int v, int c)
	{
		for (size_t i = 0; i < c; i++)
		{
			add_leaf(v);
		}
	};
	int root = create_vertex();
	add_leafs(root, 6);
	int msg = add_leaf(root);
	vector <bool> hsh;
	int c = 0;
	while (c < a.size())
	{
		if (!a[c])
		{
			c++;
			msg = add_leaf(msg);
			hsh.push_back(0);
			continue;
		}
		int tmp = msg, s = 0;
		while (a[c])
			tmp = add_leaf(tmp), s ^= 1, c++;
		hsh.push_back(s);
		msg = add_leaf(msg);
		c++;
	}
	add_leafs(msg, 3);
	msg = add_leaf(msg);
	vector<bool> ht(8);
	for (size_t i = 0; i < 8; i++)
	{
		int s = 0;
		for (size_t j = 0; j < hsh.size(); j++)
		{
			if ((j >> i) & 1)
			{
				s ^= (int)hsh[j];
			}
		}
		ht[i] = s;
	}
	int s2 = 0;
	for (auto i : hsh)
		s2 ^= i;
	ht.push_back(s2);
	ht.push_back(0);
	c = 0;
	while (c < ht.size())
	{
		if (!ht[c])
		{
			c++;
			msg = add_leaf(msg);
			continue;
		}
		int tmp = msg;
		while (ht[c])
			tmp = add_leaf(tmp), c++;
		msg = add_leaf(msg);
		c++;
	}
	add_leafs(msg, 3);
	msg = add_leaf(msg);
	int t = n - lst_vertex;
	for (size_t i = 0; i < t; i++)
	{
		msg = add_leaf(msg);
	}
	//ans.pop_back();
	return ans;
}

vector <vector<int>> gr;
bool known_error;
int ans = -1;
void dfs_dist(int v, int p, int d, int s)
{
	if (v == s)
		ans = d;
	for (auto& i : gr[v])
	{
		if (i == p)
			continue;
		dfs_dist(i, v, d + 1, s);
	}
}

int dist(int a, int b)
{
	dfs_dist(a, a, 0, b);
	return ans;
}

vector <int> p;

void dfs_p(int v)
{
	for (auto& i : gr[v])
	{
		if (i == p[v])
			continue;
		p[i] = v;
		dfs_p(i);
	}
}

vector<int> find_message(int a, int b)
{
	p.assign(gr.size(), b);
	dfs_p(b);
	int d = a;
	a = p[a];
	vector <int> ans;
	while (a != b)
	{
		ans.push_back(0);
		/*if (gr[a].size() == 2)
		{
			continue;
		}*/
		if (gr[a].size() > 3)
		{
			known_error = true;
		}
		int k = -1;
		for (auto& i : gr[a])
		{
			if (i == d || i == p[a])
				continue;
			if (k == -1 || gr[k].size() < gr[i].size())
				k = i;
		}
		while (k != -1)
		{
			if (gr[k].size() > 2)
				known_error = true;
			int k2 = -1;
			ans.back()++;
			for (auto& i : gr[k])
			{
				if (i == p[k])
					continue;
				if (k2 == -1 || gr[k2].size() < gr[i].size())
					k2 = i;
			}
			k = k2;
		}
		d = a;
		a = p[a];
	}
	return ans;
}

vector <bool> read_message(vector <int> msg)
{
	vector <bool> tmp;
	for (auto& i : msg)
	{
		for (size_t j = 0; j < i; j++)
		{
			tmp.push_back(1);
		}
		tmp.push_back(0);
	}
	return tmp;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
	n++;
	gr.clear();
	gr.resize(n);
	for (auto& i : tree)
	{
		gr[i.first].push_back(i.second);
		gr[i.second].push_back(i.first);
	}
	known_error = false;
	int root = -1, aq = -1, bq = -1;
	for (size_t i = 0; i < n; i++)
	{
		if (gr[i].size() >= 7)
			root = i;
		else if (gr[i].size() >= 5 && aq == -1)
			aq = i;
		else if (gr[i].size() >= 5)
			bq = i;
	}
	if (dist(root, aq) > dist(root, bq))
		swap(aq, bq);
	vector <int> s = find_message(root, aq);
	vector <bool> ht = read_message(find_message(aq, bq));
	if (ht.size() != 10)
		known_error = true;
	int s2 = 0;
	for (auto& i : s)
	{
		s2 ^= (i & 1);
	}
	if (!known_error && s2 == ht[8])
		known_error = true;
	if (!known_error)
	{
		// fix using ht;
		int ql = 0, qr = 256;
		for (int i = 8 - 1; i >= 0; i--)
		{
			int cur = 0;
			for (size_t j = 0; j < s.size(); j++)
			{
				if ((j >> i) & 1)
				{
					cur ^= (s[j] & 1);
				}
			}
			if (cur != ht[i])
			{
				ql = (ql + qr) >> 1;
			}
			else
			{
				qr = (ql + qr) >> 1;
			}
		}
		s[ql]--;
	}
	vector<bool> a = read_message(s);
	/*mt19937 real_rnd(0x05082009);
	for (auto i : a)
	{
		if (real_rnd() % 2 == 0)
		{
			i = !i;
		}
	}*/
	return a;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
