#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using ll = long long;
using ld = long double;

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL);
//
//}

const int MAXN = (1 << 19), SIZE = 2 * MAXN + 1;
vector <int> st[SIZE];
vector <pair<int, int>> res;
vector <vector <int>> cont;
int sl, sr, ql, qr, qt;
void segment(int v, int l, int r)
{
	if (qr <= l || r <= ql)
		return;
	if (ql <= l && r <= qr)
	{
		if (sl >= sr)
			return;
		for (auto& i : st[v])
		{
			int j = lower_bound(cont[i].begin(), cont[i].end(), qt) - cont[i].begin();
			int j2 = j + i - 1;
			if (cont[i].size() <= j2)
			{
				sl = 1e9;
				return;
			}
			if (cont[i].size() > j2 + 1)
				sr = min(sr, cont[i][j2 + 1]);
			sl = max(sl, cont[i][j2]);
		}
		return;
	}
	segment(2 * v + 1, l, (l + r) >> 1);
	segment(2 * v + 2, (l + r) >> 1, r);
}
void build(int v, int l, int r)
{
	if (r - l == 1)
		return;
	build(2 * v + 1, l, (l + r) >> 1);
	build(2 * v + 2, (l + r) >> 1, r);
	merge(st[2 * v + 1].begin(), st[2 * v + 1].end(), st[2 * v + 2].begin(), st[2 * v + 2].end(), back_inserter(st[v]));
	st[v].resize(unique(st[v].begin(), st[v].end()) - st[v].begin());
}
void init(int N, int Q, const std::vector<int>& a)
{
	res.clear();
	cont.clear();
	cont.resize(N + 1);
	for (size_t i = 0; i < N; i++)
	{
		cont[a[i]].push_back(i);
		st[MAXN - 1 + i].push_back(a[i]);
	}
	build(0, 0, MAXN);
	for (size_t i = 0; i < N; i++)
	{
		qt = i;
		sl = i;
		sr = N;
		ql = i;
		qr = i;
		while (sl < sr)
		{
			while (sl >= qr && sl < sr)
			{
				ql = qr;
				qr = sl + 1;
				segment(0, 0, MAXN);
			}
			if (sl < sr)
				res.emplace_back(i, sl);
			sl++;
		}
	}
}

long long query(int l, int r)
{
	int c = 0;
	for (auto& i : res)
	{
		if (l <= i.first && i.second <= r)
		{
			c++;
		}
	}
	return c;
	//return res.size();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
