#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<bool>> blck = blocked;
    for (int i = n - 2; i >= 0; i--) {
        vector<int> stck;
        bool f = false;
        for (int j = 0; j < m; j++) {
            if (blck[i][j]) {
                f = false;
                for (auto &x : stck) {
                    blck[i][x] = true;
                }
                continue;
            }
            if (f) {
                continue;
            }
            if (!blck[i + 1][j]) {
                stck.clear();
                f = true;
            } else {
                stck.push_back(j);
            }
        }
    }
    int x = k;
    for (int i = 0; i < n; i++) {
        int l = x;
        for (; l > 0 && !blck[i][l - 1]; l--);
        int r = x;
        for (; r < m - 1 && !blck[i][r + 1]; r++);
        int curx = -1;
        vector<int> tmp;
        for (int j = l; j <= r; j++) {
            if (i == n - 1 || !blck[i + 1][j]) {
                if (j == x) curx = tmp.size();
                tmp.push_back(j);
            }
        }
        l = 0;
        r = tmp.size() - 1;
        while (r - l > 0) {
            int m = (l + r + 1) / 2;
            if (m == curx) {
                if (m == l) m++;
                else m--;
            }
            if (investigate(tmp[m])) {
                if (m < x) {
                    r = m;
                } else {
                    l = m;
                }
            } else {
                if (m < x) {
                    l = m + 1;
                } else {
                    r = m - 1;
                }
            }
        }
        goDeeper(tmp[l]);
        x = tmp[l];
    }
}