#include <bits/stdc++.h>
#include <cassert>
using namespace std;
using ll = long long;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

vector<int> xr = {0, 1, 2, 4, 5, 8, 14, 16, 19, 20, 23, 24, 27, 28, 30, 37, 38, 42, 46, 50, 54, 55, 56, 57, 58, 59, 60, 62, 64, 65, 68, 73, 77, 78, 81, 82, 84, 85, 88, 89, 90, 91, 92, 93, 95, 96, 97, 101, 102, 104, 105, 107, 108, 110, 111, 114, 115, 117, 118, 121, 123, 127, 128, 130, 131, 132, 134, 137, 138, 139, 140, 142, 143, 144, 149, 151, 156, 157, 160, 161, 162, 167, 168, 169, 172, 174, 175, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 190, 191, 192, 194, 196, 197, 201, 202, 205, 207, 210, 211, 213, 214, 216, 217, 218, 219, 224, 225, 227, 230, 232, 233, 235, 236, 237, 245, 246, 248, 249, 250, 252, 253, 256, 260, 261, 262, 263, 265, 267, 268, 269, 272, 276, 279, 280, 281, 282, 284, 286, 287, 288, 292, 295, 299, 300, 302, 303, 307, 308, 310, 312, 314, 316, 318, 319, 320, 321, 323, 325, 326, 328, 330, 331, 332, 333, 334, 335, 336, 338, 341, 346, 348, 349, 350, 351, 358, 367, 370, 372, 375, 376, 380, 382, 383, 385, 387, 389, 391, 392, 394, 396, 397, 398, 399};

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
    for (int u : xr) if (u < sz(data)) data[u] = !data[u];
    vector<vector<int>> g(n);
    vector<int> used(n, 0);
    int jtake = 6;
    for (int i = n - jtake; i < n; i++) {
        used[i] = 1;
        g[0].pb(i);
    }
    g[0].pb(1);
    used[0] = 1;
    int pr = 0;
    auto dfs = [&](int v, int siz, auto&&self) -> void {
        used[v] = 1;
        vector<int> free;
        for (int i = 0; i < n; i++) if (!used[i]) free.pb(i);
        if (data[pr]) {
            if (siz == 3) {
                g[v].pb(free[0]); g[v].pb(free[1]);
                used[free[0]] = used[free[1]] = 1;
                return;
            } else {
                g[v].pb(free[0]); g[v].pb(free[1]);
                used[free[1]] = 1;
                pr++;
                self(free[0], siz - 2, self);
            }
        } else {
            if (siz >= 7) {
                g[v].pb(free[0]); g[v].pb(free[1]);
                used[free[0]] = used[free[1]] = 1;
                int mn = 1e9;
                for (int x = siz - 1; x >= 1; x--) {
                    if (x > siz - 1 - x && x % 2 == 1) mn = x;
                }
                if (siz == 7) {
                    mn = 3;
                }
                assert(min(mn, siz - 1 - mn) >= 3);
                pr++;
                self(free[0], mn, self);
                self(free[1], siz - 1 - mn, self);
            } else {
                for (int j = 0; j < siz - 1; j++) {
                    g[v].pb(free[j]); used[free[j]] = 1;
                }
            }
        }
    };
    dfs(1, n - jtake - 1, dfs);
    vector<pair<int, int>> E;
    for (int i = 0; i < n; i++) {
        for (int u : g[i]) E.pb({i, u});
    }
    //cout << "YES" << endl;
    return E;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
    n++;
    vector<int> deg(n);
    for (auto u : tree) {
        deg[u.first]++; deg[u.second]++;
    }
    int vt = -1;
    for (int i = 0; i < n; i++) {
        if (deg[i] % 2 == 0) {
            assert(vt == -1);
            vt = i;
        }
    }
    bool er = false;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        if (tree[i].first == vt || tree[i].second == vt) {
            if (er) {
                g[tree[i].first].pb(tree[i].second);
                g[tree[i].second].pb(tree[i].first);
            }
            er = 1;
        }
        else {
            g[tree[i].first].pb(tree[i].second);
            g[tree[i].second].pb(tree[i].first);
        }
    }
    // for(int i = 0; i < n; i++) {
    //     for (int u : g[i]) cout << i << ' ' << u << '\n';
    // }
   // return {};
    // cout << "YES" << endl;
    // return {};
    int mdeg = 0;
    for (int i = 1; i < n; i++) {
        if (sz(g[i]) > sz(g[mdeg])) mdeg = i;
    }
    vector<int> sub(n);
    vector<bool> answ;
    auto dfs_siz = [&](int v, int p, auto&&self) -> void {
        sub[v] = 1;
        for (int u : g[v]) {
            if (u != p) {
                self(u, v, self); sub[v] += sub[u];
            }
        }
    };
    dfs_siz(mdeg, mdeg, dfs_siz);

    auto dfs = [&](int v, int p, auto&&self) -> void {
        if (sub[v] == 1) return;
        sort(all(g[v]), [&](int u1, int u2){
            return sub[u1] > sub[u2];
        });
        bool son_l = false, son_nl = false;
        for (int u : g[v]) {
            if (u != p) {
                if (sub[u] == 1) son_l = 1;
                if (sub[u] > 1) son_nl = 1;
            }
        }
        if (v != mdeg && son_nl) answ.pb(son_l);
        for (int u : g[v]) {
            if (u != p) {
                self(u, v, self);
            }
        }
    };
    dfs(mdeg, mdeg, dfs);
    for (auto u : xr) if (u < sz(answ)) answ[u] = !answ[u];
    // for (auto u : answ) cout << u;
    // cout << endl;
    return answ;
}