#include <bits/stdc++.h>
#include <cassert>
using namespace std;
using ll = long long;

vector<pair<int, int>> segs;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

void init(int N, int Q, const vector<int> &a) {
    for (int i = 0; i < N; i++) {
        vector<int> cnt(N + 1, 0);
        int wrong = 0;
        for (int j = i; j < N; j++) {
            cnt[a[j]]++;
            if (cnt[a[j]] > 1 && cnt[a[j]] == a[j]) wrong--;
            if (cnt[a[j]] != a[j] && (cnt[a[j]] == 1 || cnt[a[j]] == a[j] + 1)) wrong++;
            if (!wrong) segs.pb({i, j});
        }
    }
    assert(segs.size() <= 5 * N);
}

ll query(int l, int r) {
    int cnt = 0;
    for (int i = 0; i < sz(segs); i++) {
        cnt += (segs[i].first >= l && segs[i].second <= r);
    }
    return cnt;
}