#include <bits/stdc++.h>
#define MAXN 300001

using namespace std;

vector<int>v;

int tree[4*MAXN], cnt[MAXN];
int ql, qr, num, qu;


void build_tree(int curr, int l, int r)
{
    if(l==r)
    {
        if(v[l]==1)tree[curr]=1;
        else tree[curr]=0;
        //cout<<"l= "<<l<<" r= "<<r<<"-> "<<tree[l]<<endl;
        return;
    }
    int mid=(l+r)/2;
    build_tree(2*curr, l, mid);
    build_tree(2*curr+1, mid+1, r);
    tree[curr]=tree[2*curr]+tree[2*curr+1];
    //cout<<"l= "<<l<<" r= "<<r<<"-> "<<tree[l]<<endl;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

long long ownquery(int curr, int l, int r)
{

    if(l>qr||r<ql)return 0;
    if(l>=ql&&r<=qr)
    {
        //cout<<"1 using curr= "<<curr<<" l="<<l<<" r="<<r<<" -> "<<tree[curr]<<endl;
        return tree[curr];
    }
    int mid=(l+r)/2;
    long long ne=ownquery(2*curr, l, mid)+ownquery(2*curr+1, mid+1, r);
    //cout<<"2 using l="<<l<<" r="<<r<<" -> "<<tree[curr]<<endl;
    return ne;
}

long long query(int l, int r)
{
    ql=l;
    qr=r;
    return ownquery(1, 0, num-1);
}

void init(int N, int Q, const vector<int>&a)
{
    speed();
    v=a;
    num=N;
    qu=Q;
    build_tree(1, 0, N-1);
}
