# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "tunnels.h"
//# include "Lgrader.cpp"

const int MAX=5e3+11;

bool B[MAX][MAX];

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++) B[i][j]=blocked[i][j];
    }

    for(int j=0;j<m;j++)
    {
        if(!B[0][j])
        {
            goDeeper(j);
            break;
        }
    }

    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            if(B[i][j]) continue;
            if(investigate(j))
            {
                goDeeper(j);
                break;
            }
        }
    }
}
