# include <iostream>
# include <vector>
# include <algorithm>
# include <cmath>
# include <deque>
# include <set>
using namespace std;

const int MAX=3e5+11;

int _N;
int A[MAX];
deque<int> pos[MAX];

void init(int N, int Q, const std::vector<int>& a)
{
    _N=N;
    for(int i=1;i<=N;i++)
    {
        A[i]=a[i-1];
        pos[A[i]].push_back(i);
    }
}

int cnt[MAX];

long long query(int l, int r)
{
    l++;r++;

    int sz=(r-l+1);
    int S=(int)sqrt(sz)*2+1;

    set<pair<int,int>> s;
    for(int i=1;i<=_N;i++)
    {
        if((int)pos[i].size()>0) s.insert({pos[i][0],i});
    }

    int ans=0;
    for(int i=l;i<=r;i++)
    {
        auto it=s.begin();
        int cnt=0,mx=0;
        for(int t=1;t<=S;t++)
        {
            if(it==s.end()) break;
            pair<int,int> pa=*it;

            if((int)pos[pa.second].size()<pa.second) break;
            int P=pos[pa.second][pa.second-1];
            mx=max(mx,P);
            cnt+=pa.second;

            //cout<<"->"<<i<<" "<<cnt<<" "<<mx<<"\n";

            if(cnt==mx-i+1)
            {
                ans++;
                //cout<<i<<" "<<cnt<<" "<<mx<<"\n";
            }

            it++;
        }

        s.erase({i,A[i]});
        pos[A[i]].pop_front();
        if((int)pos[A[i]].size()>0) s.insert({pos[A[i]][0],A[i]});

        //cout<<i<<"->"<<ans<<"\n";
    }

    return ans;
}

