# include <bits/stdc++.h>
# include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int level = 0; level < n; level++)
    {
        vector<int> possible;

        for(int i = k; i >= 0; i--)
        {
            if(!blocked[level][i])
            {
                if(level == n - 1 || !blocked[level + 1][i])
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        for(int i = k + 1; i < m; i++)
        {
            if(!blocked[level][i])
            {
                if(level == n - 1 || blocked[level + 1][i])
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        random_shuffle(possible.begin(), possible.end());

        int left = (int)possible.size();

        for(auto& i : possible)
        {
            if(left == 1 || investigate(i))
            {
                goDeeper(i);
                k = i;
                break;
            }

            left--;
        }
    }
}

/*
5 2 0
0 0
0 0
0 0
0 0
0 0
*/
