# include <bits/stdc++.h>
# include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int i = 0; i < n; i++)
    {
        bool flag = true;

        if(k == m - 1)
        {
            flag = false;
        }
        else if(k == 0)
        {
            flag = true;
        }
        else if(investigate(k - 1))
        {
            flag = false;
        }
        else
        {
            flag = true;
        }

        if(flag)
        {
            int l = k + 1, r = m - 1;
            int mid;
            int answer = k;

            while(l <= r)
            {
                mid = (l + r) / 2;

                if(investigate(mid))
                {
                    answer = mid;
                    l = mid + 1;
                }
                else
                {
                    r = mid - 1;
                }
            }

            k = answer;
        }
        else
        {
            int l = 0, r = k - 2;
            int mid;
            int answer = k - 1;

            while(l <= r)
            {
                mid = (l + r) / 2;

                if(investigate(mid))
                {
                    answer = mid;
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            k = answer;
        }

        goDeeper(k);
    }
}

/*
5 2 0
0 0
0 0
0 0
0 0
0 0
*/
