#include "tunnels.h"
#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

const int MAXN = 5e3 + 10;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    if(m != 2)
        return;

    int cur = k;

    for(int level = 0; level < n; level++)
    {
        //cout << "Currently on level : " << level << " in chamber " << cur << endl;
        if(blocked[level][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(level == n - 1)
        {
            goDeeper(cur);
            continue;
        }
        
        if(blocked[level + 1][cur])
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }

        if(blocked[level + 1][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(investigate(!cur))
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }
        else
        {
            goDeeper(cur);
            continue;
        }
    }
}