#include<iostream>
#include<vector>
#include<unordered_map>

using namespace std;

typedef long long ll;

const int MAXN = 3e5 + 10;
const int MAXQ = 5e5 + 10;

int a[MAXN];
int cnt[MAXN];
int n, q;
int cur;

void init(int N, int Q, vector < int > v)
{
    n = N;
    q = Q;

    for(int i = 0; i < n; i++)
    {
        a[i] = v[i];
    }
}

long long query(int l, int r)
{
    //cout << "Query : " << ++cur << endl;

    ll ans = 0;

    for(int left = l; left <= r; left++)
    {
        //cout << "From : " << left << endl;
        for(int i = 1; i <= n; i++)
        {
            cnt[i] = 0;
        }

        int wrong = 0;

        for(int right = left; right <= r; right++)
        {
            //cout << "To : " << right << endl;
            cnt[a[right]]++;

            if(cnt[a[right]] == a[right] && a[right] != 1)
                wrong--;
            else if(cnt[a[right]] != a[right] && (cnt[a[right]] - 1 == 0 || cnt[a[right]] - 1== a[right]))
                wrong++;

            //cout << "Is good : " << (bool)(wrong == 0) << endl;

            ans += (bool)(wrong == 0);
        }
        //cout << endl;
    }

    return ans;
}