#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "tunnels.h"
using namespace std;

vector<vector<bool>> poss, bl, vis;
int N, M;

bool setPoss(int curY, int curX) {
    if (curY == N) {
        poss[curY][curX] = 1;
        return 1;
    }
    if (curX < 0 || curX >= M) { return false; }
    if (bl[curY][curX]) { return false; }
    if (vis[curY][curX]) { return poss[curY][curX]; }
    vis[curY][curX] = 1;
    if (setPoss(curY, curX - 1)) {
        poss[curY][curX] = 1;
    }
    if (setPoss(curY, curX + 1)) {
        poss[curY][curX] = 1;
    }
    if (setPoss(curY + 1, curX)) {
        poss[curY][curX] = 1;
    }
    return poss[curY][curX];
}

void a(int curY, int curX) {
    if (curY == N) { return; }
    vector<int> lvlPoss, possL, possR;
    for (int x = curX - 1; x >= 0; x--) {
        if (bl[curY][x]) { break; }
        if (poss[curY + 1][x]) {
            possL.push_back(x);
        }
    }
    for (int x = curX + 1; x < M; x++) {
        if (bl[curY][x]) { break; }
        if (poss[curY + 1][x]) {
            possR.push_back(x);
        }
    }

    bool add = false, useR = false;
    if (possL.size() == 0) {
        ///Rabbit went right
        lvlPoss = possR;
        useR = true;
    } else {
        if (possR.size() == 0) {
            lvlPoss = possL;
        } else {
            if (investigate(possL[0])) {
                lvlPoss = possL;
                add = true;
            } else {
                lvlPoss = possR;
                useR = true;
            }
        }
    }
    if (possL.size() == 0 && possR.size() == 0) {
        goDeeper(curX);
        a(curY + 1, curX);
        return;
    }
    if (!poss[curY + 1][curX]) {
        add = 1;
    }

    int l = -1 + add, r = lvlPoss.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
//        cout << "g";
        if (investigate(lvlPoss[m])) {
            l = m;
        } else {
            r = m;
        }
    }
    if (l == -1) {
        goDeeper(curX);
        a(curY + 1, curX);
    } else {
        goDeeper(lvlPoss[l]);
        a(curY + 1, lvlPoss[l]);
    }
}

void solve(int _N, int _M, int K, const vector<vector<bool>>& _BLOCKED) {
    N = _N; M = _M;
    poss.clear();
    vis.clear();
    poss.resize(N + 1);
    vis.resize(N + 1);
    for (int i = 0; i < N + 1; i++) {
        poss[i].resize(M);
        vis[i].resize(M);
    }
    bl.clear();
    bl = _BLOCKED;

    setPoss(0, K);
    a(0, K);
}

