#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;
const int maxn=202;
bool used[2*maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int>>r;
    int bit=0,last=-1;
    while(bit<data.size()&&r.size()<n-1)
    {
        if(!data[bit])
        {
            if(last!=-1)
                r.push_back({last,bit});
            last=bit;
        }
        bit++;
    }

    while(r.size()<n-1)
    {
        bit=(rand())%(2*n);
        while(data[bit]||used[bit])
            bit=(rand())%(2*n);
        used[bit]=true;
        r.push_back({last,bit});
        last=bit;
    }

    return r;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector<bool>s(2*n,true);
    for(pair<int,int>i : tree)
    {
        s[i.first]=false;
        s[i.second]=false;
    }
    return s;
}
