#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& haha) {
    vector<std::vector<int>> dp(0);
    for(int i = 0; i < n; i++) {
        vector<int> wut(m,0);
        dp.push_back(wut);
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(haha[i][j]) {
                dp[i][j] = -1;
            }
            else {
                dp[i][j] = 0;
            }
        }
    }
    for(int i = 0; i < m; i++) {
        if(dp[n-1][i] == 0) {
            dp[n-1][i] = 1;
        }
    }
    for(int i = n-2; i >= 0; i--) {
        for(int j = 0; j < m; j++) {
            if(dp[i][j] == 0 && dp[i+1][j] == 1) {
                dp[i][j] = 1;
            }
            if(j > 0 && dp[i][j-1] == 1 && dp[i][j] != -1) {
                dp[i][j] = 1;
            }
        }
        for(int j = m-2; j >= 0; j--) {
            if(dp[i][j+1] == 1 && dp[i][j] != -1) {
                dp[i][j] = 1;
            }
        }
    }
   /* for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    for(int i = 0; i < n; i++) {
        int y1 = k,y2 = k;
        while(y1 > 0 && dp[i][y1-1] == 1) {
            y1--;
        }
        while(y2 < m-1 && dp[i][y2+1] == 1) {
            y2++;
        }
        vector<int> wut(0);
        for(int j = y1; j <= y2; j++) {
            if(i == n-1 || dp[i+1][j] == 1) {
                wut.push_back(j);
            }
        }
        if(wut.size() == 0) {
            return 1/0;
        }
        int l = 0,r = wut.size()-1;
        while(l < r) {
            int mid = (l+r)/2;
            if(wut[mid] > k && (l+r)%2 == 1) {
                mid++;
            }
            if(wut[mid] == k) {
                if(mid-l > r-mid) {
                    mid--;
                }
                else {
                    mid++;
                }
            }
            if(investigate(wut[mid])) {
                if(wut[mid] < k) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            else {
                if(wut[mid] < k) {
                    l = mid+1;
                }
                else {
                    r = mid-1;
                }
            }
        }
        goDeeper(wut[l]);
        k = wut[l];
    }
}
