#include<iostream>
#include "tunnels.h"
using namespace std;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    int level = 0, tek = k;
    while(level < N){
        int l = -1, r = -1;
        for(int i = tek; i < M; i ++){
            if(blocked[level][i]){
                r = i - 1;
                break;
            }
        }
        for(int i = tek; i >= 0; i --){
            if(blocked[level][i]){
                l = i + 1;
                break;
            }
        }
        if(l == -1){
            l = 0;
        }
        if(r == -1){
            r = M - 1;
        }
        int dvL, dvR;
        if(tek < M - 1 && blocked[level][tek + 1] == false && investigate(tek + 1)){
            dvL = tek;
            dvR = r;
            if(investigate(dvR)){
                goDeeper(dvR);
                level++;
                tek = dvR;
                continue;
            }
            while(dvL < dvR - 1){
                int m = (dvL + dvR)/2;
                if(investigate(m)){
                    dvL = m;
                }else{
                    dvR = m;
                }
            }
            goDeeper(dvL);
            level++;
            tek = dvL;
            continue;
        }else{
            if(tek >= 1 && blocked[level][tek - 1] == false){
                dvR = tek;
                dvL = l;
            }
            if(investigate(dvL)){
                goDeeper(dvL);
                level++;
                tek = dvL;
                continue;
            }
            while(dvL < dvR - 1){
                int m = (dvL + dvR)/2;
                if(investigate(m)){
                    dvR = m;
                }else{
                    dvL = m;
                }
            }
            goDeeper(dvR);
            level++;
            tek = dvR;
            continue;
        }

    }

}
