#include<iostream>
#include "tunnels.h"
using namespace std;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    int level = 0, tek = k;
    while(level < n){
        int l = -1, r = -1;
        for(int i = tek; i < m; i ++){
            if(blocked[level][i]){
                r = i - 1;
                break;
            }
        }
        for(int i = tek; i >= 0; i --){
            if(blocked[level][i]){
                l = i + 1;
                break;
            }
        }
        if(l == -1){
            l = 0;
        }
        if(r == -1){
            r = m - 1;
        }
        if(level <= n - 2){
            while(blocked[level + 1][l]){
                l ++;
            }
            while(blocked[level + 1][r]){
                r --;
            }
        }
        if(r - l == 0){
            goDeeper(tek);
            level++;
            tek = tek;
            continue;
        }
        int dvL, dvR;
        bool f = false;
        int s;
        if(tek < m - 1 && blocked[level][tek + 1] == false){
            dvL = tek;
            dvR = r;
            s = tek + 1;
            f = investigate(s);
        }
            if(f){

                while(dvL < dvR - 1){
                    int m1 = (dvL + dvR)/2;
                    if(m1 == s ? f : investigate(m1)){
                        dvL = m1;
                    }else{
                        dvR = m1;
                    }
                }
                if(dvR == r){
                    if(dvR == s ? f : investigate(dvR)){
                        goDeeper(dvR);
                        level++;
                        tek = dvR;
                        continue;
                    }
                }
                goDeeper(dvL);
                level++;
                tek = dvL;
                continue;
            }else{
            if(tek >= 1 && blocked[level][tek - 1] == false){
                dvR = tek;
                dvL = l;

                while(dvL < dvR - 1){
                    int m1 = (dvL + dvR)/2;
                    if(investigate(m1)){
                        dvR = m1;
                    }else{
                        dvL = m1;
                    }
                }
                if(dvL == l){
                    if(investigate(dvL)){
                        goDeeper(dvL);
                        level++;
                        tek = dvL;
                        continue;
                    }
                }
                goDeeper(dvR);
                level++;
                tek = dvR;
                continue;
            }
            goDeeper(tek);
            level++;
            tek = tek;
            continue;

        }

    }

}
