#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

int N, M;

int goLeft(int from)
{
    int l = 0;
    int r = from - 1;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (investigate(mid) == false)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return l;
}

int goRight(int from)
{
    int l = from + 1;
    int r = M - 1;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (investigate(mid) == false)
        {
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    return r;
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    N = n;
    M = m;

    int cell = k;

    for (int i = 0; i < n - 1; ++i)
    {
        if (blocked[i][1 - cell])
        {
            goDeeper(cell);
        }
        else
        {
            if (blocked[i + 1][cell]) cell = 1 - cell;
            goDeeper(cell);
        }
    }

    if (blocked[n - 1][1 - cell] == false)
    {
        if (investigate(1 - cell)) cell = 1 - cell;
    }

    goDeeper(cell);
}
