#include <bits/stdc++.h>

using namespace std;

const int maxn = 300005;

int n, q;
int a[maxn];
vector<int> positions[maxn];
int cntOcc[maxn];
bool added[maxn];

void init(int N, int Q, const std::vector<int>& arr)
{
    n = N;
    q = Q;

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = arr[i];
    }
}

long long query(int l, int r)
{
    ++l;
    ++r;
    long long ans = 0;

    for (int i = l; i <= r; ++i)
    {
        for (int j = i; j <= r; ++j)
        {
            cntOcc[a[j]] = 0;
            added[a[j]] = false;
        }

        int bad = 0;

        for (int j = i; j <= r; ++j)
        {
            ++cntOcc[a[j]];

            if (!added[a[j]])
            {
                added[a[j]] = true;
                ++bad;
            }

            if (cntOcc[a[j]] > a[j]) break;

            if (cntOcc[a[j]] == a[j])
            {
                --bad;
                if (bad == 0) ++ans;
            }
        }
    }

    return ans;
}