#include <bits/stdc++.h>

using namespace std;

const int maxn = 300005;

int n, q;
int a[maxn];
vector<int> positions[maxn];
int cntOcc[maxn];
bool added[maxn];

void init(int N, int Q, const std::vector<int>& arr)
{
    n = N;
    q = Q;

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = arr[i];
    }
}

long long query(int l, int r)
{
    ++l;
    ++r;
    long long ans = 0;

    for (int i = l; i <= r; ++i)
    {
        for (int j = i; j <= r; ++j)
        {
            cntOcc[a[j]] = 0;
            added[a[j]] = false;
        }

        int bad = 0;
        int expectedSum = 0;

        for (int j = i; j <= r; ++j)
        {
            ++cntOcc[a[j]];

            if (!added[a[j]])
            {
                added[a[j]] = true;
                ++bad;
                expectedSum += a[j];
            }

            if (expectedSum > r - i + 1) break;
            if (cntOcc[a[j]] > a[j]) break;

            if (cntOcc[a[j]] == a[j])
            {
                --bad;
                if (bad == 0) ++ans;
            }
        }
    }

    return ans;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;

    return 0;
}
