#include <bits/stdc++.h>
using namespace std;
//#include "Lgrader.cpp"
#include "tunnels.h"

unordered_map<int, bool> cache;
bool inv(int s){
    if(cache.count(s)){ return cache[s]; }
    bool ret = investigate(s);
    cache.insert({s, ret});
    return ret;
}

void goDeep(int s){
    cache.clear();
    goDeeper(s);
}

void solve(int n, int m, int k, const vector<vector<bool>>& blocked){
    int lvl = 0;
    int pos = k;
    while(lvl < n){
//        cout << "\tNivo " << lvl << '\n';
        int dir = 0;
        if(pos > 0 && inv(pos-1)){
            dir = -1;
        }
        if(dir == 0 && pos < m-1 && inv(pos+1)){
            dir = +1;
        }

//        cout << "\tdir = " << dir << "\n";

        if(dir == 0){
//            cout << "\tgoing strait down (" << pos << ")\n";
            goDeep(pos); lvl++;
            continue;
        }

        bool went = false;
//        cout << "\t, pos: " << pos << '\n';
        while((dir==-1 && pos>0) || (dir==1 && pos<m-1)){
            pos += dir;
//            cout << "\tpos: " << pos << '\n';
            if(!inv(pos)){
//                cout << "\t   gd(" << pos-dir << ")\n";
                goDeep(pos - dir);
                pos = pos-dir;
                lvl++;
                went = true;
                break;
            }
        }
        if(went){ continue; }

//        cout << "\tgd(" << pos << ")\n";
        goDeep(pos);
        lvl++;
    }
}
