#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;

int pos;
void bs(int r, int l, bool dir) {
    //r, l are inclusive
    //dir 1 = right, 0 = left
    //std::cout << "searching " << l << ", " << r << ", " << (dir ? "right" : "left") << std::endl;
    if(r == l) {
        pos = r;
        goDeeper(r);
        return;
    }
    if(r-l == 1) {
        if(dir) {
            if(investigate(r)) {
                pos = r; goDeeper(r);
            } else {
                pos = l; goDeeper(l);
            }
        } else {
            if(investigate(l)) {
                pos = l; goDeeper(l);
            } else {
                pos = r; goDeeper(r);
            }
        }
        return;
    }
    int m = (r + l)/2;

    if(investigate(m)) {
        if(dir) { //check right
            bs(r, m, dir);
        } else {
            bs(l, m, dir);
        }
    } else {
        if(dir) {
            bs(l, m-1, dir);
        } else {
            bs(r, m+1, dir);
        }
    }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    pos = k;
    for(int level = 0; level < n; level++) {
        //find left and right limits
        int r = pos;
        int l = pos;
        bool blocked_left = pos-1 < 0 || blocked[level][pos-1];
        bool blocked_right = pos+1 >= m || blocked[level][pos+1];
        if(blocked_left && blocked_right) {
            goDeeper(pos);
            continue;
        }
        if(blocked_left) {
            if(investigate(pos+1)) {
                l = pos+1;
                while(r+1 < m && !blocked[level][r+1]) r++;
                bs(r, l, 1);
            } else {
                goDeeper(pos);
            }
        } else if(blocked_right) {
            if(investigate(pos-1)) {
                r = pos-1;
                while(l-1 >= 0 && !blocked[level][l-1]) l--;
                bs(r, l, 0);
            } else {
                goDeeper(pos);
            }
        } else {
            if(investigate(pos-1)) {
                r = pos-1;
                while(l-1 >= 0 && !blocked[level][l-1]) l--;
                bs(r, l, 0);
            } else if(investigate(pos+1)) {
                l = pos+1;
                while(r+1 < m && !blocked[level][r+1]) r++;
                bs(r, l, 1);
            } else {
                goDeeper(pos);
            }
        }



    }
}
