#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;

int pos;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    pos = k;
    for(int level = 0; level < n; level++) {
        //cout << "POSITION = " << pos << endl;
        //find left and right limits
        int r = pos;
        int l = pos;
        vector<int> blocks;
        int dir = 0;

        while(r+1 < m && !blocked[level][r+1]) r++;
        while(l-1 >= 0 && !blocked[level][l-1]) l--;
        if(level != n-1) {
            while(blocked[level+1][r]) r--;
            while(blocked[level+1][l]) l++;
        }
        if(r==l) {
            goDeeper(pos);
            continue;
        }
        //cout << "l, r = " << l << ", " << r << endl;

        if(level != n-1) {
            for(int i = l; i <= r; i++) {
                if(blocked[level+1][i]) {
                    blocks.push_back(i);
                }
            }
        }

        if(r != pos) {
            if(investigate(pos+1)) {
                dir = 2;
                l = pos+1;
            }
        }
        if(l != pos) {
            if(dir == 0) {
                if(investigate(pos-1)) {
                    dir = 1;
                    r = pos-1;
                }
            }
        }

        if(dir == 0) {
            goDeeper(pos);
            continue;
        }
        dir--;
        /*vector<int> r_blocks;

        r_blocks.push_back(l-1);
        for(int i= 0; i < blocks.size(); i++) {
            if(blocks[i] > l && blocks[i] < r) r_blocks.push_back(blocks[i]);
        }
        r_blocks.push_back(r+1);
        int r_b = r_blocks.size() - 1;
        int l_b = 0;
        while(r_b - l_b > 1) {
            int m_b = (r_b + l_b)/2;
            if(investigate(r_blocks[m_b])) {
                if(dir) {
                    l_b = m_b;
                } else {
                    r_b = m_b;
                }
            } else {
                if(dir) {
                    r_b = m_b;
                } else {
                    l_b = m_b;
                }
            }
        }

        r = r_blocks[r_b] - 1;
        l = r_blocks[r_b] + 1;
        */
        while(r - l > 1) {
            int mid = (l + 1 + r)/2;
            if(dir) {
                if(investigate(mid)) {
                    l = mid;
                } else {
                    r = mid-1;
                }
            } else {
                if(investigate(mid)) {
                    r = mid;
                } else {
                    l = mid+1;
                }
            }
        }

        if(r == l) {
            pos = r;
            goDeeper(r);
            continue;
        } else {
            if(dir) {
                if(investigate(r)) {
                    pos = r;
                    goDeeper(r);
                } else {
                    pos = l;
                    goDeeper(l);
                }
            } else {
                if(investigate(l)) {
                    pos = l;
                    goDeeper(l);
                } else {
                    pos = r;
                    goDeeper(r);
                }
            }
        }

    }
}
