#include<iostream>
#include<vector>

std::vector <int> v;
int n;
int counts[1000];

void init(int N, int Q, const std::vector<int> &a) {
    v = a;
    n = v.size();
}

bool gut() {
    for (int i = 0; i < n; i++) {
        if (counts[i] != (i-1) && counts[i] != 0) return false;
    }
    return true;
}

long long query(int l, int r) {
    long long ans = 0;
    for (int i = l; i <= r; i++) {
        for (int a = 0; a < n; a++) {
            counts[a] = 0;
        }
        for (int j = i; j <= r; j++) {
            counts[v[j]]++;
            if (gut()) ans++;
        }
    }
    return ans;
}

int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
