#include <iostream>
#include <cstring>
#include <vector>

const int MAXN = (int)1e5 + 5;
int pos[MAXN];
int br[MAXN];
int dp[MAXN];

using namespace std;

void init(int N, int Q, const std::vector<int>& a)
{
    int n = N;
    vector < int > used;

    for(int i = 0 ; i < n ; i++)
    {
        if(i != 0)
            dp[i] = dp[i - 1];

        for(int j = i ; j >= 0 ; j--)
        {
            br[a[j]]++;
            used.push_back(a[j]);

            int lampa = 0;

            for(int k : used)
            {
                if(br[k] == k)
                {
                    lampa++;
                }
            }

            if(lampa == used.size())
                dp[i]++;
        }

        memset(br, 0, sizeof(br));
        used.clear();
    }
}

long long query(int l, int r)
{
    return dp[r];
}

/**
7 1
1 2 1 2 3 3 3
0 3
**/
