#include <bits/stdc++.h>
#define endl "\n"

using namespace std;


const int MAXN = 512;

int n;

int idx,ver[MAXN];
vector<pair<int,int> >sp;
int need[MAXN];

std::vector<std::pair<int, int>> encode(int N, std::vector<bool> data)
{
    n = N;
    sp.clear();
    idx = 0;

    int last = -1;
    int br = 0;
    for(int i = 0; i < data.size(); i++)
    {
        if(data[i]) need[i] = 3;
        else need[i] = 1;
        br += need[i];
        if(br + 12 <= 200) last = i;
    }

    for(int i = 1; i <= last; i++) sp.push_back({i-1,i});

    idx = last;
    for(int i = 0; i <= last; i++)
    {
        if(need[i] == 3)
        {
            idx++;
            sp.push_back({i,idx});
            idx++;
            sp.push_back({i,idx});
        }
    }
    idx++;
    int kr = idx;
    sp.push_back({last,kr});
    for(int i = 1; i <= 4; i++)
    {
        idx++;
        sp.push_back({kr,idx});
    }

    idx++;
    int nach = idx;
    sp.push_back({nach,0});
    while(idx+1 < n)
    {
        idx++;
        sp.push_back({nach,idx});
    }

    return sp;
}

vector<int>g[MAXN];
int used[MAXN];


void dfs(int beg, int par)
{
    used[beg] = used[par] + 1;
    for(int nb : g[beg])
    {
        if(!used[nb]) dfs(nb,beg);
    }
}

int dist(int x, int y)
{
    for(int i = 0; i <= n; i++) used[i] = 0;
    dfs(x,x);
    return used[y]-1;
}

vector<int>pom;
int par[MAXN];

void dfs_fill(int beg, int kr)
{
    if(beg == kr)
    {
        int x = kr;
        while(x != par[x])
        {
            pom.push_back(x);
            x = par[x];
        }
        pom.push_back(x);
        return;
    }
    for(int nb : g[beg])
    {
        if(nb != par[beg])
        {
            par[nb] = beg;
            dfs(nb,kr);
        }
    }
}

void fill_pom(int nach, int kr)
{
    pom.clear();
    for(int i = 1; i <= n; i++) used[i] = par[i] = 0;
    par[nach] = nach;

    dfs_fill(nach,kr);
}

std::vector<bool> decode(int N, std::vector<std::pair<int, int>> tree)
{
    n = N;
    for(int i = 0; i <= n; i++) g[i].clear();
    for(pair<int,int> x : tree)
    {
        g[x.first].push_back(x.second);
        g[x.second].push_back(x.first);
    }

    int nach = 0;
    for(int i = 1; i <= n; i++) if(g[i].size() > g[nach].size()) nach = i;

    vector<int>kri;
    for(int i = 0; i <= n; i++)
    {
        if(i == nach) continue;
        if(g[i].size() >= 5) kri.push_back(i);
    }

    int kr = kri[0];

    if(kri.size() > 1)
    {
        if(dist(nach,kri[1]) > dist(nach,kr)) kr = kri[1];
    }

    fill_pom(nach,kr);
    reverse(pom.begin(),pom.end());

    vector<bool>ans;
    for(int i = 1; i < pom.size()-1; i++)
    {
        if(g[i].size() >= 4) ans.push_back(1);
        else ans.push_back(0);
    }
    return ans;
}
