#include <bits/stdc++.h>


using namespace std;

const int MAXN = 3e5+5;

int n,q,a[MAXN];

struct Point
{
    int x,t;
};
vector<Point>poi;

vector<int>v[MAXN];
int used[MAXN],p[MAXN];

int invalid[MAXN];

int tree[4*MAXN];

bool cmppoi(Point p1, Point p2)
{
    if(p1.x == p2.x) return p1.t > p2.t;
    return p1.x < p2.x;
}

int ql,qr;

int Merge(int t1, int t2)
{
    if(t1 == -1) return t2;
    if(t2 == -1) return t1;
    return min(t1,t2);
}

void make_tree(int v, int l, int r)
{
    if(l==r)
    {
        if(invalid[r]) tree[v] = r;
        else tree[v] = -1;
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    tree[v] = Merge(tree[v*2+0],tree[v*2+1]);
}

void update(int v, int l, int r)
{
    if(l == r)
    {
        tree[v] = r;
        return;
    }
    int mid = (l+r)/2;
    if(qr <= mid) update(v*2+0,l,mid+0);
    else update(v*2+1,mid+1,r);
    tree[v] = Merge(tree[v*2+0],tree[v*2+1]);
}

int query(int v, int l, int r)
{
    if(r < ql || qr < l || l > r) return -1;
    if(ql <= l && r <= qr) return tree[v];
    int mid = (l+r)/2;
    return Merge(query(v*2+0,l,mid+0),query(v*2+1,mid+1,r));
}

long long solve(int l, int r)
{
    unordered_set<int>valid;

    bool brchis = false;
    for(int i = 0; i < n; i++)
    {
        used[a[i]]++;
        if(used[a[i]] == a[i]) valid.insert(a[i]);
    }

    int tekmin = n;
    for(int i = 0; i < n; i++)
    {
        if(used[a[i]] < a[i])
        {
            invalid[i] = 1;
            tekmin = min(tekmin,i);
        }
    }
    make_tree(1,0,n-1);

    for(int i = 1; i <= n; i++) p[i] = -1;
    for(auto it = valid.begin(); it != valid.end(); it++)
    {
        int c = (*it);
        p[c] = 0;
    }

    long long ans = 0;

    for(int i = 0; i < n; i++)
    {
        if(tekmin < i)
        {
            ql = i;
            qr = n-1;
            tekmin = query(1,0,n-1);

            if(tekmin < i) tekmin = n;
        }

       /* cout << "NEW LINE " << "------------->  " << i << endl;
        for(auto it = valid.begin(); it != valid.end(); it++)
        {
            cout << (*it) << " ";
        }
        cout << endl << endl;

        cout << "tekmin  " <<  tekmin << endl;*/
        for(auto it = valid.begin(); it != valid.end(); it++)
        {
            int c = (*it);

            if(i <= v[c][p[c]]-1)
            {
               poi.push_back({i,  1});
               poi.push_back({v[c][p[c]] - 1,  -1});
            }

            ///vinagi ima
            poi.push_back({v[c][p[c]+c-1],  1});
            poi.push_back({v[c][p[c] + c] - 1,  -1});

        }

        int sresh = 1;
        if(tekmin != i)
        {
            poi.push_back({i,1});
            poi.push_back({tekmin-1,-1});
        }

        /*for(int j =  0; j < poi.size(); j++)
        {
            cout << poi[j].x << " - " << poi[j].t << endl;
        }*/



        sort(poi.begin(),poi.end(),cmppoi);
        //cout << "SORTED poi" << endl;

        int bal = 0;
        int last = -1;

        for(int j = 0; j < poi.size(); j++)
        {
            if(poi[j].t == 1) bal++;
            else bal--;

            if(poi[j].t == 1 && bal == (int)valid.size()+sresh) last = poi[j].x;
            if(poi[j].t == -1 && bal+1 == (int)valid.size()+sresh)
            {
                long long sumi = poi[j].x - last + 1;;
                //cout << "new sumi  " << sumi <<  " ot do   " << last << " " << poi[j].x <<endl;
                ans += sumi;
            }
        }


        if(valid.find(a[i]) != valid.end())
        {
            used[a[i]]--;
            if(used[a[i]] == a[i]-1)
            {
                valid.erase(a[i]);
                for(int j = p[a[i]] + 1; j < v[a[i]].size(); j++)
                {
                    if(v[a[i]][j] < tekmin) tekmin = v[a[i]][j];
                    ql = qr = v[a[i]][j];
                    update(1,0,n-1);
                }

                ///v[a[i]].clear(
            }
            else p[a[i]]++;
        }

        poi.clear();

    }
    return ans;
}

void prequ()
{
    poi.clear();
    for(int i = 0; i <= n; i++) used[i] = invalid[i] = 0;
}

long long query(int l, int r)
{
    prequ();
    return solve(l,r);
}

void pre()///precompute
{
    for(int i = 0; i < n; i++) v[a[i]].push_back(i);
    for(int i = 0; i < n; i++)
    {
        if(v[a[i]].back() != n) v[a[i]].push_back(n);
    }
}

void init(int N, int Q, const std::vector<int>& A)
{
    n = N;
    q = Q;
    for(int i = 0; i < n; i++) a[i] = A[i];
    pre();
}

/*int main(){

	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}*/
