#include <iostream>
#include <vector>
#include "tunnels.h"

#define PB push_back
#define X first
#define Y second
#define maxn 5005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int , int> pii;


bool ans[maxn][maxn];

bool did[maxn][maxn];
std::vector<std::vector<bool>> a;

bool my_inv(int x , int y)
{
    if(did[x][y] == true)
        return ans[x][y];

    if(a[x][y] == true)
        return false;

    did[x][y] = true;

    return ans[x][y] = investigate(y);
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    pii pos = {0 , k};
    //goDeeper(k);

    a = blocked;

    while(pos.X < n)
    {
        if(m == 1)
        {
            goDeeper(pos.Y);
            pos.X++;

            continue;
        }

        int cc; /// 0 - left , 1 - right , 2 - down
        if(pos.Y == m - 1)
        {
            if(my_inv(pos.X , pos.Y - 1) == false)
                cc = 2;
            else
                cc = 0;
        }
        else
            if(pos.Y == 0)
            {
                if(my_inv(pos.X , pos.Y + 1) == false)
                    cc = 2;
                else
                    cc = 1;
            }
            else
            {
                bool l = my_inv(pos.X , pos.Y - 1);
                bool r = my_inv(pos.X , pos.Y + 1);

                if(l == false && r == false)
                    cc = 2;
                else
                    if(l == false && r == true)
                        cc = 1;
                    else
                        cc = 0;
            }


        if(cc == 2)
        {
            goDeeper(pos.Y);
            pos.X++;

            continue;
        }

        int j;

        if(cc == 0)
        {
            bool lamp = false;
            j = pos.Y - 1;
            while(j >= 0)
            {
                if(my_inv(pos.X , j) == false)
                {
                    goDeeper(j + 1);
                    pos.X++;

                    lamp = true;
                    break;
                }

                j--;
            }

            if(lamp == false)
            {
                goDeeper(0);
            }
        }
        else
        {
            bool lamp = false;

            j = pos.Y + 1;
            while(j <= m - 1)
            {
                if(my_inv(pos.X , j) == false)
                {
                    goDeeper(j - 1);
                    pos.X++;

                    lamp = true;
                    break;
                }

                j++;
            }

            if(lamp == false)
            {
                goDeeper(m - 1);
            }
        }
    }
}
