#include <iostream>
#include <vector>
#include "tunnels.h"

#define PB push_back
#define X first
#define Y second
#define maxn 5005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int, int> pii;


bool ans[maxn][maxn];

bool did[maxn][maxn];
std::vector<std::vector<bool>> a;

bool my_inv(int x, int y)
{
    if(did[x][y] == true)
        return ans[x][y];

    if(a[x][y] == true)
        return false;

    did[x][y] = true;

    return ans[x][y] = investigate(y);
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    pii pos = {0, k};
    //goDeeper(k);

    a = blocked;

    while(pos.X < n)
    {
        if(pos.X == n - 1)
        {
            if(pos.Y == 0)
            {
                if(my_inv(pos.X, 1) == true)
                {
                    pos.Y = 1;
                    pos.X++;
                    goDeeper(pos.Y);
                }
                else
                {
                    pos.Y = 0;
                    pos.X++;
                    goDeeper(pos.Y);
                }
            }
            else
            {
                if(my_inv(pos.X, 0) == true)
                {
                    pos.Y = 0;
                    pos.X++;
                    goDeeper(pos.Y);
                }
                else
                {
                    pos.Y = 1;
                    pos.X++;
                    goDeeper(pos.Y);
                }
            }
        }

        if(pos.Y == 0)
        {
            if(my_inv(pos.X, 1) == true)
            {
                pos.Y = 1;
                pos.X++;
                goDeeper(pos.Y);
            }
            else
            {
                pos.Y = 0;
                pos.X++;
                goDeeper(pos.Y);
            }
        }
        else
        {
            if(my_inv(pos.X, 0) == true)
            {
                pos.Y = 0;
                pos.X++;
                goDeeper(pos.Y);
            }
            else
            {
                pos.Y = 1;
                pos.X++;
                goDeeper(pos.Y);
            }
        }
    }
}
