#include <iostream>
#include <vector>
#include "tunnels.h"

#define PB push_back
#define X first
#define Y second
#define maxn 5005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int, int> pii;


bool ans[maxn][maxn];

bool did[maxn][maxn];
std::vector<std::vector<bool>> a;

bool my_inv(int x, int y)
{
    if(did[x][y] == true)
        return ans[x][y];

    if(a[x][y] == true)
        return false;

    did[x][y] = true;

    return ans[x][y] = investigate(y);
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    pii pos = {0 , k};

    a = blocked;

    while(pos.X < n)
    {
        //std::cout << "-> " << pos.X << " " << pos.Y << "\n";

        if(pos.X < n - 2)
        {
            if(a[pos.X + 1][0] == true)
            {
                goDeeper(1);
                pos.X++;
                pos.Y = 1;

                continue;
            }

            if(a[pos.X + 1][1] == true)
            {
                goDeeper(0);
                pos.X++;
                pos.Y = 0;

                continue;
            }
        }

        //std::cout << "out check" << "\n";

        if(pos.Y == 0)
        {
            if(a[pos.X][1] == true)
            {
                goDeeper(pos.Y);
                pos.X++;

                continue;
            }

            if(my_inv(pos.X , 1) == true)
            {
                pos.Y = 1;
                goDeeper(pos.Y);
                pos.X++;
                continue;
            }
            else
            {
                goDeeper(pos.Y);
                pos.X++;
                continue;
            }
        }
        else
        {
            if(a[pos.X][0] == true)
            {
                goDeeper(pos.Y);
                pos.X++;

                continue;
            }

            if(my_inv(pos.X , 0) == true)
            {
                pos.Y = 0;
                goDeeper(pos.Y);
                pos.X++;
                continue;
            }
            else
            {
                goDeeper(pos.Y);
                pos.X++;
                continue;
            }
        }

        pos.X++;
    }
}
