#include <iostream>
#include <vector>
#include "bits_and_tree.h"

#define PB push_back
#define X first
#define Y second
#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int , int> pii;


std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    std::vector <pii> ans;
    if(data[0] == 0)
    {
        ans.PB({0 , 1});
        ans.PB({0 , 2});
        ans.PB({0 , 3});
        ans.PB({0 , 4});
        ans.PB({0 , 5});

        for(int i = 6; i < n; i++)
        ans.PB({i - 1 , i});
    }
    else
    {
        ans.PB({0 , 1});

        for(int i = 2; i < n; i++)
        ans.PB({i - 1 , i});
    }

    return ans;
}

int br[maxn];

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    for(auto& e : tree)
        br[e.X]++ , br[e.Y]++;

    int maxx = 0;
    for(int i = 0; i <= n; i++)
        maxx = std::max(br[i] , maxx);

    std::vector <bool> ans;

    if(maxx <= 3)
        ans = {true};
    else
        ans = {false};

    return ans;
}
