#include <iostream>
#include <vector>
#include "bits_and_tree.h"

#define PB push_back
#define X first
#define Y second
#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int , int> pii;
typedef long long ll;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    std::vector <pii> ans;

    ll num = 0;
    num += data[0];
    num += 2 * data[1];
    num += 4 * data[2];
    num += 8 * data[3];

    num *= 2;

    num += 10;

    for(int i = 1; i <= num; i++)
        ans.PB({0 , i});

    for(int i = num + 1; i < n; i++)
        ans.PB({i - 1 , i});

    return ans;
}

int br[maxn];

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    for(int i = 0; i <= n; i++)
        br[i] = 0;

    for(auto& e : tree)
        br[e.X]++ , br[e.Y]++;

    int maxx = 0;
    for(int i = 0; i <= n; i++)
        maxx = std::max(br[i] , maxx);

    std::vector <bool> ans;

    maxx -= 10;

    if(maxx % 2 == 1)
        maxx--;

    maxx /= 2;

    for(int i = 0; i < 4; i++)
        if(maxx & (2 << i) == true)
            ans.PB(true);
        else
            ans.PB(false);

    return ans;
}
