//#pragma once
//#include "Lgrader.cpp"
#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;
int level=0,N,M,pos,used[5005][5005];
vector<int>cur;
vector<vector<bool>> mat;
void find_posval(int x)
{
    queue<pair<int,int>>q;
    pair<int,int> p,w,nb;
    p.first=N-1;
    p.second=x;
    q.push(p);
    used[p.first][p.second]=1;
    while(q.size())
    {
        w=q.front();
        q.pop();
        //cout<<w.first<<" "<<w.second<<" "<<mat[w.first][w.second]<<endl;
        if(w.second-1>=0&&!used[w.first][w.second-1]&&!mat[w.first][w.second-1])
        {
            nb=w;
            nb.second--;
            used[nb.first][nb.second]=1;
            q.push(nb);
        }
        if(w.second+1<M&&!used[w.first][w.second+1]&&!mat[w.first][w.second+1])
        {
            nb=w;
            nb.second++;
            used[nb.first][nb.second]=1;
            q.push(nb);
        }
        if(w.first-1>=0&&!used[w.first-1][w.second]&&!mat[w.first-1][w.second])
        {
            nb=w;
            nb.first--;
            used[nb.first][nb.second]=1;
            q.push(nb);
        }
    }
}
void find_all(int pos)
{
    int fir=pos;
    for(int i=pos-1;i>=0;i--)
    {
        if(mat[level][i]==1)break;
        fir=i;
    }
    for(int i=fir; i<M; i++)
    {
        if(mat[level][i]==1)break;
        if(level==N-1||(mat[level+1][i]==0&&used[level+1][i]==1))cur.push_back(i);
    }
}
void go_down()
{
    int l=0,r=cur.size()-1,mid,otg;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(cur[mid]==pos)
        {
            if(l==r)
            {
                l=mid+1;
                otg=mid;
                break;
            }
            else
            {
                if(r==mid)mid--;
                else mid++;
            }
        }
        if(investigate(cur[mid]))
        {
            if(cur[mid]>=pos)
            {
                l=mid+1;
            }
            else r=mid-1;
            otg=mid;
        }
        else
        {
            if(cur[mid]>=pos)
            {
                r=mid-1;
            }
            else l=mid+1;
        }
    }
    goDeeper(cur[otg]);
    pos=cur[otg];
    level++;
}
void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    mat=blocked;
    pos=k;
    N=n;
    M=m;
    for(int i=0;i<M;i++)
    {
        if(!mat[N-1][i]&&!used[N-1][i])
        {
            find_posval(i);
        }
    }
    for(int i=0; i<n; i++)
    {
        cur.clear();
        find_all(pos);
        if(cur.size()==1)
        {
            goDeeper(cur[0]);
            pos=cur[0];
            level++;
            continue;
        }
        go_down();
    }
    return;
}
