#include <bits/stdc++.h>
#include "tunnels.h"
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

bool isValid(int x, int y, int n, int m, const std::vector<std::vector<bool>>& blocked)
{
    if (y < 0 || y >= m || blocked[x][y])
        return false;

    if (x < n-1 && blocked[x+1][y] == 1)
            return false;

    return true;
}


void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper(k);

    int currY = k;
    for (int i = 1; i < n; i++)
    {
        bool isValidCurrent = isValid(i, currY, n, m, blocked);
        if (!isValidCurrent)
        {
            currY ^= 1;
            goDeeper(currY);
            continue;
        }

        int otherY = currY^1;
        if (!isValid(i, otherY, n, m, blocked))
        {
            goDeeper(currY);
            continue;
        }

        bool q = investigate(currY);
        if (q)
        {
            goDeeper(currY);
            continue;
        }

        else
        {
            currY = otherY;
            goDeeper(currY);
            continue;
        }
    }
}

/*
5 2 1
1 0
0 0
0 0
1 0
1 0

*/
