#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
using namespace std;
const int MAX_N=3e5+5;
int a[MAX_N];
vector<int>endss[MAX_N];

int cntR[MAX_N];
vector<int>occ[MAX_N];
int cntall[MAX_N];
int cntcur[MAX_N];
int from[MAX_N];

vector<int>tree[3*MAX_N];
void Init(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=endss[l];
        sort(tree[node].begin(),tree[node].end());
        return;
    }

    int mid=(l+r)/2;
    Init(2*node,l,mid);
    Init(2*node+1,mid+1,r);

    if(tree[2*node].size()==0)tree[node]=tree[2*node+1];
    else if(tree[2*node+1].size()==0)tree[node]=tree[2*node];
    else
    {
        for(int x:tree[2*node])tree[node].push_back(x);
        for(int x:tree[2*node+1])tree[node].push_back(x);
        sort(tree[node].begin(),tree[node].end());
        //merge(tree[2*node].begin(),tree[2*node].end(),tree[2*node+1].begin(),tree[2*node+1].end(),tree[node].begin());
    }
}
int Query(int node,int l,int r,int ql,int qr,int x)
{
    if(ql<=l && r<=qr)
    {
        int le=0,re=tree[node].size()-1;
        int pos=-1;
        while(le<=re)
        {
            int mid=(le+re)/2;
            if(tree[node][mid]<=x)
            {
                pos=mid;
                le=mid+1;
            }
            else re=mid-1;
        }
        return pos+1;
    }

    int mid=(l+r)/2;

    int ans=0;

    if(ql<=mid)ans=Query(2*node,l,mid,ql,qr,x);
    if(mid+1<=qr)ans+=Query(2*node+1,mid+1,r,ql,qr,x);

    return ans;
}
void rec(int l,int r)
{
    if(l==r)
    {
        if(a[l]==1)endss[l].push_back(l);

        return;
    }

    int len=r-l+1;
    int mid=(l+r)/2;
    int sumneed=0;

    for(int i=l;i<=r;i++)
    {
        cntall[a[i]]++;
    }

    for(int i=mid+1;i<=r;i++)
    {
        occ[a[i]].push_back(i);
        from[a[i]]++;
    }

    vector<int>nums;

    for(int i=mid;i>=l;i--)
    {
        if(cntall[a[i]]<a[i])break;

        if(cntcur[a[i]]==0)
        {
            sumneed+=a[i];
            nums.push_back(a[i]);
        }

        if(sumneed>len)break;

        cntcur[a[i]]++;

        if(cntcur[a[i]]>a[i])break;

        while(from[a[i]]+1+cntcur[a[i]]>a[i])from[a[i]]--;

        int sl=mid+1,sr=r;

        bool ok=1;

        for(int x:nums)
        {
            if(from[a[i]]+1+cntcur[a[i]]<a[i]){ok=0;break;}

            int curl=mid+1,curr=r;

            if(occ[x].size()>0)
            {
                curl=(from[x]==-1 ? mid+1 : occ[x][from[x]]);
                curr=(from[x]+1==occ[x].size() ? r : occ[x][from[x]+1]-1);
            }
            else
            {
                if(cntcur[x]!=x){ok=0;break;}
            }


            if(curl>curr){ok=0;break;}
            if(curl>sr or curr<sl){ok=0;break;}

            sl=max(sl,curl);
            sr=min(sr,curr);
        }

        if(ok)
        {
            int uni=0,good=0;

            for(int j=sl;j<=sr;j++)
            {
                if(cntcur[a[j]]!=0)
                {
                    endss[i].push_back(j);
                    continue;
                }

                if(cntR[a[j]]==0)
                {
                    uni++;
                }
                cntR[a[j]]++;

                if(cntR[a[j]]==a[j])good++;
                else if(cntR[a[j]]>a[j])break;

                if(uni==good)
                {
                    endss[i].push_back(j);
                }
            }

            for(int j=sl+1;j<=sr;j++)
            {
                cntR[a[j]]=0;
            }
        }
    }

    for(int i=l;i<=r;i++)
    {
        cntall[a[i]]=0;
        cntcur[a[i]]=0;
        from[a[i]]=0;
        occ[a[i]].clear();
    }

    rec(l,mid);
    rec(mid+1,r);
    //from 0/cntcur 0/cntall 0/occ clear
}
int n;
void init(int N, int Q, const std::vector<int>& A)
{
    n=N;
    for(int i=1;i<=N;i++)
    {
        a[i]=A[i-1];
    }
    rec(1,N);
    Init(1,1,N);
}
long long query(int l, int r)
{
    return Query(1,1,n,l+1,r+1,r+1);
}
