#include <bits/stdc++.h>
#define pb push_back
using namespace std;
const int maxn = 5e5 + 10;
int n, q;
vector < int > p[maxn];
int passed[maxn], ending[maxn];

int t[maxn * 4];
void build(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = ending[l];
        return;
    }
    int mid = (l + r)/2;
    build(2*i, l, mid);
    build(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}
int ql, qr;
int query(int i, int l, int r)
{
    if(qr < l || ql > r)return 0;
    if(ql <= l && r <= qr)return t[i];
    int mid = (l + r)/2;
    return max(query(2*i, l, mid), query(2*i+1, mid+1, r));
}

int updpos, updval;
void update(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = updval;
        return;
    }
    int mid = (l + r)/2;
    if(updpos <= mid)update(2*i, l, mid);
    else update(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}
long long ans;
void init(int N, int Q, const std::vector<int>& a)
{
    ans = 0;
    n = N;
    q = Q;
    for (int i = 0; i < n; ++ i)
    {
        p[a[i]].pb(i);
    }
   // cout << "started build " << endl;
    unordered_map < int, int > cnt;
    for (int j = 0; j < n; ++ j)
    {

        int val = a[j];
        cnt[val] ++;
        if(cnt[val] > val)
        {
            ending[j] = n;
            continue;
        }
        int sz = p[a[j]].size();
        if(sz - passed[val] < val)ending[j] = n;
        else if(cnt[val] == 1)ending[j] = p[val][passed[val] + val - 1];
        else ending[j] = 0;
    }
    //cout << " ended build " << endl;
   // for (int i = 0; i < n; ++ i)
    //    cout << ending[i] << " ";
    //cout << endl;
    build(1, 0, n-1);
   // cout <<"tree building ended" << endl;
    for (int i = 0; i < n; ++ i)
    {

        //cout << " solving i = " << i << endl;
        int x = i;
        while(x < n)
        {
            //cout << i << " " << x << endl;
            ql = i;
            qr = x;
            int maxx = query(1, 0, n-1);
            if(maxx == x)
            {
               // cout << "ans ++ " << endl;
                ans ++;
                x ++;
            }
            else if(maxx == n)break;
            else
            {
                x = maxx;
            }
        }
        passed[a[i]] ++;
        ending[i] = n;
        int currval = a[i];
         int currsz = p[currval].size();
        int leftcnt = currsz - passed[currval];
        if(leftcnt < currval)
        {
            //cout << " wont have more " << endl;
            if(leftcnt)
            {
                updpos = p[currval][passed[currval]];
                updval = n;
                update(1, 0, n-1);
                ending[updpos] = updval;
            }

        }
        else
        {
            //cout << " will have more " << endl;
            int nxtofvalue = p[currval][passed[currval]];
            //cout << "nxtofvalue " << nxtofvalue << endl;
            ending[nxtofvalue] = p[currval][passed[currval] + currval - 1];
            int lasti =  p[currval][passed[currval] + currval - 1];
           // cout << "lasti " << lasti << endl;
            updpos = nxtofvalue;
            updval = lasti;
            update(1, 0, n-1);
            ending[updpos] = updval;
            if(lasti != nxtofvalue)
            {
                updpos = lasti;
            updval = 0;
            update(1, 0, n-1);
            ending[updpos] = updval;
            }
        }
       //cout << " curr " << endl;
        //for (int j = 0; j < n; ++ j)
        //    cout << ending[j] << " ";
        //cout << endl;
    }
}
long long query(int l, int r)
{
    return ans;
}
