#include<iostream>
#include<vector>
#include "tunnels.h"
#define MAXN 5010
using namespace std;
bool tab[MAXN][MAXN];
bool check(int x, int y, int n, int m)
{
    if(x>n || y<0 || y>=m)return 0;
    if(x==n)return 1;
    if(tab[x][y])return 0;
    if(check(x+1,y,n,m))return 1;
    if(check(x,y-1,n,m))return 1;
    if(check(x,y+1,n,m))return 1;
    return 0;
}
void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    int curr=k;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)tab[i][j]=blocked[i][j];
    }
    for(int i=0;i<n;i++)
    {
        int l,r;
        vector<int> order1,order2;
        for(int j=curr-1;j>=0;j--)order1.push_back(j);
        for(int j=curr+1;j<m;j++)order2.push_back(j);

        int lm,last=-1;
        if(order1.size()>0)
        {
            l=0;r=order1.size()-1;
            lm=r;
            while(l+r<=lm)
            {
                int mid=l+r;
                if(investigate(order1[mid]))
                {
                    l=mid;
                    last=mid;
                    if(r==0)break;
                }
                else {r>>=1;lm=mid-1;}
            }
        }

        if(last>-1)curr=order1[last];
        else
        {
            if(order2.size()>0)
            {
                l=0;r=order2.size()-1;
                lm=r;
                while(l+r<=lm)
                {
                    int mid=l+r;
                    if(investigate(order2[mid]))
                    {
                        l=mid;
                        last=mid;
                        if(r==0)break;
                    }
                    else {r>>=1;lm=mid-1;}
                }
            }
            if(last>-1)curr=order2[last];
        }

        goDeeper(curr);
    }
}