#include<bits/stdc++.h>
#include "bits_and_tree.h"
#define MAXN 505
using namespace std;
vector<pair<int,int>> encode(int n, vector<bool> data)
{
    vector<pair<int,int>> ret;
    ret.push_back({0,1});
    ret.push_back({0,2});
    ret.push_back({0,3});
    ret.push_back({0,4});
    ret.push_back({0,5});
    int lim=14,cntr=0;//6 beg, 8 en, could be compressed to 5-7
    for(int i=0;i<data.size();i++)
    {
        if(data[i])lim++;
        else lim+=3;
        cntr++;
        if(lim>200)
        {
            if(data[i])lim--;
            else lim-=3;
            cntr--;
            break;
        }
    }
    int prev=0,curr=6;
    for(int i=0;i<cntr;i++)
    {
        if(data[i])
        {
            ret.push_back({prev,curr});
            prev=curr;
            curr++;
        }
        else
        {
            ret.push_back({prev,curr});
            ret.push_back({curr,curr+1});
            ret.push_back({curr,curr+2});
            prev=curr;
            curr+=3;
        }
    }
    ret.push_back({prev,curr});
    prev=curr;
    curr++;
    for(int i=curr;i<200;i++)ret.push_back({prev,i});
    return ret;
}
vector<int> edges[MAXN];
int info[MAXN];
vector<bool> decode(int n, vector<pair<int,int>> tree)
{
    for(int i=0;i<MAXN;i++)
    {
        edges[i].clear();
        info[i]=1;
    }
    int corr=0,root=0,en=0;
    for(int i=0;i<tree.size();i++)
    {
        int u=tree[i].first,v=tree[i].second;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
    for(int i=0;i<MAXN;i++)
    {
        if(edges[i].size()==6)root=i;
        else if(edges[i].size()==7){root=i;corr=i;}
        else if(edges[i].size()==8)en=i;
        else if(edges[i].size()>8){en=i;corr=i;}
        else if(edges[i].size()==2)info[i]=1;
        else if(edges[i].size()==3){info[i]=1;corr=i;}
        else if(edges[i].size()==4)info[i]=0;
        else if(edges[i].size()==5){info[i]=0;corr=i;}
        else info[i]=2;
    }
    info[root]=2;
    info[en]=2;
    for(int i=0;i<MAXN;i++)
    {
        if(edges[i].size()==2)
        {
            int c1=edges[i][0],c2=edges[i][1];
            if(c1==root || c1==en)
            {
                if(info[c2]==2)info[i]=2;
            }
            else if(c2==root || c2==en)
            {
                if(info[c1]==2)info[i]=2;
            }
            else if(info[c1]==2 || info[c2]==2)info[i]=2;
        }
    }
    vector<bool> ans;
    int curr=root,prev=-1;
    /*cout<<root<<" "<<en<<"A\n";
    if(root==170 && en==188)
    {
        for(int i=0;i<MAXN;i++)cout<<edges[i].size()<<" ";
        cout<<"B\n";
        for(int i=0;i<tree.size();i++)
        {
            cout<<tree[i].first<<" "<<tree[i].second<<"\n";
        }
    }*/
    while(curr!=en)
    {
        //cout<<"{"<<curr<<" "<<edges[curr].size()<<"} ";
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i];
            if(now==en){curr=en;break;}
            if(info[now]==2 || now==prev)continue;
            if(info[now])ans.push_back(1);
            else ans.push_back(0);
            prev=curr;
            curr=now;
            break;
        }
    }
    mt19937 mt(9879613);
    uniform_int_distribution<> dist(0,1);
    while(ans.size()!=(n<<1))
    {
        ans.push_back(dist(mt));
    }
    return ans;
}