#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int p = k ;
    goDeeper( k );
    for ( int i = 1 ; i < n ; i++ )
    {
        if ( i == n-1 )
        {
            if ( blocked[i][0] == 1 ) { goDeeper(1); p = 1 ; continue; }
            if ( blocked[i][1] == 1 ) { goDeeper(0); p = 0 ; continue; }
            if ( p == 0 )
            {
                if ( investigate(1) == 1 ) { goDeeper(1) ; p = 1 ; }
                else { goDeeper(0) ; p = 0 ; }
                continue ;
            }
            if ( investigate(0) == 1 ) { goDeeper(0) ; p = 0 ; }
            else { goDeeper(1) ; p = 1 ; }
            continue ;
        }

        if ( blocked[i][0] == 0 && blocked[i][1] == 0 )
        {
            if ( blocked[i+1][0] == 0 && blocked[i+1][1] == 0 )
            {
                if ( p == 0 )
                {
                    if ( investigate(1) == 1 ) { goDeeper(1) ; p = 1 ; }
                    else { goDeeper(0) ; p = 0 ; }
                    continue ;
                }
                if ( investigate(0) == 1 ) { goDeeper(0) ; p = 0 ; }
                else { goDeeper(1) ; p = 1 ; }
                continue ;
            }
            if ( blocked[i+1][0] == 1 ) { goDeeper(1); p = 1 ; continue; }
            if ( blocked[i+1][1] == 1 ) { goDeeper(0); p = 0 ; continue; }
        }

        goDeeper(p) ;
    }
}
/*
10 2 0
0 0
0 1
0 1
0 0
1 0
1 0
0 0
0 0
1 0
0 0
*/

