#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int j1 , j2 ;
    goDeeper(k) ;
    for ( int i = 1 ; i < n ; i++ )
    {
        j1 = k+1 ;
        j2 = k-1 ;
        while ( j1 < m or investigate(j1) == 1 )
            j1++ ;
        j1-- ;

        if ( j1 > k )
        {
            goDeeper( j1 ) ;
            k = j1 ;
            continue ;
        }


        while ( j2 >= 0 or investigate(j2) == 1 )
            j2-- ;
        j2++ ;

        if ( j2 < k )
        {
            goDeeper( j2 ) ;
            k = j2 ;
        }
        else goDeeper( k ) ;
    }
}

