#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);


void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper( k ) ;
    int j1 , j2 ;

    for ( int i = 1 ; i < n ; i++ )
    {
        j1 = k + 1 ;
        while ( j1 < m && blocked[i][j1] == 0 && investigate(j1) == 1 )
            j1++ ;
        j1-- ;

        if ( j1 > k )
        {
            k = j1 ;
            goDeeper( k ) ;
            continue ;
        }

        j2 = k - 1 ;
        while ( j2 >= 0 && blocked[i][j2] == 0 && investigate(j2) == 1 )
            j2-- ;
        j2++ ;


        if ( j2 < k )
        {
            k = j2 ;
            goDeeper( k ) ;
            continue ;
        }

        goDeeper( k ) ;
    }

}
