#include <bits/stdc++.h>
#include "bits_and_tree.h"
#define pb push_back
using namespace std;
int maxn=47;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    maxn=min(maxn,(int)data.size());
    vector<pair<int,int> > t;
    int id=2*maxn+1;
    t.pb({0,1});
    t.pb({0,2});
    if(data[0])
    {
        t.pb({1,id++});
        t.pb({2,id++});
    }
    for(int i=2;i<=maxn;i++)
    {
        if(data[i-1])
        {
            t.pb({i*2-1,id++});
            t.pb({i*2,id++});
        }

        t.pb({(i-1)*2-1,i*2-1});
        t.pb({(i-1)*2,i*2});
    }

    t.pb({maxn*2,id++});
    t.pb({id-1,id++});
    t.pb({id-1,id++});

    t.pb({maxn*2-1,id++});
    t.pb({id-1,id++});
    t.pb({id-1,id++});

    while(id<n)
        t.pb({0,id++});

    /*for(int i=0;i<t.size();i++)
        cout<<t[i].first<<" "<<t[i].second<<endl;
    cout<<"out"<<endl;*/
    return t;
}

vector<int> v[256];
int sz[256];

void prec(int i,int p)
{
    sz[i]=1;
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(nb==p)continue;
        prec(nb,i);
        sz[i]+=sz[nb];
    }
    //cout<<i<<" + "<<sz[i]<<endl;
}

int used[256];
int c[2][256];
void dfs(int i,int id,int tp)
{
    //cout<<"- "<<i<<" "<<id<<" "<<v[i].size()<<endl;
    used[i]=1;
    if(v[i].size()==1)return;
    int maxx=v[i][0];
    if(used[maxx])maxx=v[i][1];
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(used[nb])continue;
        if(sz[nb]>sz[maxx])maxx=nb;
    }

    c[tp][id]=v[i].size();
    dfs(maxx,id+1,tp);
}
std::vector<bool> decode(int n, std::vector<std::pair<int, int>> t)
{
    int maxx=0;
    for(int i=0;i<t.size();i++)
    {
        v[t[i].first].pb(t[i].second);
        v[t[i].second].pb(t[i].first);
        if(v[maxx].size()<v[t[i].first].size())maxx=t[i].first;
        if(v[maxx].size()<v[t[i].second].size())maxx=t[i].second;
    }

    prec(maxx,-1);

    used[maxx]=1;
    int nb1=0,nb2=0;
    for(int i=0;i<v[maxx].size();i++)
    {
        //cout<<v[maxx][i]<<" - "<<sz[v[maxx][i]]<<endl;
        if(sz[v[maxx][i]]>2)
        {
            if(nb1)nb2=v[maxx][i];
            else nb1=v[maxx][i];
        }
    }
    //cout<<"here"<<endl;

    dfs(nb1,1,0);
    dfs(nb2,1,1);
    vector<bool> ans;

    for(int i=1;i<=maxn;i++)
        if(c[0][i]+c[1][i]>=6)ans.pb(1);
        else ans.pb(0);

    //cout<<"done"<<endl;

    for(int i=0;i<t.size();i++)
    {
        v[t[i].first].clear();
        v[t[i].second].clear();
    }
    memset(used,0,sizeof(used));
    return ans;
}
