#include <iostream>
#include <vector>
#include <cstring>
using namespace std;

vector<int> a_doubl;
int tree[4*5*100000 + 1];
int n;

void build(int node, int l, int r){
    if(l == r){
        tree[node] = 1;
        return;
    }

    int mid = (l+r)/2;
    build(node*2+1, l, mid);
    build(node*2+2 , mid+1, r);

    tree[node] = (tree[node*2+1] & tree[node*2 + 2]);
}

long long find_q(int node, int l, int r, int ql, int qr){
    if(l > qr || r < ql){
        return 0;
    }

    if(l >= ql && r <= qr){
        return tree[node];
    }

    int mid = (l+r)/2;
    long long ans1 = find_q(node*2+1, l, mid, ql, qr);
    long long ans2 = find_q(node*2+2, mid+1, r, ql, qr);


    return (ans1 & ans2);
}

long long query(int l, int r){
    return find_q(0, 0, n-1, l, r);
}


void init(int N, int Q, const std::vector<int>& a){
    a_doubl.resize(a.size());
    n = N;
    for(int i = 0; i < N; i++){
        a_doubl[i] = a[i];
    }
    build(0, 0, N-1);
}