#include "tunnels.h"

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &blocked) {
  bool fl = true;
  if (blocked[0].front())
    fl = true;
  else if (blocked[0].back())
    fl = false;
  else {
    if (investigate(0))
      goDeeper(0);
    else
      goDeeper(1);
  }

  for (int i = 1; i < n; i++) {
    if (blocked[i].back())
      goDeeper(0);
    else if (blocked[i].front())
      goDeeper(1);
    else {
      if (investigate(0))
        goDeeper(0);
      else
        goDeeper(1);
    }
  }
}