#include <iostream>
#include <set>
#include <vector>

const int maxn = 5 + 3e5;
int cnt[maxn], n, q;
std::vector<int> arr;

void init(int _n, int _q, const std::vector<int> &a) {
  n = _n, q = _q;
  arr = std::move(a);
}

long long query(int l, int r) {
  if (q > 600)
    return 0;

  long long ans = 0;
  for (int i = l; i <= r; i++) {
    for (int k = 1; k <= n; k++)
      cnt[k] = 0;

    int r = 0;
    std::set<int> nums;
    for (int j = i; j <= r; j++) {
      if (arr[j] % 2 == 0) {
        r ^= arr[j];
        continue;
      }

      cnt[arr[j]]++;
      nums.insert(arr[j]);
      if (cnt[arr[j]] > arr[j])
        break;
      if (r != 0)
        continue;

      bool fl = true;
      for (int num : nums)
        if (cnt[num] != num) {
          fl = false;
          break;
        }

      if (fl)
        ans++;
    }
  }
  return ans;
}
