#include "bits_and_tree.h"

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
  std::vector<std::pair<int, int>> res;
  if (data[0] == '1') {
    res.push_back({2, 2});
    res.push_back({4, 4});
    res.push_back({6, 6});
  } else {
    res.push_back({1, 1});
    res.push_back({3, 3});
    res.push_back({5, 5});
  }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
  std::pair<int, int> p1 = {2, 2}, p2 = {4, 4}, p3 = {6, 6};
  std::vector<bool> ans(200, 0);
  for (auto &e : tree) {
    if (e == p1)
      p1 = {-1, -1};
    else if (e == p2)
      p2 = {-1, -1};
    else if (e == p3)
      p3 = {-1, -1};
  }
  if (p1 == p2 && p1 == p3)
    ans[0] = 1;
  return ans;
}