#include <iostream>
#include <set>
#include <vector>

const int maxn = 5 + 3e5;
int cnt[maxn];
std::vector<int> arr;
int n, q;

void init(int _n, int _q, const std::vector<int> &a) {
  n = _n;
  q = _q;
  arr = a;
}

long long query(int l, int r) {
  if (q > 1)
    return 0;

  long long ans = 0;
  std::set<int> nums;
  for (int i = 0; i <= n - 1; i++) {
    if (i % 2 == 0) {
      for (int j = i; j <= n - 1; j++) {
        cnt[arr[j]]++;
        nums.insert(arr[j]);

        bool fl = true;
        for (int num : nums)
          if (cnt[num] != num) {
            fl = false;
            break;
          }

        if (fl)
          ans++;
      }
    } else {
      cnt[arr[i - 1]]--;
      if (cnt[arr[i - 1]] == 0)
        nums.erase(arr[i - 1]);

      for (int j = n - 1; j >= i; j--) {
        bool fl = true;
        for (int num : nums)
          if (cnt[num] != num) {
            fl = false;
            break;
          }

        if (fl)
          ans++;

        cnt[arr[j]]--;
        if (cnt[arr[j]] == 0)
          nums.erase(arr[j]);
      }
    }
  }
  return ans;
}
