#include <iostream>
#include <set>
#include <vector>

const int maxn = 5 + 3e5;
int cnt[maxn];
std::vector<int> arr;

void init(int _n, int q, const std::vector<int> &a) { arr = std::move(a); }

long long query(int l, int r) {
  int ans = 0, sz = arr.size();
  bool fl = 0;

  for (int i = l; i <= r; i++) {
    for (int l = 0; l <= sz; l++)
      cnt[l] = 0;

    std::set<int> nums;
    for (int j = i; j <= r; j++) {
      if (cnt[arr[j]] > arr[j])
        break;
      cnt[arr[j]]++;
      nums.insert(arr[j]);

      bool fl = true;
      for (int num : nums)
        if (cnt[num] != num) {
          fl = false;
          break;
        }

      if (fl)
        ans++;
    }
  }
  return ans;
}
