#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const long long mod[2]={1000000007,1000000009};
long long power[MAXN][2];

int n,q,a[MAXN],cnt[MAXN],fr[MAXN];
long long ans;

void calc(){
    power[0][0]=power[0][1]=1;
    
    for(int i=1;i<=n;i++){
        for(int f=0;f<2;f++)power[i][f]=(long long) (power[i-1][f]*(n+1))%mod[f];
    }
}

struct hesh{
    long long h[2];

    void add(int x,long long y){
        h[0]+=power[x][0]*y; h[0]+=mod[0]*mod[0]; h[0]%=mod[0];
        h[1]+=power[x][1]*y; h[1]+=mod[1]*mod[1]; h[1]%=mod[1];
    }

    inline friend bool operator == (hesh fr,hesh sc){
        return fr.h[0]==sc.h[0] and fr.h[1]==sc.h[1];
    }

    inline friend bool operator < (hesh fr,hesh sc){
        if(fr.h[0]!=sc.h[0])return fr.h[0]<sc.h[0];
        return fr.h[1]<sc.h[1];
    }
}zero;

map<hesh,int> mp;
hesh curr[MAXN];

void solve(int l,int r){
    if(l==r){
        if(a[l]==1)ans++;
        return;
    }

    int mid=(l+r)/2;
    solve(l,mid);
    solve(mid+1,r);

    mp.clear();
    int pt=l;

    for(int i=mid;i>=l;i--){
        cnt[a[i]]++;
        if(cnt[a[i]]==1)fr[a[i]]=i;

        if(cnt[a[i]]>a[i]){
            pt=i+1;
            break;
        }

        if(i<mid)curr[i]=curr[i+1];
        else curr[i]=zero;

        if(cnt[a[i]]!=a[i])curr[i].add(a[i],1);
        else curr[i].add(a[i],-(a[i]-1));

        mp[curr[i]]++;
    }

    for(int i=mid;i>=l;i--)cnt[a[i]]=0;

    for(int i=mid+1;i<=r;i++){
        cnt[a[i]]++;
        if(cnt[a[i]]>a[i])break;

        if(cnt[a[i]]==a[i]){
            while(pt<=fr[a[i]]){
                mp[curr[pt]]--;
                pt++;
            }
        }

        if(i>mid+1)curr[i]=curr[i-1];
        else curr[i]=zero;

        if(cnt[a[i]]==1){
            curr[i].add(a[i],a[i]-1);
        }else{
            curr[i].add(a[i],-1);
        }

        ans+=mp[curr[i]];
    }

    for(int i=l;i<=r;i++){
        fr[a[i]]=0; cnt[a[i]]=0;
    }
}

void init(int N, int Q, const std::vector<int>& A){
    n=N; q=Q;

    for(int i=1;i<=n;i++){
        a[i]=A[i-1];
    }
    calc();

    solve(1,n);
}

long long query(int l, int r){
    return ans;
}


/*int main(){
    init(7,3,{1,2,1,2,3,3,3});
    cout<<query(1,7)<<"\n";

    return 0;
}*/