#include<bits/stdc++.h>
#include "tunnels.h"


using namespace std;

vector<vector<bool> > block;
vector<int> pos, path, frst;
int N, M, first;
bool flag, up;
int reach[5005][5005];

void opit()
{
    for(auto j : pos)
    {
        bool res = investigate(j);
        if(res)
        {
            path.push_back(j);
            goDeeper(j);
        }
        else
        {
            up = true;
            return;
        }
    }
    flag = true;
}
bool findPath(int i, int j, int last)
{
    if(j < 0 || j == M) return false;
    if(i == N) return true;
    if(block[i][j]) return false;
    if(reach[i][j] != -1) return reach[i][j];
    bool a = false, b = false, c = false;
    if(last != 2) a = findPath(i, j - 1, 1);
    if(last != 1) b = findPath(i, j + 1, 2);
    c = findPath(i + 1, j, 0);
    return reach[i][j] = (a || b || c);
}
bool check(int i, int j)
{
    int cnt = 0, J = j;
    first = -1;
    while(J < M && !block[i][J] && cnt < 2)
    {
        if(findPath(i + 1, J, 0))
        {
            cnt ++;
            first = J;
        }
        else block[i][J] = 1;
        J ++;
    }
    J = j - 1;
    while(J > -1 && !block[i][J] && cnt < 2)
    {
        if(findPath(i + 1, J, 0))
        {
            cnt ++;
            first = J;
        }
        else block[i][J] = 1;
        J --;
    }
    //cout<<i<<"     "<<cnt<<endl;
    return cnt > 1;
}
void backtr(int i, int j, int last)
{
    if(j < 0 || j == M) return;
    if(flag) return;

    if(i == N)
    {
        opit();
        return;
    }
    if(block[i][j]) return;
    if(!check(i, j))
    {
        path.push_back(first);
        goDeeper(first);
        backtr(i + 1, first, 0);
        return;
    }
    if(last != 1 && !up) backtr(i, j + 1, 2);
    if(i == path.size() - 1) up = false;
    if(last != 2 && !up) backtr(i, j - 1, 1);
    if(i == path.size() - 1) up = false;

    if(!up)
    {
        if(j == path[path.size() - 1] && i == path.size() - 1)
        {
            path.push_back(j);
            goDeeper(j);
            backtr(i + 1, j, 0);
        }
        else
        {
            pos.push_back(j);
            backtr(i + 1, j, 0);
            pos.pop_back();
        }
    }
    if(i == path.size() - 1) up = false;

}

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    for(int i = 0; i < 5005; i ++)
    {
        for(int j = 0; j < 5005; j ++) reach[i][j] = -1;
    }
    block = blocked;
    N = n;
    M = m;
    path.push_back(k);
    backtr(0, k, 0);
}
