#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

const int maxn = 5002;
int nn, mm;
bool b[maxn][maxn];

int bin_search1(int l, int r, int a)
{
    int mid = ((l+r) >> 1), ans = a;
    while (l <= r)
    {
        if (investigate(mid))
        {
            ans = mid;
            r = mid - 1;
        }
        else l = mid + 1;
        mid = ((l+r) >> 1);
    }
    return ans;
}

int bin_search2(int l, int r, int a)
{
    int mid = ((l+r) >> 1), ans = a;
    while (l <= r)
    {
        if (investigate(mid))
        {
            ans = mid;
            l = mid + 1;
        }
        else r = mid - 1;
        mid = ((l+r) >> 1);
    }
    return ans;
}

int solve_level(int level, int pos)
{
    int left = pos, right = pos, i;
    for (i=pos; i>=0; --i)
    {
        if (b[level][i])
            break;
        left = i;
    }
    for (i=pos; i<nn; ++i)
    {
        if (b[level][i])
            break;
        right = i;
    }

    if (left == pos && right == pos)
    {
        goDeeper(pos);
        return pos;
    }
    else if (left == pos)
    {
        if (investigate(pos+1))
        {
            if (pos + 1 == right)
            {
                goDeeper(right);
                return right;
            }
            int k = bin_search2(pos+2, right, pos+1);
            goDeeper(k);
            return k;
        }
        else
        {
            goDeeper(pos);
            return pos;
        }
    }
    else if (right == pos)
    {
        if (investigate(pos-1))
        {
            if (pos - 1 == left)
            {
                goDeeper(left);
                return left;
            }
            int k = bin_search1(left, pos-2, pos-1);
            goDeeper(k);
            return k;
        }
        else
        {
            goDeeper(pos);
            return pos;
        }
    }
    else
    {
        if (investigate(pos-1))
        {
            if (pos - 1 == left)
            {
                goDeeper(left);
                return left;
            }
            int k = bin_search1(left, pos-2, pos-1);
            goDeeper(k);
            return k;
        }
        else
        {
            if (investigate(pos+1))
            {
                if (pos + 1 == right)
                {
                    goDeeper(right);
                    return right;
                }
                int k = bin_search2(pos+2, right, pos+1);
                goDeeper(k);
                return k;
            }
            else
            {
                goDeeper(pos);
                return pos;
            }
        }
    }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    nn = n, mm = m;
    int i, j;
    for (i=0; i<n; ++i)
    {
        for (j=0; j<m; ++j)
        {
            b[i][j] = blocked[i][j];
        }
    }

    int l = 0;
    int pos = solve_level(l, k);
    //cout << pos << endl;
    ++ l;

    while (l < n)
    {
        pos = solve_level(l, pos);
        //cout << pos << endl;
        ++ l;
    }
    //goDeeper(pos);
}

/*

8 8 3
01000001
01100000
00000000
00000000
00000100
00000000
00100000
11110000

*/