#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;
typedef long long ll;

void solve(int n, int m, int k, const vector< vector<bool > > &blocked)
{
    for (int row = 0; row < n; row ++)
    {
        int span_left = k, span_right = k;
        if (m == 1)
        {
            goDeeper(k);
            continue;
        }

        if (k >= m / 2)
        {
            if (k == m - 1 || investigate(k - 1) == 1)
            {
                int lb = -1, rb = k - 1;
                while(lb + 1 < rb)
                {
                    int m = (lb + rb) / 2;
                    if (investigate(m) == 0)
                        lb = m;
                    else
                        rb = m;

                }

                span_left = rb;
            }
            else
            {
                int lb = k;
                int rb = m;
                while(lb + 1 < rb)
                {
                    int m = (lb + rb) / 2;
                    if (investigate(m) == 1)
                        lb = m;
                    else
                        rb = m;

                }

                span_right = lb;
            }
        }
        else
        {
            if (k == 0 || investigate(k + 1) == 1)
            {
                int lb = k + 1;
                int rb = m;
                while(lb + 1 < rb)
                {
                    int m = (lb + rb) / 2;
                    if (investigate(m) == 1)
                        lb = m;
                    else
                        rb = m;

                }

                span_right = lb;
            }
            else
            {
                int lb = -1, rb = k;
                while(lb + 1 < rb)
                {
                    int m = (lb + rb) / 2;
                    if (investigate(m) == 0)
                        lb = m;
                    else
                        rb = m;

                }

                span_left = rb;
            }
        }

        if (span_left != k)
        {
            goDeeper(span_left);
            k = span_left;
        }
        else
        if (span_right != k)
        {
            goDeeper(span_right);
            k = span_right;
        }
        else
            goDeeper(k);

    }

}
