#include<bits/stdc++.h>
#include "bits_and_tree.h"


using namespace std;
typedef long long ll;


const int MARK_NEC = 10;
vector < pair < int, int > > encode(int n, vector < bool > data)
{
    vector < pair < int, int > > edges;
    int root = 0, next_ver = 0;
    /// mark root



    for (int i = 0; i < MARK_NEC; i ++)
    {
        edges.push_back({root, ++ next_ver});
    }

    int cur = root;
    for (int i = 0; i  + 1 < (int)(data.size()); i += 2)
    {
        bool bit1 = data[i];
        bool bit2 = data[i + 1];


        if (bit1 == 0 && bit2 == 0 && next_ver + 4 < n)
        {
            edges.push_back({cur, ++ next_ver});
            edges.push_back({cur, ++ next_ver});
            edges.push_back({cur, ++ next_ver});
            edges.push_back({cur, ++ next_ver});
        }
        else
        if (bit1 == 1 && bit2 == 0 && next_ver + 1 < n)
        {
            edges.push_back({cur, ++ next_ver});
        }
        else
        if (bit1 == 0 && bit2 == 1 && next_ver + 4 < n)
        {
            edges.push_back({cur, ++ next_ver});
            edges.push_back({next_ver, next_ver + 1});
            next_ver ++;
            edges.push_back({cur, ++ next_ver});
            edges.push_back({next_ver, next_ver + 1});
            next_ver ++;
        }
        else
        if (bit1 == 1 && bit2 == 1 && next_ver + 6 < n)
        {
            edges.push_back({cur, ++ next_ver});
            edges.push_back({next_ver, next_ver + 1});
            next_ver ++;
            edges.push_back({cur, ++ next_ver});
            edges.push_back({next_ver, next_ver + 1});
            next_ver ++;
            edges.push_back({cur, ++ next_ver});
            edges.push_back({next_ver, next_ver + 1});
            next_ver ++;
        }
        cur = next_ver;
    }

    while(edges.size() < n - 1)
    {
        edges.push_back({next_ver, next_ver + 1});
        next_ver ++;
    }

    return edges;

}

const int MAXN = 210;
vector < int > adj[MAXN];
vector < int > child[MAXN];
int sub[MAXN], marked[MAXN];

void trav(int v, int p)
{

    //cout << "trav " << v << " " << p << " " << marked[v] << endl;
    sub[v] = 1;
    marked[v] ++;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        assert(marked[u] == 0);
        child[v].push_back(u);
        trav(u, v);
        sub[v] += sub[u];

    }
}

vector < bool > decode (int n, vector < pair < int, int > > tree)
{
    for (int i = 0; i <= n; i ++)
    {
        adj[i].clear();
        child[i].clear();
        sub[i] = 0;
        marked[i] = 0;
    }

    assert((int)tree.size() == n);

    for (int i = 0; i < n; i ++)
    {

        adj[tree[i].first].push_back(tree[i].second);
        adj[tree[i].second].push_back(tree[i].first);
    }

    int root = 0;
    for (int i = 0; i <= n; i ++)
    {
        if (adj[i].size() > adj[root].size())
            root = i;
    }

    trav(root, - 1);

    int cur = root, main_bit = 0;
    vector < bool > data;

    while(true)
    {
        int real_child = (int)(child[cur].size());
        if (real_child == 0)
            break;

        if (cur == root)
            real_child -= MARK_NEC;

            int cnt_fat = 0;
        for (int u : child[cur])
            if (sub[u] > 1)
            cnt_fat ++;

            cout << "stop " << real_child << " " << cnt_fat << endl;
        if (real_child >= 4 && cnt_fat < 3)
        {
            data.push_back(0);
            data.push_back(0);
        }
        else
        if (real_child <= 2 && cnt_fat < 2)
        {
            data.push_back(1);
            data.push_back(0);
        }
        else
        if (real_child >= 2 && real_child <= 3 && cnt_fat <= 2)
        {
            data.push_back(0);
            data.push_back(1);
        }
        else
        {
            data.push_back(1);
            data.push_back(1);
        }


        int to = child[cur][0];
        for (int u : child[cur])
        {
            if (sub[u] > sub[to])
                to = u;
        }
        cur = to;
    }

    return data;

}
