#include "tunnels.h"
#include<bits/stdc++.h>

using namespace std;

int n,m,k;

void solve(int _n, int _m, int _k, const std::vector<std::vector<bool>>& blocked)
{
    n=_n; m=_m; k=_k;

    int cur=k;
    for(int lvl=0;lvl<n;lvl++)
    {
        int l=cur,r=cur;
        for(int i=cur-1;i>=0;i--)
        {
            if(blocked[lvl][i])
            {
                l=i+1;
                break;
            }
            if(i==0) l=0;
        }
        for(int i=cur+1;i<m;i++)
        {
            if(blocked[lvl][i])
            {
                r=i-1;
                break;
            }
            if(i==m-1) r=m-1;
        }
//cout<<lvl<<": "<<l<<" "<<r<<" - ";
        vector<int> pos;
        for(int i=l;i<=r;i++)
        {
            if(lvl<n-1)
            {
                if(!blocked[lvl+1][i]) pos.push_back(i);
            }
            else pos.push_back(i);
        }
        
        int sz=pos.size();
        if(sz==1)
        {
            goDeeper(pos[0]);
            continue;
        }
        int ind=sz-1;
        for(int i=0;i<sz-1;i++)
        {
            if(pos[i]<=cur && cur<pos[i+1])
            {
                ind=i;
                break;
            }
        }
        int l1=0, r1=ind;
        int l2=ind+1, r2=sz-1;
        bool fl=0;
        while(1)
        {
            if(fl) break;
            int len1=r1-l1+1;
            int len2=r2-l2+1;
            if(len1==0 && len2==1)
            {
                goDeeper(pos[l2]);
                break;
            }
            if(len1==1 && len2==0)
            {
                goDeeper(pos[l1]);
                break;
            }
            if(len1>=len2)
            {
                if(l1==r1)
                {
                    if(investigate(pos[l1]))
                    {
                        goDeeper(pos[l1]);
                        fl=1;
                        continue;
                    }
                    else l1=r1+1;
                    continue;
                }
                int mid=(l1+r1)/2;
                if(investigate(pos[mid])) r1=mid;
                else l1=mid+1;
            }
            else
            {
                if(l2==r2)
                {
                    if(investigate(pos[l2]))
                    {
                        goDeeper(pos[l2]);
                        fl=1;
                        continue;
                    }
                    else l2=r2+1;
                    continue;
                }
                int mid=(l2+r2+1)/2;
                if(investigate(pos[mid])) l2=mid;
                else r2=mid-1;
            }
        }
    }
}