#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

const int MAXN=3e5+5;
const int B=500;

int n,q;
int a[MAXN];
int b[MAXN];
int cnt[MAXN/B+5][MAXN];
int offset[MAXN/B+5];
vector<int> pos[MAXN];
int ind[MAXN];
int vals[MAXN];
long long ans=0;

void update(int l,int r,int x)
{
    int bl=l/B;
    int br=r/B;
    if(bl==br)
    {
        for(int i=l;i<=r;i++)
        {
            cnt[bl][vals[i]]--;
            vals[i]+=x;
            cnt[bl][vals[i]]++;
        }
        return;
    }
    for(int i=bl+1;i<=br-1;i++)
    {
        offset[i]+=x;
    }
    for(int i=l;i<(bl+1)*B;i++)
    {
        cnt[bl][vals[i]]--;
        vals[i]+=x;
        cnt[bl][vals[i]]++;
    }
    for(int i=br*B;i<=r;i++)
    {
        cnt[br][vals[i]]--;
        vals[i]+=x;
        cnt[br][vals[i]]++;
    }
}

int query1(int r,int n1)
{
    int ret=0;
    int br=r/B;
    for(int i=br*B;i<=r;i++)
    {
        if(vals[i]+offset[br]==n1) ret++;
        //cout<<vals[i]+offset[br]<<" ";
    }
    //cout<<endl;
    for(int i=0;i<br;i++)
    {
        ret+=cnt[i][n1-offset[i]];
    }
    return ret;
}

void init(int _n,int _q,const std::vector<int>& a1)
{
    n=_n;
    q=_q;
    for(int i=0;i<n;i++) b[i]=a1[i];
}

long long query(int l,int r)
{   
    int n1=r-l+1;
    for(int i=l;i<=r;i++) a[i-l]=b[i];
    for(int i=0;i<n;i++) pos[i].clear();
    for(int i=0;i*B<n1;i++) offset[i]=0;
    for(int i=0;i<n1;i++)
    {
        pos[a[i]].push_back(i);
        ind[i]=pos[a[i]].size()-1;
    }
    for(int i=0;i<n1;i++)
    {
        vals[i]=n1;
    }
    for(int i=0;i*B<n1;i++)
    {
        for(int j=0;j<n1;j++) cnt[i][j]=0;
        cnt[i][n1]=min((i+1)*B,n)-i*B;
    }

ans=0;
    for(int i=0;i<n1;i++)
    {
        int x=a[i];
        int idx=ind[i];
        if(x==1)
        {
            if(idx==0) 
            {
                ans+=query1(i,n1);
                continue;
            }
            int r=pos[x][idx-1];
            int l=(idx-2>=0 ? (pos[x][idx-2]+1) : 0);
            update(l,r,-1);
        }
        else
        {
            int r=pos[x][idx];
            int l=(idx>0 ? (pos[x][idx-1]+1) : 0);
            update(l,r,-1);
            int prv=idx-x+1;
            if(prv>=0)
            {
                r=pos[x][prv];
                l=(prv>0 ? (pos[x][prv-1]+1) : 0);
                update(l,r,1);
            }
            prv--;
            if(prv>=0)
            {
                r=pos[x][prv];
                l=(prv>0 ? (pos[x][prv-1]+1) : 0);
                update(l,r,-1);
            }
        }
        //for(int j=0;j<n;j++) cout<<vals[j]<<" "; cout<<endl;
        ans+=query1(i,n1);
    }

    return ans;
}