#include<iostream>
#include "tunnels.h"
using namespace std;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper(k);

    int l,r,mid,p=k,j;
    for(int i=1;i<n;i++)
    {
        if(p>0 && !blocked[i][p-1] && investigate(p-1))
        {
            for(j=p-2;j>=0;j--)
                if(blocked[i][j])
                 break;
            j++;

            l=j;r=p-1;
        }
        else
        {
            for(j=p;j<=n-1;j++)
                if(blocked[i][j])
                 break;
            j--;
            l=p;r=j;
        }
        while(l<=r)
        {
            mid=(l+r)/2;
            if(!investigate(mid))
                l=mid+1;
            else
                r=mid-1;
        }
        goDeeper(l);
        p=l;
    }
    return;
}
