#include<iostream>
#include "bits_and_tree.h"
#include<algorithm>
using namespace std;
vector<int> v[5005];
vector<bool> b;
int t;
std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    std::vector<std::pair<int, int>> r;

    for(int i=1;i<=6;i++)
    r.push_back({0,i});

    int p=6,ind=0,i=6;
    for(i=p;i<=n-1 && ind<data.size();i++)
    { //cout<<i<<" "<<ind<<" "<<data[ind]<<endl;
        if(data[ind]==0)
        {
            if(i+1>n-1) break;
            i++;
            r.push_back({p,i});
            p=i;
            ind++;i--;
            continue;
        }
        if(data[ind]==1)
        {
            if(i+1>n-1) break;
            i++;
            r.push_back({p,i});

            if(i+1>n-1) break;
            i++;
            r.push_back({p,i});

            if(i+1>n-1) break;
            i++;
            r.push_back({p,i});
            p=i;
            ind++;i--;
            continue;
        }
    }
    /*for(int j=0;j<r.size();j++)
        cout<<r[j].first<<" "<<r[j].second<<endl;
*/
    return r;
}
bool cmp(int v1,int v2)
{
    return (v[v1].size()<v[v2].size());
}
void dfssort(int vr,int par)
{
    sort(v[vr].begin(),v[vr].end(),cmp);

    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i]==par)
            continue;

        dfssort(v[vr][i],vr);
    }
}
void dfs(int vr,int par, int pos)
{
    if(pos>=t) return;
   // cout<<vr<< " "<<par<<" "<<pos<<endl;

    if(v[vr].size()==1) return;

    if(v[vr].size()>=6)
    {
       for(int i=0;i<v[vr].size();i++)
       {
         dfs(v[vr][i],vr,pos);
       }
       return;
    }

    if(v[vr].size()==4 || v[vr].size()==5)
        b[pos]=1;
    if((v[vr].size()==3 || v[vr].size()==2))
        b[pos]=0;

    for(int i=0;i<v[vr].size();i++)
    {
        if(v[vr][i]==par)
            continue;

        dfs(v[vr][i],vr,pos+1);
    }
}
std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    t=2*n;
    b.resize(2*n,0);

   /* for(int j=0;j<tree.size();j++)
        cout<<tree[j].first<<" "<<tree[j].second<<endl;
        */

    for(int i=0;i<=2*n;i++)
    v[i].clear();

    for(int i=0;i<tree.size();i++)
    {
        v[tree[i].first].push_back(tree[i].second);
        v[tree[i].second].push_back(tree[i].first);
    }
    int root=0;
    for(int i=0;i<=n;i++)
    {
        if(v[i].size()==6 || v[i].size()==7)
        {
            root=i;
            break;
        }
    }
    dfssort(root,-1);

   /* int par=root,r2=root,siz=1;
    for(int j=0;j<v[root].size();j++)
    {
        if(v[v[root][j]].size()>siz)
        {
            siz=v[v[root][j]].size();
            r2=v[root][j];
            //cout<<"*";
        }
    }
    root=r2;
    */

    dfs(root,-1,0);

    /*for(int i=0;i<b.size();i++)
        cout<<b[i];cout<<endl;
        */
    return b;
}
/*
1
15 30 110101011011010101101101010110
*/
