#include"tunnels.h"
#include<bits/stdc++.h>
using namespace std;
#define MAXN 5007
bool bl[MAXN][MAXN];
bool pos[MAXN][MAXN];
bool apos[MAXN][MAXN];
int mry[MAXN][MAXN];
bool query(int red, int kolona)
{
    if (mry[red][kolona]==0)
    {
        bool toi=investigate(kolona);
        if (toi) mry[red][kolona]=2;
        else mry[red][kolona]=1;
        return toi;
    }
    if (mry[red][kolona]==2) return 1;
    return 0;
}
int numComp(int lgr, int rgr, int red)
{
    int br=0;
    for (int q=lgr;q<=rgr;q++)
    {
        if (q!=lgr && pos[red][q]==0 && pos[red][q-1]==1) br++;
    }
    if (pos[red][rgr]==1) br++;
    return br;
}
int n,m,k;
void solve(int N, int M, int K, const vector<vector<bool>>& blocked)
{
    n=N;
    m=M;
    k=K;
    for (int q=0;q<n;q++)
    {
        for (int w=0;w<m;w++) bl[q][w]=blocked[q][w];
    }
    for (int w=0;w<m;w++) pos[n-1][w]=!blocked[n-1][w];
    for (int w=0;w<m;w++) apos[n-1][w]=!blocked[n-1][w];
    for (int q=n-2;q>=0;q--)
    {
        for (int w=0;w<m;w++) pos[q][w]=apos[q+1][w];
        for (int w=0;w<m;w++)
        {
            if (w!=0 && bl[q][w]==1 && bl[q][w-1]==0)
            {
                bool dali=false;
                for (int e=w-1;e>=0;e--)
                {
                    if (pos[q][e]) dali=true;
                    if (bl[q][e]==1) break;
                }
                for (int e=w-1;e>=0;e--)
                {
                    apos[q][e]=dali;
                    if (bl[q][e]==1) break;
                }
            }
        }
        if (bl[q][n-1]==0)
        {
            bool dali=false;
            for (int e=n-1;e>=0;e--)
            {
                if (pos[q][e]) dali=true;
                if (bl[q][e]==1) break;
            }
            for (int e=n-1;e>=0;e--)
            {
                apos[q][e]=dali;
                if (bl[q][e]==1) break;
            }
        }
        for(int w=0;w<m;w++)
        {
            if (bl[q][w])
            {
                pos[q][w]=0;
                apos[q][w]=0;
            }
        }
    }
    /*for (int q=0;q<n;q++)
    {
        for (int w=0;w<m;w++) cout<<pos[q][w]<<" ";
        cout<<"\n";
    }*/
    for (int red=0;red<n;red++)
    {
        int lgr=k;
        for (int w=k;w>=0;w--)
        {
            if (bl[red][w]) break;
            lgr=w;
        }
        int rgr=k;
        for (int w=k;w<m;w++)
        {
            if (bl[red][w]) break;
            rgr=w;
        }
        //cout<<lgr<<" "<<rgr<<"\n";
        if (numComp(lgr,rgr,red)==1)
        {
            int ll,rr;
            for (int w=lgr;w<=rgr;w++)
            {
                if (pos[red][w]) rr=w;
            }
            for (int w=rgr;w>=lgr;w--)
            {
                if (pos[red][w]) ll=w;
            }
            if (ll>=k)
            {
                rr++;
                while (ll<rr-1)
                {
                    int mid=(ll+rr)/2;
                    if (query(red,mid)) ll=mid;
                    else rr=mid;
                }
                k=ll;
                goDeeper(k);
                continue;
            }
            if (rr<=k)
            {
                ll--;
                while (ll<rr-1)
                {
                    int mid=(ll+rr)/2;
                    if (query(red,mid)) rr=mid;
                    else ll=mid;
                }
                k=rr;
                goDeeper(k);
                continue;
            }
            if (query(red,k+1))
            {
                lgr=k+1;
                rr++;
                while (ll<rr-1)
                {
                    int mid=(ll+rr)/2;
                    if (query(red,mid)) ll=mid;
                    else rr=mid;
                }
                k=ll;
                goDeeper(k);
                continue;
            }
            else
            {
                rgr=k;
                ll--;
                while (ll<rr-1)
                {
                    int mid=(ll+rr)/2;
                    if (query(red,mid)) rr=mid;
                    else ll=mid;
                }
                k=rr;
                goDeeper(k);
                continue;
            }
        }
    }
}
