#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

const int nmax = 5000;
const int oo = INT_MAX;

bool sel[nmax + 5][nmax + 5];

int l[nmax + 5], lpoz[nmax + 5];
int dp[nmax + 5][nmax + 5], dpoz[nmax + 5][nmax + 5];

int dx[] = {-1, 0, 0};
int dy[] = {0, 1, -1};

void precalc(int n)
{
    for(int len=1;len<=n;len++)
    {
        l[len] = oo;
        for(int inv=1;inv<=len;inv++)
        {
            if(max(l[inv - 1], l[len - inv]) + 1 < l[len])
            {
                l[len] = max(l[inv - 1], l[len - inv]) + 1;
                lpoz[len] = inv;
            }
        }
    }
    for(int len=1;len<=n;len++)
    {
        for(int poz=1;poz<=len;poz++)
        {
            dp[len][poz] = oo;
            if(len == 1)
            {
                dp[len][poz] = 0;
                dpoz[len][poz] = 1;
                continue;
            }
            for(int inv=1;inv<poz;inv++)
            {
                if(max(l[inv - 1], dp[len - inv][poz - inv]) + 1 < dp[len][poz])
                {
                    dp[len][poz] = max(l[inv - 1], dp[len - inv][poz - inv]) + 1;
                    dpoz[len][poz] = inv;
                }
            }
            for(int inv=poz+1;inv<=len;inv++)
            {
                if(max(dp[inv - 1][poz], l[len - inv]) + 1 < dp[len][poz])
                {
                    dp[len][poz] = max(dp[inv - 1][poz], l[len - inv]) + 1;
                    dpoz[len][poz] = inv;
                }
            }
        }
    }
}

void solve(int n, int m, int k, const vector<vector<bool>> &blocked)
{
    for(int j=0;j<m;j++)
    {
        sel[n][j] =  true;
    }
    for(int i=n-1;i>=0;i--)
    {
        for(int j=0;j<m;j++)
        {
            sel[i][j] = false;
            if(blocked[i][j])
            {
                continue;
            }
            if(sel[i + 1][j])
            {
                sel[i][j] = true;
                continue;
            }
            if(blocked[i + 1][j])
            {
                continue;
            }
            int poz = j;
            while(poz > 0 && !blocked[i + 1][poz - 1])
            {
                --poz;
                if(sel[i + 1][poz])
                {
                    sel[i][j] = true;
                    break;
                }
            }
            poz = j;
            while(poz < m - 1 && !blocked[i + 1][poz + 1])
            {
                ++poz;
                if(sel[i + 1][poz])
                {
                    sel[i][j] = true;
                    break;
                }
            }
        }
    }
    precalc(m);
    int l = 0, c = k;
    for(int i=1; i<=n; i++)
    {
        int st = c, dr = c;
        while(st > 0 && sel[l][st - 1])
        {
            --st;
        }
        while(dr < m - 1 && sel[l][dr + 1])
        {
            ++dr;
        }
        while(st < dr)
        {
            if(st <= c && c <= dr)
            {
                int len = dr - st + 1;
                int poz = c - st + 1;
                int inv = dpoz[len][poz] + st - 1;
                bool ok = investigate(inv);
                if(ok)
                {
                    if(inv < c)
                    {
                        st = inv + 1;
                    }
                    else
                    {
                        dr = inv - 1;
                    }
                }
                else
                {
                    if(inv < c)
                    {
                        dr = inv - 1;
                    }
                    else
                    {
                        st = inv + 1;
                    }
                }
            }
            else
            {
                int len = dr - st + 1;
                int inv = lpoz[len];
                if(c < st)
                {
                    inv = inv + st - 1;
                }
                else
                {
                    inv = dr - inv + 1;
                }
                bool ok = investigate(inv);
                if(ok)
                {
                    if(c > dr)
                    {
                        st = inv + 1;
                    }
                    else
                    {
                        dr = inv - 1;
                    }
                }
                else
                {
                    if(c > dr)
                    {
                        dr = inv - 1;
                    }
                    else
                    {
                        st = inv + 1;
                    }
                }
            }
        }
        goDeeper(st);
        c = st;
        ++l;
    }
}
