#include <bits/stdc++.h>

using namespace std;

const int nmax = 5e5;
const int Mod = 666013;

mt19937 my_rand(0);

int n;
int v[nmax + 5];
int p[nmax + 5];

int h[nmax + 5];
int fr[nmax + 5];

int u[nmax + 5];

queue<int> q[nmax + 5];

vector<int> l[Mod + 5];

int ai[4 * nmax + 5];

long long rez = 0;

int lgput(int a, int b)
{
    int p = 1;
    while(b)
    {
        if(b % 2 == 0)
        {
            b /= 2;
            a = 1LL * a * a % Mod;
        }
        else
        {
            --b;
            p = 1LL * p * a % Mod;
        }
    }
    return p;
}

void update(int poz, int val, int nod, int a, int b)
{
    if(a == b)
    {
        ai[nod] = val;
        return;
    }
    int mij = (a + b) >> 1;
    if(poz <= mij)
    {
        update(poz, val, nod * 2, a, mij);
    }
    else
    {
        update(poz, val, nod * 2 + 1, mij + 1, b);
    }
    ai[nod] = max(ai[nod * 2], ai[nod *2 + 1]);
}

void init(int N, int Q, const vector<int> &a)
{
    n = N;
    for(int i=1;i<=n;i++)
    {
        v[i] = a[i - 1];
    }
    for(int i=1;i<=n;i++)
    {
        p[i] = 1 + my_rand() % (Mod - 1);
    }
    h[0] = 0;
    for(int i=1;i<=n;i++)
    {
        if(v[i] == 1)
        {
            h[i] = h[i - 1];
            continue;
        }
        h[i] = h[i - 1];
        h[i] = (h[i] - lgput(p[v[i]], fr[v[i]]) + Mod) % Mod;
        ++fr[v[i]];
        if(fr[v[i]] == v[i])
        {
            fr[v[i]] = 0;
        }
        h[i] = (h[i] + lgput(p[v[i]], fr[v[i]])) % Mod;
    }
    for(int i=1;i<=n;i++)
    {
        if(q[v[i]].size() == v[i] + 1)
        {
            q[v[i]].pop();
        }
        q[v[i]].push(i);
        if(q[v[i]].size() == v[i] + 1)
        {
            update(v[i], q[v[i]].front(), 1, 1, n);
        }
        u[i] = ai[1];
    }
    l[0].push_back(0);
    for(int i=1;i<=n;i++)
    {
        int st = 0;
        int dr = (int)(l[h[i]].size()) - 1;
        int poz = dr + 1;
        while(st <= dr)
        {
            int mij = (st + dr) >> 1;
            if(l[h[i]][mij] + 1 > u[i])
            {
                poz = mij;
                dr = mij - 1;
            }
            else
            {
                st = mij + 1;
            }
        }
        rez += (int)(l[h[i]].size()) - poz;
        l[h[i]].push_back(i);
    }
}

long long query(int st, int dr)
{
    return rez;
}
