#include <bits/stdc++.h>

using namespace std;

int n, a[300005];
vector<int> pos[300005];
int f[300005];
int cate;
int ct[300005];
vector<pair<int, int>> sols;

struct aint_node
{
    int mnm = 0, cnt_mnm = 0, lazy = 0, prm = 0;
};

struct query_ans
{
    int mnm, cnt_mnm, cine;
};

aint_node aint[1200005];

void build(int nod, int l, int r)
{
    aint[nod].mnm = 0;
    aint[nod].cnt_mnm = r - l + 1;
    aint[nod].lazy = 0;
    aint[nod].prm = l;
    if (l != r)
    {
        int mij = (l + r) / 2;
        build(2 * nod, l, mij);
        build(2 * nod + 1, mij + 1, r);
    }
}

void prop(int nod, int l, int r)
{
    int lz = aint[nod].lazy;
    aint[nod].lazy = 0;
    if (l == r)
        return;
    aint[2 * nod].mnm += lz;
    aint[2 * nod].lazy += lz;
    aint[2 * nod + 1].mnm += lz;
    aint[2 * nod + 1].lazy += lz;
}

void update(int nod, int l, int r, int st, int dr, int val)
{
    prop(nod, l, r);
    if (r < st or dr < l)
        return;
    if (st <= l and r <= dr)
    {
        aint[nod].mnm += val;
        aint[nod].lazy += val;
        return;
    }
    int mij = (l + r) / 2;
    update(2 * nod, l, mij, st, dr, val);
    update(2 * nod + 1, mij + 1, r, st, dr, val);
    pair<int, int> p1 = {aint[2 * nod].mnm, aint[2 * nod].cnt_mnm}, p2 = {aint[2 * nod + 1].mnm, aint[2 * nod + 1].cnt_mnm};
    if (p1.first < p2.first)
        aint[nod].mnm = p1.first, aint[nod].cnt_mnm = p1.second, aint[nod].prm = aint[2 * nod].prm;
    else if (p1.first > p2.first)
        aint[nod].mnm = p2.first, aint[nod].cnt_mnm = p2.second, aint[nod].prm = aint[2 * nod + 1].prm;
    else
        aint[nod].mnm = p1.first, aint[nod].cnt_mnm = p1.second + p2.second, aint[nod].prm = aint[2 * nod].prm;
}

query_ans query(int nod, int l, int r, int st, int dr)
{
    prop(nod, l, r);
    if (r < st or dr < l)
    {
        query_ans aux;
        aux.mnm = aux.cnt_mnm = aux.cine = 1e9;
        return aux;
    }
    if (st <= l and r <= dr)
    {
        query_ans aux;
        aux.mnm = aint[nod].mnm;
        aux.cnt_mnm = aint[nod].cnt_mnm;
        aux.cine = aint[nod].prm;
        return aux;
    }
    int mij = (l + r) / 2;
    query_ans p1 = query(2 * nod, l, mij, st, dr), p2 = query(2 * nod + 1, mij + 1, r, st, dr);
    if (p1.mnm < p2.mnm)
        return p1;
    else if (p1.mnm > p2.mnm)
        return p2;
    query_ans aux;
    aux = p1;
    aux.cnt_mnm += p2.cnt_mnm;
    return aux;

}

bool cmp_r(pair<int, int> A, pair<int, int> B)
{
    return A.second < B.second;
}

vector<int> roots;
vector<int> vals, ls, rs, fs, fd;

void bld(int nod)
{
    if (ls[nod] == rs[nod])
        return;
    int mij = (ls[nod] + rs[nod]) / 2;
    vals.push_back(0);
    ls.push_back(ls[nod]);
    rs.push_back(mij);
    fs.push_back(0);
    fd.push_back(0);
    fs[nod] = vals.size() - 1;
    bld(fs[nod]);
    vals.push_back(0);
    ls.push_back(mij + 1);
    rs.push_back(rs[nod]);
    fs.push_back(0);
    fd.push_back(0);
    fd[nod] = vals.size() - 1;
    bld(fd[nod]);
}

void init(int N, int Q, const vector<int>& A)
{
    n = N;
    for (int i = 1; i <= n; i++)
        a[i] = A[i - 1];
    for (int i = 1; i <= n; i++)
        pos[a[i]].push_back(i), ct[i] = pos[a[i]].size() - 1;
    build(1, 1, n);
    for (int l = n; l >= 1; l--)
    {
        int cc = ct[l];
        if (cc < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc], n, 1);// cout << "hi " << pos[a[l]][cc] << ' ' << n << ' ' << 1 << endl;
        if (cc + a[l] - 1 < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc + a[l] - 1], n, -1);// cout << "hi " << pos[a[l]][cc + a[l] - 1] << ' ' << n << ' ' << -1 << endl;
        if (cc + a[l] < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc + a[l]], n, 1);// cout << "hi " << pos[a[l]][cc + a[l]] << ' ' << n << ' ' << 1 << endl;
        cc++;
        if (cc < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc], n, -1);// cout << "hi " << pos[a[l]][cc] << ' ' << n << ' ' << -1 << endl;
        if (cc + a[l] - 1 < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc + a[l] - 1], n, 1);// cout << "hi " << pos[a[l]][cc + a[l] - 1] << ' ' << n << ' ' << 1 << endl;
        if (cc + a[l] < pos[a[l]].size())
            update(1, 1, n, pos[a[l]][cc + a[l]], n, -1);// cout << "hi " << pos[a[l]][cc + a[l]] << ' ' << n << ' ' << -1 << endl;
        query_ans pr = query(1, 1, n, l, n);
        //cout << pr.first << ' ' << pr.second << endl;
        if (pr.mnm == 0)
        {
            cate += pr.cnt_mnm;
            int dudeee = pr.cnt_mnm;
            sols.push_back({l, pr.cine});
            for (int nrr = 2; nrr <= dudeee; nrr++)
            {
                pr = query(1, 1, n, pr.cine + 1, n);
                sols.push_back({l, pr.cine});
            }
        }
    }
    sort(sols.begin(), sols.end(), cmp_r);
    roots.push_back(0);
    vals.push_back(0);
    ls.push_back(1);
    rs.push_back(n);
    fs.push_back(0);
    fd.push_back(0);
    bld(0);
    for (int i = 0; i < sols.size(); i++)
    {
        int cp = roots[i];
        vals.push_back(vals[cp]);
        ls.push_back(ls[cp]);
        rs.push_back(rs[cp]);
        fs.push_back(fs[cp]);
        fd.push_back(fd[cp]);
        int nd = vals.size() - 1;
        roots.push_back(nd);
        int pos = sols[i].first;
        while (true)
        {
            vals[nd]++;
            if (ls[nd] == rs[nd])
                break;
            int mij = (ls[nd] + rs[nd]) / 2;
            if (pos <= mij)
            {
                cp = fs[nd];
                vals.push_back(vals[cp]);
                ls.push_back(ls[cp]);
                rs.push_back(rs[cp]);
                fs.push_back(fs[cp]);
                fd.push_back(fd[cp]);
                fs[nd] = vals.size() - 1;
                nd = fs[nd];
            }
            else
            {
                cp = fd[nd];
                vals.push_back(vals[cp]);
                ls.push_back(ls[cp]);
                rs.push_back(rs[cp]);
                fs.push_back(fs[cp]);
                fd.push_back(fd[cp]);
                fd[nd] = vals.size() - 1;
                nd = fd[nd];
            }
        }
    }
}

int qr(int nod, int st, int dr)
{
    if (dr < ls[nod] or rs[nod] < st)
        return 0;
    if (st <= ls[nod] and rs[nod] <= dr)
        return vals[nod];
    return qr(fs[nod], st, dr) + qr(fd[nod], st, dr);
}

int doamne_ajuta(int vers, int L)
{
    int nd = roots[vers];
    return qr(nd, L, n);
}

long long query(int L, int R)
{
    L++;
    R++;
    int st = -1, pas = 1 << 22;
    while (pas != 0)
    {
        if (st + pas < sols.size() and sols[st + pas].second <= R)
            st += pas;
        pas /= 2;
    }
    if (st == -1)
        return 0;
    return doamne_ajuta(st + 1, L);
}

