#include "tunnels.h"
#include <bits/stdc++.h>
std::vector<int>p1,p2,p3;
int dp[5010][2][5010],pozo[5010][2][5010];
void raspunde(int &b,int &e)
{
    int b1=0,e1=p1.size()-1;
    int b2=p2.size();
    int b3=0,e3=p3.size()-1;
    while(1)
    {
        if(e1-b1+1+b2+e3-b3+1==1)
        {
            if(b1==e1)
            {
                b=e=p1[b1];
            }
            if(b2==1)
            {
                b=e=p2[0];
            }
            if(b3==e3)
            {
                b=e=p3[b3];
            }
            return;
        }
        int nr1=e1-b1+1;
        int nr2=b2;
        int nr3=e3-b3+1;
        int q=pozo[nr1][nr2][nr3];
        if(q<=nr1)
        {
            if(investigate(p1[q-1+b1])==0)
                b1+=q;
            else
            {
                e1=q-1+b1;
                b2=0;
                e3=b3-1;
            }
        }
        else if(q<=nr1+nr2)
        {
            exit(-1);
        }
        else
        {
            if(investigate(p3[q-nr1-nr2-1+b3])==0)
                e3=q-nr1-nr2-2+b3;
            else
            {
                e1=b1-1;
                b2=0;
                b3=q-nr1-nr2-1+b3;
            }
        }
    }
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int nre=2;nre<=m;++nre)
    {
        for(int nr1=0;nr1<=nre;++nr1)
            for(int nr2=0;nr2+nr1<=nre&&nr2<=1;++nr2)
            {
                int nr3=nre-nr1-nr2;
                dp[nr1][nr2][nr3]=1000000000;
                for(int q=std::max(0,(nr1+nr2+nr3)/2-10);q<=std::min(nre,(nr1+nr2+nr3)/2+10);++q)
                {
                    if(q<=nr1)
                    {
                        if(dp[nr1][nr2][nr3]>std::max(dp[nr1-q][nr2][nr3],dp[q][0][0]))
                        {
                            dp[nr1][nr2][nr3]=std::max(dp[nr1-q][nr2][nr3],dp[q][0][0]);
                            pozo[nr1][nr2][nr3]=q;
                        }
                    }
                    else if(q<=nr1+nr2)
                    {
                        continue;
                    }
                    else
                    {
                        if(dp[nr1][nr2][nr3]>std::max(dp[0][0][nre-q+1],dp[nr1][nr2][q-nr1-nr2-1]))
                        {
                            dp[nr1][nr2][nr3]=std::max(dp[0][0][nre-q+1],dp[nr1][nr2][q-nr1-nr2-1]);
                            pozo[nr1][nr2][nr3]=q;
                        }
                    }
                }
                ++dp[nr1][nr2][nr3];
            }
    }
    int b=k,e=k;
    for(int lin=0;lin<n;++lin)
    {
        p1.clear();
        p2.clear();
        p3.clear();
        k=b;
        if(lin==n-1||blocked[lin+1][b]==0)
            p2.push_back(b);
        while(b>0&&blocked[lin][b-1]==0)
        {
            --b;
        }
        for(int i=b;i<k;++i)
            if(lin==n-1||blocked[lin+1][i]==0)
                p1.push_back(i);
        while(e<m-1&&blocked[lin][e+1]==0)
        {
            ++e;
            if(lin==n-1||blocked[lin+1][e]==0)
                p3.push_back(e);
        }
        raspunde(b,e);
        k=b;
        goDeeper(k);
    }
}

static int n, m, k;
static std::vector<std::vector<bool>> blocked;

static void input()
{
    std::cin >> n >> m >> k;

    blocked.resize(n);
    for (int i = 0; i < n; i++)
    {
        blocked[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}

static int numQueries = 0;

static int currX;
static int currY;

static void goTo(int y)
{
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;

    while (currY != y)
    {
        if (currY < y) currY++;
        else currY--;

        if (blocked[currX][currY])
        {
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}

bool investigate(int y)
{
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}

void goDeeper(int y)
{
    std::cout << "Going deeper: " << y << std::endl;

    if (currX == n)
    {
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }

    goTo(y);
    currX++;

    if (currX == n) return;

    if (blocked[currX][currY])
    {
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}

int main()
{
    input();

    currX = 0;
    currY = k;

    if (blocked[currX][currY])
    {
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }

    solve(n, m, k, blocked);

    if (currX < n)
    {
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }

    std::cout << "Reached the treasure room." << std::endl;

    std::cout << "Number of investigations: " << numQueries << std::endl;

    return 0;
}
