#include<bits/stdc++.h>
#include "tunnels.h"
using namespace std;
const int N = 4e2;
const int inf = 1e9;
array<int, 3> dp[N][N][N];
int l[N], r[N];
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    for(int q = n - 1;q >= 0;q--){
        /// RESET
        for(int i = 0;i < m;i++){
            for(int j = i + 1;j < m;j++){
                dp[q][i][j] = {inf, -1, -1};
            }
            if(q == n - 1){
                dp[q][i][i] = {0, -1, -1};
            }
        }
        for(int j = 0;j < m;j++){
            if(blocked[q + 1][j]){
                dp[q][j][j] = {inf, -1, -1};
            }
            if(blocked[q][j]){
                dp[q][j][j] = {inf, -1, -1};
            }
        }
        for(int j = 0;j < m;j++){
            if(blocked[q][j]){
                l[j] = j;
                r[j] = j;
            }else{
                l[j] = (j == 0?-1:l[j - 1]);
            }
        }
        for(int j = m - 1;j >= 0;j--){
            if(blocked[q][j]){
                r[j] = j;
            }else{
                r[j] = ((j == m - 1)?m:r[j + 1]);
            }
        }
        for(int _i = 1;_i < m;_i++){
            for(int _j = 0;_i + _j < m;_j++){
                int i = _j;
                int j = _i + _j;
                /// from i to j
                if(blocked[q + 1][j]){
                    dp[q][i][j] = min(dp[q][i][j], {dp[q][i][j - 1][0], i, j - 1});
                }
                if(blocked[q + 1][i]){
                    dp[q][i][j] = min(dp[q][i][j], {dp[q][i + 1][j][0], i + 1, j});
                }
                for(int p = i;p < j;p++){
                    dp[q][i][j] = min(dp[q][i][j], max(array<int,3>{dp[q][i][p][0], p, -1}, array<int,3>{dp[q][p + 1][j][0], p, -1}));
                }
            }
        }
        if(q != 0){
            for(int i = 0;i < m;i++){
                dp[q - 1][i][i] = {dp[q][l[i] + 1][r[i] - 1][0], l[i] + 1, r[i] - 1};
            }
        }
    }
    int pos = 0, x = l[k] + 1, y = r[k] - 1;
    int loc = k;
    while(x != -1 && y != -1){
        int nx, ny;
        if(x == y){
            pos++;
            nx = dp[pos - 1][x][y][1];
            ny = dp[pos - 1][x][y][2];
            goDeeper(x);
            loc = x;
            /// no investigation
        }else if(dp[pos][x][y][2] != -1){
            nx = dp[pos][x][y][1];
            ny = dp[pos][x][y][2];
            /// move back
        }else{
            int r = 0, z = dp[pos][x][y][1];
            nx = x;ny = y;
            if(loc <= z){
                r = investigate(z + 1);
                if(r == 0){
                    ny = z;
                }else{
                    nx = z + 1;
                }
            }else{
                r = investigate(z);
                if(r == 0){
                    ny = z;
                }else{
                    nx = z + 1;
                }
            }
        }
        x = nx;
        y = ny;
    }
};
