#include "tunnels.h"
#include <iostream>
#include <vector>
#include <tuple>
#include <functional>
#include <cassert>
#include <map>
#include <set>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;


map<int, int> atr;
void query(int a) {
   if(atr.count(a)) return atr[a];
   return atr[a] = investigate(a);
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
   for(int i = 0; i < n; i++) {
      int l = 0, r = m - 1;
      while(l < r) {
	 int mid = (l + r) >> 1;
	 if(mid == k) {
	    if(mid == 0) mid++;
	    else if(mid == n - 1) mid--;
	    else if(r - mid < l - mid) mid--;
	    else mid++;
	 }
	 if(query(mid)) {
	    if(mid < k) r = mid;
	    else l = mid;
	 }
	 else {
	    if(mid < k) l = mid + 1;
	    else r = mid - 1;
	 }
      }
      goDeeper(l);
      k = l;
      atr.clear();
   }
   return;
   
}
