#include <bits/stdc++.h>
using namespace std;
#define pii pair<int, int>
const int NMAX = 200;
const int K = 60;

vector<pii> encode( int n, vector<bool> data ) {
  int node = 0, cnt, i, pos, aux;
  vector <pii> edg;
  for( i = 1; i <= 6; i++ )
    edg.push_back( pii{ 0, i } );
  cnt = 7;
  node = 1;
  pos = 0;
  while( cnt <= NMAX - 5 ) {
    if( data[pos] == 0 ) {
      edg.push_back( { node, cnt } );
      node = cnt;
      cnt++;
    }
    else {
      edg.push_back( { node, cnt } );
      aux = cnt, cnt++;
      edg.push_back( { node, cnt++ } );
      edg.push_back( { node, cnt++ } );
      node = aux;
    }
    pos++;
  }
  while( cnt < NMAX ) {
    edg.push_back( { node, cnt } );
    node = cnt, cnt++;
  }
  //for( auto x: edg )
    //cout << x.first << " " << x.second << "\n";
  return edg;
}

vector<int> edges[NMAX+1];
int sz[NMAX+1], parent[NMAX+1];
void dfs( int node, int par = -1 ) {
  sz[node] = 1;
  parent[node] = par;
  for( auto vec: edges[node] ) {
    if( vec != par ) {
      dfs( vec, node );
      sz[node] += sz[vec];
    }
  }
}

vector<bool> decode( int n, vector<pii> data ) {
  int root = 0, a, b, i;
  vector<bool> ans;
  for( i = 0; i <= n; i++ )
    edges[i].clear();
  for( i = 0; i < n; i++ ) {
    a = data[i].first, b = data[i].second;
    edges[a].push_back( b );
    edges[b].push_back( a );
  }
  while( root <= n && edges[root].size() <= 5 )
    root++;
  dfs( root );
  while( root != -1 ) {
    vector<pii> v;
    if( edges[root].size() <= 3 )
      ans.push_back( 0 );
    else if( edges[root].size() <= 5 )
      ans.push_back( 1 );
    for( auto vec: edges[root] ) {
      if( vec != parent[root] ) {
        v.push_back( { vec, sz[vec] } );
        //if( i == 0 )
          //cout << vec << " " << sz[vec] << "\n";
      }
    }
    sort( v.begin(), v.end(), []( pii a, pii b ) {
        return a.second > b.second || ( a.second == b.second && a.first < b.first );
    } );
    if( v.size() && v[0].first < NMAX )
      root = v[0].first;
    else
      root = -1;
  }
  while( ans.size() < 2 * NMAX )
    ans.push_back( 0 );
  return ans;
}
