#include<iostream>
#include<cassert>
#include "tunnels.h"
using namespace std;
const int INF = 1e9;
int n,m;
/*bool isfree[5005][5005],blocked[5005][5005];
void dfs(int lin, int col)
{
    assert(!isfree[lin][col]);

    //cerr<<lin<<" "<<col<<" se ocupa\n";

    isfree[lin][col] = 1;
    if(col+1 < m && !isfree[lin][col+1] && !blocked[lin][col+1])
        dfs(lin,col+1);
    if(col-1 >= 0 && !isfree[lin][col-1] && !blocked[lin][col-1])
        dfs(lin,col-1);
    if(lin-1 >= 0 && !isfree[lin-1][col] && !blocked[lin-1][col])
        dfs(lin-1,col);
}
int dp[405][405][405];
int first_query[405][405][405];
pair<int,int> simplif(int lin, int le, int ri)
{
    int newle=le,newri=ri;
    while(!isfree[lin+1][newle] || !isfree[lin][newle])
        newle++;
    while(!isfree[lin+1][newri] || !isfree[lin][newri])
        newri--;
    return {newle,newri};
}
int calc_dp(int lin, int s)
{
    for(int i=0;i<m;i++)
        dp[lin][i][i] = -INF;
    int sle=s,sri=s;
    for(int i=s;i<m;i++)
    {
        if(!isfree[lin][i])
            break;
        sri = i;
        if(isfree[lin+1][i])
            dp[lin][i][i]=0;
    }
    for(int i=s;i>=0;i--)
    {
        if(!isfree[lin][i])
            break;
        sle = i;
        if(isfree[lin+1][i])
            dp[lin][i][i]=0;
    }
    for(int lun=2;lun<=m;lun++)
    {
        for(int le=sle;le+lun-1<=sri;le++)
        {
            int ri = le+lun-1;
            dp[lin][le][ri] = INF;
            first_query[lin][le][ri] = -1;

            auto [newle,newri] = simplif(lin,le,ri);

            if(newle > newri)
            {
                dp[lin][le][ri] = -INF;
                continue;
            }

            if(le!=newle || ri!=newri)
            {
                dp[lin][le][ri] = dp[newle][newri];
                continue;
            }

            assert(le==newle);
            assert(ri==newri);
            for(int f=le;f<=ri;f++)
            {
                if(f==s)
                    continue;
                int aux=INF;
                if(f > s)
                {
                    if(f>le) aux = max(dp[le][f-1], dp[f][ri]) + 1;
                }
                else
                {
                    assert(f < s);
                    if(f<ri) aux = max(dp[le][f], dp[f+1][ri]) + 1;
                }
                if(aux < dp[le][ri])
                {
                    dp[le][ri] = aux;
                    first_query[le][ri] = f;
                }
            }
            assert(first_query[le][ri] != -1);
        }
    }
}*/
int dp[5005][5005],unde[5005][5005];///dp[lun][s]
void solve(int copn, int copm, int k, const std::vector<std::vector<bool>>& cop_blocked)
{
    n = copn;
    m = copm;

    dp[1][1] = dp[1][0] = dp[1][2] = 0;
    for(int lun=2;lun<=m;lun++)
    {
        for(int s=0;s<=lun+1;s++)
        {
            int mij=lun/2;
            dp[lun][s] = INF;
            unde[lun][s] = -1;
            for(int f=max(1,mij-5);f<=min(lun,mij+5);f++)
            {
                if(f==s)
                    continue;
                int aux=INF;
                if(f < s)
                {
                    if(f<lun) aux = max(dp[f][f+1], dp[lun-f][s-f]) + 1;
                }
                else
                {
                    if(f>1) aux = max(dp[lun-f+1][0], dp[f-1][s]) + 1;
                }
                if(aux < dp[lun][s])
                {
                    dp[lun][s] = aux;
                    unde[lun][s] = f;
                }
            }
        }
    }

    for(int i=0;i<n;i++)
    {
        int le=0,ri=m-1,s=k+1;
        while(le<ri)
        {
            int f = unde[ri-le+1][s];
            assert(f != -1);
            bool bl = investigate(le+f-1);
            assert(f != s);
            if(f < s)
            {
                if(bl)
                {
                    ri = le + f - 1;
                    s = ri-le+1 + 1;
                }
                else
                {
                    le = le + f;
                    s = s - f;
                }
            }
            else
            {
                if(bl)
                {
                    le = le + f - 1;
                    s = 0;
                }
                else
                {
                    ri = le + f - 2;
                }
            }
        }

        assert(le==ri);
        goDeeper(le);
        k = le;
    }

    /*for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            blocked[i][j] = cop_blocked[i][j];
    for(int i=0;i<m;i++)
    {
        if(!isfree[n][i])
            dfs(n,i);
    }
    for(int i=n-1;i>=0;i--)
    {
        calc_dp(i,k);
    }*/
}
/**

2 5 2
00000
00000

2 6 2
000010
001000


6 2 0
00
10
00
00
01
00



*/

