#include<iostream>
#include<vector>
#include<cassert>
using namespace std;
#define int long long
const int INF = 1e9;
int n;
long long tot=0;
vector<int> pozs[300005];
int incle[300005];

pair<int,int> combine(pair<int,int> x, pair<int,int> y)
{
    if(x.first < y.first)
        return x;
    if(x.first > y.first)
        return y;
    return {x.first, x.second + y.second};
}
pair<int,int> aint[1100000];
int lazy[1100000];
void propagate(int nod)
{
    if(!lazy[nod])
        return;
    lazy[nod*2] += lazy[nod];
    lazy[nod*2+1] += lazy[nod];
    aint[nod*2].first += lazy[nod];
    aint[nod*2+1].first += lazy[nod];
    lazy[nod]=0;
}
void build(int nod, int st, int dr)
{
    lazy[nod]=0;
    if(st==dr)
    {
        aint[nod] = {0,1};
        return;
    }
    int mij=(st+dr)/2;
    build(nod*2,st,mij);
    build(nod*2+1,mij+1,dr);
    aint[nod] = combine(aint[nod*2], aint[nod*2+1]);
}
void upd(int nod, int st, int dr, int le, int ri, int newv)
{
    if(le>ri)
        return;
    if(le==st && dr==ri)
    {
        aint[nod].first += newv;
        lazy[nod] += newv;
        return;
    }
    propagate(nod);
    int mij=(st+dr)/2;
    upd(nod*2,st,mij,le,min(mij,ri),newv);
    upd(nod*2+1,mij+1,dr,max(mij+1,le),ri,newv);
    aint[nod] = combine(aint[nod*2], aint[nod*2+1]);
}
pair<int,int> qry(int nod, int st, int dr, int le, int ri)
{
    if(le>ri)
        return {INF,0};
    if(le==st && dr==ri)
        return aint[nod];
    propagate(nod);
    int mij=(st+dr)/2;
    return combine(qry(nod*2,st,mij,le,min(mij,ri)),
                   qry(nod*2+1,mij+1,dr,max(mij+1,le),ri));
}

void baga(int le, int ri)
{
    if(le>ri)
        return;
    upd(1,0,n-1,le,ri,+1);
}
void scoate(int le, int ri)
{
    if(le>ri)
        return;
    upd(1,0,n-1,le,ri,-1);
}

void init(int32_t N, int32_t Q, const std::vector<int32_t>& a)
{
    n=N;
    assert(n <= 300000);
    build(1,0,n-1);
    tot=0;
    int maxle=0;
    for(int i=0;i<n;i++)
    {
        assert(a[i]<=n);

        if((int)pozs[a[i]].size() >= a[i])
        {
            scoate(pozs[a[i]][(int)pozs[a[i]].size() - a[i]] + 1, pozs[a[i]].back());
        }
        else if(!pozs[a[i]].empty())
        {
            scoate(0,pozs[a[i]].back());
        }

        pozs[a[i]].push_back(i);

        if((int)pozs[a[i]].size() >= a[i])
        {
            baga(pozs[a[i]][(int)pozs[a[i]].size() - a[i]] + 1, pozs[a[i]].back());
        }
        else
        {
            baga(0,pozs[a[i]].back());
        }

        if((int)pozs[a[i]].size() > a[i])
            maxle = max(maxle, pozs[a[i]][pozs[a[i]].size() - a[i] - 1] + 1);

        incle[i] = maxle;

        pair<int,int> x = qry(1,0,n-1,maxle,i);
        if(x.first==0)
            tot += x.second;
    }
}
long long query(int32_t l, int32_t r)
{
    return tot;
}
/**

7 3
1 2 1 2 3 3 3
0 3
2 6
0 6

*/
