#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

int caut_bin_right(int s, int f)
{
    int l=s, r=f;
    while(l!=r)
    {
        int mid=(l+r+1)/2;
        if(investigate(mid))
            l=mid;
        else
            r=mid-1;
    }
    return l;
}

int caut_bin_left(int s, int f)
{
    int l=s, r=f;
    while(l!=r)
    {
        int mid=(l+r-1)/2;
        if(investigate(mid))
            l=mid;
        else
            r=mid+1;
    }
    return l;
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int cp=k;
    for(int i=0;i<n;i++)
    {
        //determine search interval from current level
        int fr=cp, fl=cp;
        while(fr+1<m && !blocked[i][fr+1])
            fr++;
        while(fl-1>=0 && !blocked[i][fl-1])
            fl--;
        if(i<n-1)
        {
            //determine search interval from level below
            while(blocked[i+1][fl])
                fl++;
            while(blocked[i+1][fr])
                fr--;
        }
        //cout<<fl<<" "<<fr<<'\n';
        if(cp<=fl)
        {
            //cp<=fl<=fr
            cp=caut_bin_right(fl, fr);
        }
        else if(fr<=cp)
        {
            //fr<=fr<=cp
            cp=caut_bin_left(fr, fl);
        }
        else
        {
            //fl<cp<fr
            if(investigate(cp-1))
                cp=caut_bin_left(cp-1, fl);
            else
                cp=caut_bin_right(cp, fr);
        }
        goDeeper(cp);
    }
}