#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

/*#include <iostream>
#include <algorithm>
#include <random>
#include <cassert>*/

using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int, int>> tree;
    int i=0, prev=-1, curr=0, add=4+2*data[0];
    while(curr+3*add<n)
    {
        for(int i=curr+1;i<=curr+add;i++)
            tree.push_back({curr, i});
        prev=curr;
        curr+=add;
        if(i==0)
            add--;
        i++;
        add+=2*(data[i]-data[i-1]);
    }
    for(int i=curr+1;i<=min(n-1, curr+4);i++)
        tree.push_back({prev, i});
    curr+=4;
    int un=1;
    while(curr<n-1)
    {
        curr++;
        tree.push_back({un, curr});
        un=curr;
    }
    //for(auto p:tree)
    //    cout<<p.first<<" "<<p.second<<'\n';
    return tree;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector<int> adj[n+5];
    vector<bool> ans;
    for(auto p:tree)
    {
        adj[p.first].push_back(p.second);
        adj[p.second].push_back(p.first);
    }
    int maxg=0, curn, prev;
    for(int i=0;i<=n;i++)
        if((int)adj[i].size()>maxg)
        {
            maxg=adj[i].size();
            curn=i;
        }
    ans.push_back((maxg%4-maxg%2)/2);
    prev=curn;
    while(true)
    {
        int ncur=-1;
        for(auto x:adj[curn])
            if(4<=(int)adj[x].size() && x!=prev)
                ncur=x;
        if(ncur==-1)
            break;
        prev=curn;
        curn=ncur;
        int deg=adj[ncur].size();
        ans.push_back((deg%4-deg%2)/2);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}