#include <bits/stdc++.h>

using namespace std;

const int NMAX = 200;
int N;
vector <pair<int, int>> muchii;

int curNodes = 1;

int addNodes( int node, int cntNodes = 1 ) {
    while ( curNodes < N && cntNodes > 0 ) {
        muchii.push_back( {node, curNodes++} );
        cntNodes --;
    }
    return curNodes - 1;
}
std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
    int current = 0;
    N = n;
    if ( data[0] == 0 ) {
        current = addNodes( current, 7 );
    } else {
        current = addNodes( current, 9 );
    }
    for ( int i = 1; i < (int)data.size(); i ++ ) {
        if ( data[i] == 0 ) {
            addNodes( current, 2 );
        }
        current = addNodes( current );
    }

    return muchii;
}


vector <int> edges[NMAX + 1];
int subsize[NMAX + 1];
int nxt[NMAX + 1];

void dfs( int node, int p = -1 ) {
    subsize[node] = 1;
    for ( auto vec : edges[node] ) {
        if ( vec != p ) {
            dfs( vec, node );
            subsize[node] += subsize[vec];
            if ( nxt[node] == -1 || subsize[vec] > subsize[nxt[node]] ) nxt[node] = vec;
        }
    }
}
std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
    for ( int i = 0; i <= n; i ++ ) {
        nxt[i] = -1;
        edges[i].clear();
    }
    int heavyCh = 0;
    for ( auto p : tree ) {
        edges[p.first].push_back( p.second );
        edges[p.second].push_back( p.first );
    }
    int cnt = 0;
    for ( int i = 0; i <= n; i ++ ) {
        if ( edges[i].size() >= 6 ) cnt ++;
        if ( edges[i].size() >= edges[heavyCh].size() ) {
            heavyCh = i;
        }
    }
    if ( cnt >= 2 ) assert( false );
    vector <bool> ans;
    dfs( heavyCh );

    if ( edges[heavyCh].size() <= 8 ) ans.push_back( 0 );
    else ans.push_back( 1 );

    int currentNode = nxt[heavyCh];
    while ( currentNode != -1 ) {
        if ( edges[currentNode].size() >= 4 ) ans.push_back( 0 );
        else ans.push_back( 1 );
        currentNode = nxt[currentNode];
    }
    assert( ans.size() > 10 );
    return ans;
}
