#include "tunnels.h"
using namespace std;

#define MAXN 400
#define MAXM 400

int spartblock[MAXN][MAXM];

bool canGo(int l,int source,int dest){
  if(source>dest){
    swap(source,dest);
  }

  if(spartblock[l][dest]-spartblock[l][source-1]>0){
    return false;
  }

  return true;
}

void solve(int n,int m,int k,const vector<vector<bool>>& blocked){
  int l,c;

  for(l=0;l<n;l++){
    spartblock[l][0]=(blocked[l][0]?1:0);
    for(c=1;c<m;c++){
      spartblock[l][c]=spartblock[l][c-1]+(blocked[l][c]?1:0);
    }
  }

  for(l=0;l<n;l++){
    int nextc=m;
    bool special=false;
    for(c=0;c<m;c++){
      if(canGo(l,k,c)&&(l==n-1||!blocked[l+1][c])){
        if(nextc!=m){
          special=true;
          break;
        }
        nextc=c;
      }
    }

    if(special&&investigate(0)){
      nextc=0;
    }else{
      nextc=1;
    }
    goDeeper(nextc);
    k=nextc;
  }

}
