#include "tunnels.h"

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& b)
{
    if(m == 2)
    {
        for(int i = 1; i < n; i ++)
            goDeeper(k);
        return;
    }

    goDeeper(k);
    for(int i = 1; i < n; i ++)
    {
        int p = 0, mi = 0;

        if(!b[i][k + 1] && k + 1 < m)
            p = investigate(k + 1);

        if(!b[i][k - 1] && k - 1 >= 0)
            mi = investigate(k - 1);

        if(p){
            k ++;
            while(k + 1 < m && investigate(k + 1) && !b[i][k]) k ++;
        }

        else if(mi){
            k --;
            while(k - 1 >= 0 && investigate(k - 1) && !b[i][k]) k --;
        }

        goDeeper(k);
    }
}