#include "tunnels.h"

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& b)
{
    goDeeper(k);

    for(int i = 1; i < n; i ++)
    {
        std::vector<int> v; v.clear();
        if(k + 1 < m && !b[i][k + 1] && investigate(k + 1))
        {
            int t = k + 1;
            while(t < m && !b[i][t])
            {
                if(i + 1 < n && !b[i + 1][t])
                    v.push_back(t);

                else if(i + 1 >= n)
                    v.push_back(t);

                t ++;
            }

            int s = 0, d = v.size() - 1, poz;
            while(s <= d)
            {
                if(s == d){
                    poz = v[s];
                    break;
                }

                int mij = (s + d) / 2;
                if(investigate(v[mij]))
                    s = mij + 1, poz = v[mij];
                else
                    d = mij - 1;
            }

            k = poz;
        }

        else if(k - 1 >= 0 && !b[i][k - 1] && investigate(k - 1))
        {
            int t = k - 1;
            while(t >= 0 && !b[i][t])
            {
                if(i + 1 < n && !b[i + 1][t])
                    v.push_back(t);

                else if(i + 1 >= n)
                    v.push_back(t);

                t --;
            }

            int s = 0, d = v.size() - 1, poz;
            while(s <= d)
            {
                if(s == d){
                    poz = v[s];
                    break;
                }

                int mij = (s + d) / 2;
                if(investigate(v[mij]))
                    s = mij + 1, poz = v[mij];
                else
                    d = mij - 1;
            }

            k = poz;
        }

        goDeeper(k);
    }
}