#include "tunnels.h"

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& b)
{
    if(m == 2)
    {
        goDeeper(k);
        for(int i = 1; i < n; i ++)
        {
            if(i == n - 1)
            {
                if(b[i][0] == 0 && b[i][1] == 0)
                {
                    if(!investigate((k + 1) % 2))
                        goDeeper(k);
                    else
                        goDeeper((k + 1) % 2);
                }

                else
                    goDeeper(k);
                return;
            }

            if(b[i][(k + 1) % 2] || b[i + 1][(k + 1) % 2])
                goDeeper(k);

            else if(b[i + 1][k])
                goDeeper((k + 1) % 2), k = (k + 1) % 2;

            else
            {
                if(!investigate((k + 1) % 2))
                    goDeeper(k);
                else
                    goDeeper((k + 1) % 2), k = (k + 1) % 2;
            }
        }

        return;
    }

    goDeeper(k);

    for(int i = 1; i < n; i ++)
    {
        std::vector<int> v; v.clear();
        if(k + 1 < m && !b[i][k + 1] && investigate(k + 1))
        {
            int t = k + 1;
            while(t < m && !b[i][t])
            {
                if(i + 1 < n && !b[i + 1][t])
                    v.push_back(t);

                else if(i + 1 >= n)
                    v.push_back(t);

                t ++;
            }

            int s = 0, d = v.size() - 1, poz;
            while(s <= d)
            {
                if(s == d){
                    poz = v[s];
                    break;
                }

                int mij = (s + d) / 2;
                if(investigate(v[mij]))
                    s = mij + 1, poz = v[mij];
                else
                    d = mij - 1;
            }

            k = poz;
        }

        else if(k - 1 >= 0 && !b[i][k - 1] && investigate(k - 1))
        {
            int t = k - 1;
            while(t >= 0 && !b[i][t])
            {
                if(i + 1 < n && !b[i + 1][t])
                    v.push_back(t);

                else if(i + 1 >= n)
                    v.push_back(t);

                t --;
            }

            int s = 0, d = v.size() - 1, poz;
            while(s <= d)
            {
                if(s == d){
                    poz = v[s];
                    break;
                }

                int mij = (s + d) / 2;
                if(investigate(v[mij]))
                    s = mij + 1, poz = v[mij];
                else
                    d = mij - 1;
            }

            k = poz;
        }

        goDeeper(k);
    }
}