#include <unordered_map>
#include <vector>

using namespace std;

const int nmax = 3e5 + 5;
int n, v[nmax];
unordered_map<int, int> fr;

void init(int N, int Q, const std::vector<int>& a){
    n = N;
    for(int i = 0; i < N; i ++)
        v[i + 1] = a[i];
}

long long query(int l, int r)
{
    long long numi = 0;
    for(int i = l; i <= r; i ++)
    {
        fr.clear();
        for(int j = i + 1; j <= r; j ++)
        {
            fr[v[j]] ++; int oki = 1;
            for(auto x : fr)
                if(x.first != x.second){
                    oki = 0; break;
                }

            numi += oki;
        }
    }

    return numi;
}
