#include <unordered_map>
#include <vector>

using namespace std;

const int nmax = 3e5 + 5;
int n, v[nmax];
unordered_map< int, vector<int> > poz;
unordered_map< int, unordered_map<int, int> > fr;

void init(int N, int Q, const std::vector<int>& a){
    n = N;
    for(int i = 0; i < N; i ++){
        v[i] = a[i];
        if(i > 0)
            fr[i] = fr[i - 1];
        fr[i][v[i]] ++;
    }
}

long long query(int l, int r)
{
    for(int i = 0; i < n; i ++) poz[i].clear();

    long long numi = 0;
    for(int i = l; i <= r; i ++)
    {
        for(auto x : fr[i])
            if(!x.second)fr[i].erase(x.first);

        unordered_map<int, int> aux; aux.clear();
        poz[v[i]].push_back(i);

        if(poz[v[i]].size() < v[i])
            continue;

        int p2 = poz[v[i]][poz[v[i]].size() - v[i]];

        int p1 = poz[v[i]].size() - v[i] - 1;
        if((int)poz[v[i]].size() - v[i] - 1 >= 0)
            p1 = poz[v[i]][poz[v[i]].size() - v[i] - 1];
        else
            p1 = 0;

        if(p2 > 0){
            for(auto x : fr[i])
                if(x.second - fr[p2 - 1][x.first] > 0)
                    aux[x.first] = x.second - fr[p2 - 1][x.first];
        }

        else
            aux = fr[i];

        int oki = 1;
        for(auto x : aux)
            if(x.first != x.second) oki = 0;
        numi += oki;

        for(int j = p2 - 1; j >= max(l, p1); j --)
        {
            aux[v[j]] ++;
            int oki = 1;
            for(auto x : aux)
                if(x.first != x.second) oki = 0;

            numi += oki;
        }
    }

    return numi;
}