#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

#define DEFINES 1
#if DEFINES
    #define DEBUG           0
    #define STATISTICS_TREE 0

    #define DEBUG_LOG_ONLY if(DEBUG)
    #define DEBUG_PAUSE_SYSTEM system("pause");
    #define DEBUG_CLEAR system("cls");
    #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";

    #if STATISTICS_TREE
        #include <ext/pb_ds/assoc_container.hpp>
        #include <ext/pb_ds/tree_policy.hpp>

        using namespace __gnu_pbds;

        template<class type, class comarator = less<type>>
        using OrderedSet = tree<type, null_type, less<type>, rb_tree_tag, tree_order_statistics_node_update>;
    #endif // STATISTICS_TREE
#endif // DEFINES

bool CanIGoDown(int i, int j, int n, const vector<vector<bool>>& bloc) {
    return i == n - 1 || (i < n - 1 && !bloc[i + 1][j]);
}

void solve(int n, int m, int k, const vector<vector<bool>>& bloc) {
    /// Workflow
    /// 1) determine where did the bunny go to so he could be able to jump down
    /// 2) jump down

    /// determining coud easily be done greedely with O(M) between closest rocks

    /// TODO:
    /// add binary search for $st and $dr

    for(int i = 0; i < n; i++) {
        int st = k - 1;
        bool areLocJosSt = false;

        while(0 <= st && !bloc[i][st]) {
            areLocJosSt |= CanIGoDown(i, st, n, bloc);
            st--;
        }
        st++;

        int dr = k + 1;
        bool areLocJosDr = false;

        while(dr < m && !bloc[i][dr]) {
            areLocJosDr |= CanIGoDown(i, dr, n, bloc);
            dr++;
        }
        dr--;

        //DEBUG_LOG_ONLY DEBUG_PRINT_VAR_BOLD("st", st);
        //DEBUG_LOG_ONLY DEBUG_PRINT_VAR_BOLD("dr", dr);

        short dir = 0;    /// nu o ia pe nicaieri

        bool areLocSt = (st != k && areLocJosSt);
        bool areLocDr = (k != dr && areLocJosDr);

        bool areLoc = (areLocSt | areLocDr);

        if(areLocSt) {
            if(investigate(k - 1)) {
                dr = k - 1;
                dir = -1;
            }
        }
        if(areLocDr && dir == 0) {
            if(investigate(k + 1)) {
                st = k + 1;
                dir = 1;
            }
        }

        int rasp = -1;

        if(dir != 0) {
            vector<int> valabile;

            int poz;
            if(dir == 1) {
                if(CanIGoDown(i, k + 1, n, bloc)) rasp = k + 1, st = k + 2;

                for(int j = st; j <= dr; j++) {
                    if(CanIGoDown(i, j, n, bloc)) valabile.push_back(j);
                }

                st = 0;
                dr = valabile.size() - 1;
                poz = -1;

                while(st <= dr) {
                    int mij = st + (dr - st) / 2;

                    if(investigate(valabile[mij])) {
                        poz = mij;
                        st = mij + 1;
                    }
                    else dr = mij - 1;
                }
            }
            else {
                if(CanIGoDown(i, k - 1, n, bloc)) rasp = k - 1, dr = k - 2;

                for(int j = st; j <= dr; j++) {
                    if(CanIGoDown(i, j, n, bloc)) valabile.push_back(j);
                }

                st = 0;
                dr = valabile.size() - 1;
                poz = -1;

                while(st <= dr) {
                    int mij = st + (dr - st) / 2;

                    if(investigate(valabile[mij])) {
                        poz = mij;
                        dr = mij - 1;
                    }
                    else st = mij + 1;
                }
            }
            if(poz != -1) rasp = valabile[poz];
        }
        else rasp = k;

        goDeeper(k = rasp);
    }
}
