#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

/*
#define DEFINES 0
#if DEFINES
    #define DEBUG           0
    #define STATISTICS_TREE 0

    #if DEBUG
        #define DEBUG_LOG_ONLY if(DEBUG)
        #define DEBUG_PAUSE_SYSTEM system("pause");
        #define DEBUG_CLEAR system("cls");
        #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";
    #endif // DEBUG

    #if STATISTICS_TREE
        #include <ext/pb_ds/assoc_container.hpp>
        #include <ext/pb_ds/tree_policy.hpp>

        using namespace __gnu_pbds;

        template<class type, class comarator = less<type>>
        using OrderedSet = tree<type, null_type, less<type>, rb_tree_tag, tree_order_statistics_node_update>;
    #endif // STATISTICS_TREE
#endif // DEFINES
*/

bool CanIGoDown(int i, int j, int n, const vector<vector<bool>>& bloc) {
    return i == n - 1 || (i < n - 1 && !bloc[i + 1][j]);
}

void SolveForM2(int n, int m, int k, const vector<vector<bool>>& bloc) {
    for(int i = 0; i < n; i++) {
        int other = (k == 0 ? 1 : 0);

        if(!CanIGoDown(i, k, n, bloc)) k = other;
        else if(!bloc[i][other] && CanIGoDown(i, other, n, bloc)) {
            if(investigate(other)) k = other;
        }

        goDeeper(k);
    }
}

static inline void SolveForBlocEmpty(int n, int m, int k, const vector<vector<bool>>& bloc) {
    for(int i = 0; i < n; i++) {
        int dir = 0;

             if(0 < k && investigate(k - 1)) dir = -1;
        else if(k < m && investigate(k + 1)) dir =  1;

        if(dir == 0) goDeeper(k);
        else if(dir == 1) {
            int st = k + 2, dr = m - 1;
            int poz = k + 1;

            while(st <= dr) {
                int mij = st + (dr - st) / 2;

                if(investigate(mij)) {
                    poz = mij;
                    st = mij + 1;
                }
                else dr = mij - 1;
            }
            goDeeper(k = poz);
        }
        else {
            int st = 1, dr = k - 2;
            int poz = k - 1;

            while(st <= dr) {
                int mij = st + (dr - st) / 2;

                if(!investigate(mij)) {
                    poz = mij;
                    st = mij + 1;
                }
                else dr = mij - 1;
            }
            goDeeper(k = poz + 1);
        }
    }
}

void solve(int n, int m, int k, const vector<vector<bool>>& bloc) {
    if(m == 2) SolveForM2(n, m, k, bloc);
    else SolveForBlocEmpty(n, m, k, bloc);
}
