#include "tunnels.h"

#include <bits/stdc++.h>

using namespace std;

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<vector<bool>>> dp(n, vector<vector<bool>>(m, vector<bool>(3, false)));

    for (int j = 0; j < m; ++j) {
        if (blocked[n - 1][j]) continue;
        dp[n - 1][j][0] = (j > 0 && !blocked[n - 1][j - 1]);
        dp[n - 1][j][1] = (j < m - 1 && !blocked[n - 1][j + 1]);
        dp[n - 1][j][2] = true;
    }

    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (blocked[i][j]) continue;
            dp[i][j][2] = (dp[i + 1][j][0] || dp[i + 1][j][1] || dp[i + 1][j][2]);
        }

        for (int j = 0; j < m; ++j) {
            if (j == 0 || blocked[i][j]) continue;
            dp[i][j][0] = (dp[i][j - 1][0] || dp[i][j - 1][2]);
        }

        for (int j = m - 1; j >= 0; --j) {
            if (j == m - 1 || blocked[i][j]) continue;
            dp[i][j][1] = (dp[i][j + 1][1] || dp[i][j + 1][2]);
        }
    }

    int curr = k;
    for (int i = 0; i < n; ++i) {
        int dir = 0;
        if (dp[i][curr][0]) {
            if (!dp[i][curr][1]) dir = -1;
            else if (investigate(curr + 1)) dir = 1, ++curr;
            else dir = -1;
        } else if (dp[i][curr][1]) dir = 1;
        else {
            goDeeper(curr);
            continue;
        }

        for (;; curr += dir) {
            if (curr == (dir == 1 ? m - 1 : 0)) break;
            if (!dp[i][curr][1]) break;
            if (!investigate(curr + 1)) break;
        }

        goDeeper(curr);
    }
}
