#include "bits/stdc++.h"

using namespace std;

void goDeeper(int s);

bool investigate(int s);

const int N = 105, M = 105;

int dp[N][M], dp1[N][M][M][M], p[N][M][M][M];

vector<vector<bool>> b;
int n, m;

int calc(int x, int y) {
    if (dp[x][y] != -1) return dp[x][y];
    if (x == n) return dp[x][y] = 0;
    int R = m, L = -1;
    for (int i = y + 1; i < m; i++) {
        if (b[x][i]) {
            R = i;
            break;
        }
    }
    for (int i = y - 1; i >= 0; i--) {
        if (b[x][i]) {
            L = i;
            break;
        }
    }
    vector<int> c;
    for (int i = L + 1; i < R; i++) {
        if (b[x + 1][i] == 0) c.push_back(i);
    }
    for (int i = 0; i < c.size(); i++) dp1[x][y][i][i] = calc(x + 1, c[i]);
    for (int d = 1; d < c.size(); d++) {
        for (int l = 0, r = d; r < c.size(); l++, r++) {
            dp1[x][y][l][r] = 1e9;
            for (int k = l; k <= r; k++) {
                if (c[k] == y) continue;
                if (c[k] < y) {
                    int l1 = l, r1 = k, l2 = k + 1, r2 = r;
                    if (dp1[x][y][l][r] > max(dp1[x][y][l1][r1],
                                              (l2 == r + 1 ? -1 : dp1[x][y][l2][r2])) + 1) {
                        dp1[x][y][l][r] = max(dp1[x][y][l1][r1],
                                              (l2 == r + 1 ? -1 : dp1[x][y][l2][r2])) + 1;
                        p[x][y][l][r] = k;
                    }
                } else {
                    int l1 = k, r1 = r, l2 = l, r2 = k - 1;
                    if (dp1[x][y][l][r] > max(dp1[x][y][l1][r1],
                                              (r2 == l - 1 ? -1 : dp1[x][y][l2][r2])) + 1) {
                        dp1[x][y][l][r] = max(dp1[x][y][l1][r1],
                                              (r2 == l - 1 ? -1 : dp1[x][y][l2][r2])) + 1;
                        p[x][y][l][r] = k;
                    }
                }
            }
        }
    }
    return dp[x][y] = dp1[x][y][0][c.size() - 1];
}

vector<int> x{0, 0, 1, -1}, y{1, -1, 0, 0};

void prec() {
    queue<pair<int, int>> q;
    auto c = b;
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) c[i][j] = 1;
    for (int i = 0; i < m; i++) q.push({n, i});
    while (q.size()) {
        auto [i, j] = q.front();
        q.pop();
        for (int k = 0; k < 4; k++) {
            int i1 = i + x[k], j1 = j + y[k];
            if (min(i1, j1) < 0 || i1 == n + 1 || j1 == m ||
                c[i1][j1] == 0 || b[i1][j1])
                continue;
            c[i1][j1] = 0;
            q.push({i1, j1});
        }
    }
    b = c;
}

void solve(int _n, int _m, int k, const std::vector<std::vector<bool>> &blocked) {
    memset(dp, -1, sizeof dp);
    n = _n;
    m = _m;
    int x = 0, y = k;
    b = blocked;
    b.push_back(vector<bool>(m, 0));
    prec();
    calc(0, y);
    while (x < n) {
        int R = m, L = -1;
        for (int i = y + 1; i < m; i++) {
            if (b[x][i]) {
                R = i;
                break;
            }
        }
        for (int i = y - 1; i >= 0; i--) {
            if (b[x][i]) {
                L = i;
                break;
            }
        }
        vector<int> c;
        for (int i = L + 1; i < R; i++) {
            if (b[x + 1][i] == 0) c.push_back(i);
        }
        int l = 0, r = c.size() - 1;
        while (l != r) {
            int i = p[x][y][l][r];
            if (c[i] < y) {
                if (investigate(c[i])) r = i;
                else l = min(r, i + 1);
            } else {
                if (investigate(c[i])) l = i;
                else r = max(l, i - 1);
            }
        }
        y = c[l];
        goDeeper(y), x++;
    }
}