#include "bits/stdc++.h"

using namespace std;

void goDeeper(int s);

bool investigate(int s);

const int N = 405, M = 405;

int dp[N][M][M], p[N][M][M], L[N][M], R[N][M], cn[N][M][M], it[N][M][M], opt[N][M][M];

vector<vector<bool>> b;
int n, m;

void calc(int x, int l, int r) {
    if (x == 1 && l == 1 && r == 2) {
        bool fl = 0;
    }
    if (x == n) {
        dp[x][l][r] = 0;
        return;
    }
    if (cn[x][l][r] == 0) return;
    if (cn[x][l][r] == 1) {
        dp[x][l][r] = dp[x + 1][L[x + 1][it[x][l][r]]][R[x + 1][it[x][l][r]]];
        opt[x][l][r] = l;
        return;
    }
    dp[x][l][r] = 1e9;
    int l1 = opt[x][l][r - 1];
    while (l1 + 2 <= r && dp[x][l][l1 + 1] <= dp[x][l1 + 2][r]) l1++;
    for (int k = l1; k <= min(l1 + 1, r); k++) {
        if (dp[x][l][r] > max(dp[x][l][k], dp[x][k + 1][r]) + 1) {
            dp[x][l][r] = max(dp[x][l][k], dp[x][k + 1][r]) + 1;
            p[x][l][r] = k;
        }
    }
//    for (int k = l + 1; k <= r; k++) {
//        if (dp[x][l][r] > max(dp[x][l][k - 1], dp[x][k][r]) + 1) {
//            dp[x][l][r] = max(dp[x][l][k - 1], dp[x][k][r]) + 1;
//            p[x][l][r] = k - 1;
//        }
//    }
}

vector<int> x{0, 0, -1}, y{1, -1, 0};

void prec() {
    queue<pair<int, int>> q;
    auto c = b;
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) c[i][j] = 1;
    for (int i = 0; i < m; i++) q.push({n, i});
    while (q.size()) {
        auto [i, j] = q.front();
        q.pop();
        for (int k = 0; k < 3; k++) {
            int i1 = i + x[k], j1 = j + y[k];
            if (min(i1, j1) < 0 || i1 == n + 1 || j1 == m ||
                c[i1][j1] == 0 || b[i1][j1])
                continue;
            c[i1][j1] = 0;
            q.push({i1, j1});
        }
    }
    b = c;
}

void prec1() {
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < m; j++) {
            int l = 0, r = m - 1;
            for (int i1 = j - 1; i1 >= 0; i1--) {
                if (b[i][i1]) {
                    l = i1 + 1;
                    break;
                }
            }
            for (int i1 = j + 1; i1 < m; i1++) {
                if (b[i][i1]) {
                    r = i1 - 1;
                    break;
                }
            }
            L[i][j] = l, R[i][j] = r;
        }
    }
}

void prec2() {
    for (int i = 0; i < n; i++) {
        for (int l = 0; l < m; l++) {
            int cnt = 0, lst = -1;
            for (int r = l; r < m; r++) {
                cnt += (1 - b[i + 1][r]);
                if (b[i + 1][r] == 0) lst = r;
                cn[i][l][r] = cnt;
                it[i][l][r] = lst;
            }
        }
    }
}

void solve(int _n, int _m, int k, const std::vector<std::vector<bool>> &blocked) {
    n = _n;
    m = _m;
    int x = 0, y = k;
    b = blocked;
    b.push_back(vector<bool>(m, 0));
    prec();
    prec1();
    prec2();
    for (int i = n; i >= 0; i--)
        for (int d = 0; d < m; d++)
            for (int l = 0, r = d; r < m; l++, r++)
                calc(i, l, r);
    while (x < n) {
        int l = L[x][y], r = R[x][y];
        vector<int> c;
        for (int i = l; i <= r; i++) if (b[x + 1][i] == 0) c.push_back(i);
        while (cn[x][l][r] != 1) {
            int i = p[x][l][r];
            if (i > y) i++;
            if (i == y) i += (i == m - 1 ? -1 : +1);
            if (i < y) {
                if (investigate(i)) r = i;
                else l = min(r, i + 1);
            } else {
                if (investigate(i)) l = i;
                else r = max(l, i - 1);
            }
        }
        y = it[x][l][r];
        goDeeper(y), x++;
    }
}