#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;

void solve(int n, int m, int k, std::vector<std::vector<bool>> blocked) {
//    vector blocked(n, vector<char>(m));
    vector dp(n + 1, vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            blocked[i][j] = Blocked[i][j];
            if (blocked[i][j]) {
                dp[i][j] = inf;
            }
        }
    }
    fill(dp[n].begin(), dp[n].end(), 0);
    for (int i = n - 1; i >= 0; --i) {
        for (int s = 0, j = 0; s < m; s = j) {
            vector<int> nxt;
            while (j < m && blocked[i][s] == blocked[i][j]) {
                if (dp[i + 1][j] < inf) {
                    nxt.push_back(dp[i + 1][j]);
                }
                j += 1;
            }
            if (blocked[i][s]) {
                continue;
            }
            sort(nxt.begin(), nxt.end());
            int best = -1;
            for (int t = 0; t < nxt.size(); ++t) {
                best = max(best, t + (t + 1 != nxt.size()) + nxt[t]);
            }
            if (best == -1) {
                best = inf;
            }
            while (s < j) {
                dp[i][s++] = best;
            }
        }
    }
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << dp[i][j] << " ";
//        }
//        cout << endl;
//    }
    int i = 0, j = k;
    while (i < n) {
        int l = j, r = j + 1;
        vector<pair<int, int>> nxt;
        while (l >= 0 && !blocked[i][l]) {
            if (dp[i + 1][l] < inf) {
                nxt.push_back({dp[i + 1][l], l});
            }
            l -= 1;
        }
        while (r < m && !blocked[i][r]) {
            if (dp[i + 1][r] < inf) {
                nxt.push_back({dp[i + 1][r], r});
            }
            r += 1;
        }
        sort(nxt.begin(), nxt.end());
        for (int t = 0; t < nxt.size(); ++t) {
            if (t + 1 < nxt.size()) {
                if (investigate(nxt[t].second)) {
                    i += 1;
                    goDeeper(j = nxt[t].second);
                    break;
                }
            } else {
                i += 1;
                goDeeper(j = nxt[t].second);
                break;
            }
        }
    }
}