#include<bits/stdc++.h>
using namespace std;

using ll = long long;

vector<int> A;

ll solve(vector<int> a) {
	int n = a.size();
	set<pair<int, int>> st;
	int mx = *max_element(a.begin(), a.end());
	vector<vector<int>> occ(mx + 1, {n});
	ll ret = 0;
	auto seg = [&](int x) -> pair<int, int> {
		int l = occ[x].size() ? occ[x].back() : n;
		int r = x <= occ[x].size() ? occ[x][occ[x].size() - x] : n;
		return {l, r};
	};
	for (int i = 1; i <= mx; ++i) st.insert({n, i});
	for (int i = n - 1; i >= 0; --i) {
		st.erase({occ[a[i]].back(), a[i]});
		occ[a[i]].push_back(i);
		st.emplace(i, a[i]);
		int sum = 0;
		int r = i - 1;
		for (auto o = st.begin(); o != st.end(); o++) {
			sum += o->second;
			r = max(r, seg(o->second).second);
			if (r >= n) break;
			if (i + sum > n) break;
			ret += r - i + 1 == sum;
		}
	}
	return ret;
}

void init(int n, int q, const vector<int>& a) {
	A = a;
}

ll query(int l, int r) {
	return solve(vector(A.begin() + l, A.begin() + r + 1));
}