#include<bits/stdc++.h>
using namespace std;

using ll = long long;

vector<int> A;
const int N = 3e5 + 1;
const int B = 550;
int sqr[N][B];
vector<int> ls[N];

void init(int n, int q, const vector<int>& a) {
	set<pair<int, int>> st;
	int mx = *max_element(a.begin(), a.end());
	vector<vector<int>> occ(mx + 1, {n});
	auto seg = [&](int x) -> pair<int, int> {
		int l = occ[x].size() ? occ[x].back() : n;
		int r = x <= occ[x].size() ? occ[x][occ[x].size() - x] : n;
		return {l, r};
	};
	for (int i = 1; i <= mx; ++i) st.insert({n, i});
	for (int i = n - 1; i >= 0; --i) {
		for (int j = 0; j < B; ++j) sqr[i][j] += sqr[i + 1][j];
		st.erase({occ[a[i]].back(), a[i]});
		occ[a[i]].push_back(i);
		st.emplace(i, a[i]);
		int sum = 0;
		int r = i - 1;
		for (auto o = st.begin(); o != st.end(); o++) {
			sum += o->second;
			r = max(r, seg(o->second).second);
			if (r >= n) break;
			if (i + sum > n) break;
			if (r - i + 1 == sum) {
				sqr[i][r / B]++;
				ls[r].push_back(i);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		reverse(ls[i].begin(), ls[i].end());
	}
}

ll query(int l, int r) {
	ll ans = 0;
	int i;
	for (i = 0; i * B + B - 1 <= r; ++i) {
		ans += sqr[l][i];
	}
	i *= B;
	while (i <= r) {
		ans += ls[i].end() - lower_bound(ls[i].begin(), ls[i].end(), l);
		i++;
	}
	return ans;
}