#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

using ll = long long;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    vector<vector<int>> ok(n, vector<int>(m, 0));
    auto d_ok {[&](int i, int j) -> bool {
        if (blocked[i][j]) return false;
        if (i == n - 1) return true;
        if (blocked[i + 1][j]) return false;
        return ok[i + 1][j];
    }};
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            ok[i][j] = d_ok(i, j);
        }
        for (int j = 1; j < m; j++) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j] |= ok[i][j - 1];
            }
        }
        for (int j = m - 1; j > 0; j--) {
            if (!blocked[i][j - 1] && !blocked[i][j]) {
                ok[i][j - 1] |= ok[i][j];
            }
        }
    }
    vector<vector<int>> dp(n, vector<int>(m, INT32_MAX / 2));
    vector<vector<vector<int>>> dp1(n, vector<vector<int>>(m, vector<int>(m, INT32_MAX / 2)));
    vector<vector<vector<int>>> opt(n, vector<vector<int>>(m, vector<int>(m, -1)));
    for (int i = 0; i < m; i++) {
        dp[n - 1][i] = (blocked[n - 1][i] ? INT32_MAX / 2 : 0);
    }
    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            dp1[i][j][j] = (blocked[i][j] ? INT32_MAX / 2 : dp[i + 1][j]);
            opt[i][j][j] = j + 1;
        }
        for (int l = 1; l < m; l++) {
            for (int j = 0; j + l < m; j++) {
                opt[i][j][j + l] = j + 1;
                for (int p = opt[i][j][j + l - 1]; p <= min(opt[i][j + 1][j + l], j + l); p++) {
                    if (dp1[i][j][j + l] > max(dp1[i][j][p - 1], dp1[i][p][j + l]) + 1) {
                        dp1[i][j][j + l] = max(dp1[i][j][p - 1], dp1[i][p][j + l]) + 1;
                        opt[i][j][j + l] = p;
                    }
                }
            }
        }
        for (int j = 0; j < m; j++) {
            int l = j, r = j;
            if (blocked[i][j]) continue;
            while (l >= 0 && !blocked[i][l]) l--;
            while (r < m && !blocked[i][r]) r++;
            l++;
            r--;
            dp[i][j] = dp1[i][l][r];
        }
    }
    for (int i = 0; i < n; i++) {
        int l = k, r = k;
        {
            while (l >= 0 && !blocked[i][l]) l--;
            while (r < m && !blocked[i][r]) r++;
            l++;
            r--;
        }
        while (l != r) {
            int m1 = opt[i][l][r];
            bool res;
            if (m1 <= k) {
                res = investigate(m1 - 1);
                if (res) {
                    r = m1 - 1;
                } else {
                    l = m1;
                }
            } else {
                res = investigate(m1);
                if (res) {
                    l = m1;
                } else {
                    r = m1 - 1;
                }
            }
        }
        k = l;
        goDeeper(k);
    }
}
