#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<deque<ll>> all(n + 1);
	set<pair<ll, ll>> lpos;
	vector<vector<pair<ll, ll>>> gs(n);
	ll ans = 0;
	for (ll i = n - 1; i >= 0; i--) {
		ll nx = arr[i];
		if (!all[nx].empty()) {
			lpos.erase(make_pair(all[nx].front(), nx));
		}
		lpos.insert(make_pair(i, nx));
		all[nx].push_front(i);
		ll fb = n;
		vector<pair<ll, ll>> bs;
		for (auto[st, num] : lpos) {
			if (st >= fb) {
				break;
			}
			if (all[num].size() < num) {
				assign_min(fb, st);
			} else {
				bs.emplace_back(make_pair(st, all[num][num - 1]));
				if (all[num].size() > num) {
					assign_min(fb, all[num][num]);
				}
			}
		}
		sort(bs.begin(), bs.end());
		vector<pair<ll, ll>> nbs;
		ll now = 0;
		while (now < bs.size()) {
			auto[nl, nr] = bs[now];
			now++;
			while (now < bs.size() && bs[now].first <= nr) {
				assign_max(nr, bs[now].second);
				now++;
			}
			nbs.emplace_back(nl, nr);
		}
		nbs.emplace_back(n, n);
		ll nst = i;
		for (auto[l, r] : nbs) {
			if (nst >= fb) {
				break;
			}
			gs[i].emplace_back(nst, min(l, fb));
			ans += min(l, fb) - nst;
			nst = r;
		}
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
