#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<vector<pair<ll, ll>>> gs;
vector<vector<ll>> psgs;

void init(ll n, ll q, const vector<ll>& a) {
	vector<deque<ll>> all(n + 1);
	set<pair<ll, ll>> lpos;
	gs.resize(n);
	psgs.resize(n);
	for (ll i = n - 1; i >= 0; i--) {
		ll nx = a[i];
		if (!all[nx].empty()) {
			lpos.erase(make_pair(all[nx].front(), nx));
		}
		lpos.insert(make_pair(i, nx));
		all[nx].push_front(i);
		ll fb = n;
		vector<pair<ll, ll>> bs;
		for (auto[st, num] : lpos) {
			if (st >= fb) {
				break;
			}
			if (all[num].size() < num) {
				assign_min(fb, st);
			} else {
				bs.emplace_back(make_pair(st, all[num][num - 1]));
				if (all[num].size() > num) {
					assign_min(fb, all[num][num]);
				}
			}
		}
		sort(bs.begin(), bs.end());
		vector<pair<ll, ll>> nbs;
		ll now = 0;
		while (now < bs.size()) {
			auto[nl, nr] = bs[now];
			now++;
			while (now < bs.size() && bs[now].first <= nr) {
				assign_max(nr, bs[now].second);
				now++;
			}
			nbs.emplace_back(nl, nr);
		}
		nbs.emplace_back(n, n);
		ll nst = i;
		for (auto[l, r] : nbs) {
			if (nst >= fb) {
				break;
			}
			gs[i].emplace_back(nst, min(l, fb));
			nst = r;
		}
		psgs[i].push_back(0);
		for (auto[l, r] : gs[i]) {
			psgs[i].push_back(psgs[i].back() + r - l);
		}
	}
}

long long query(ll l, ll r) {
	r++;
	long long ans = 0;
	for (ll st = l; st < r; st++) {
		ll fnf = lower_bound(gs[st].begin(), gs[st].end(), make_pair(r, r)) - gs[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs[st][fnf] + min(r, gs[st][fnf].second) - gs[st][fnf].first;
		}
	}
	return ans;
}

#ifdef LOCAL
int main(){
        std::ios_base::sync_with_stdio(false);
        std::cin.tie(nullptr); std::cout.tie(nullptr);
        int n, q; std::cin >> n >> q;
        std::vector<int> input(n);
        for(int i = 0; i < n; i ++){
                std::cin >> input[i];
        }
        init(n, q, input);
        for(int i = 0; i < q; i ++){
                int l, r;
                std::cin >> l >> r;
                std::cout << query(l, r) << " ";
        }
        std::cout << std::endl;
}
#endif
