//#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

constexpr ll K = 512, LK = 9, KM1 = 511;

vector<vector<pair<ll, ll>>> gs;
vector<vector<ll>> psgs;
vector<vector<ll>> psb;
vector<ll> bst;

void init(ll n, ll q, const vector<ll>& a) {
	vector<deque<ll>> all(n + 1);
	set<pair<ll, ll>> lpos;
	gs.resize(n);
	psgs.resize(n);
	psb.resize((n + K - 1) / K);
	bst.resize(psb.size(), 0);
	ll nbs = 0;
	for (ll i = 0; i < bst.size(); i++) {
		bst[i] = nbs;
		nbs += K;
		psb[i].resize(n - bst[i] + 1);
	}
	for (ll i = n - 1; i >= 0; i--) {
		ll nx = a[i];
		if (!all[nx].empty()) {
			lpos.erase(make_pair(all[nx].front(), nx));
		}
		lpos.insert(make_pair(i, nx));
		all[nx].push_front(i);
		ll fb = n;
		vector<pair<ll, ll>> bs;
		for (auto[st, num] : lpos) {
			if (st >= fb) {
				break;
			}
			if (all[num].size() < num) {
				assign_min(fb, st);
			} else {
				bs.emplace_back(make_pair(st, all[num][num - 1]));
				if (all[num].size() > num) {
					assign_min(fb, all[num][num]);
				}
			}
		}
		sort(bs.begin(), bs.end());
		vector<pair<ll, ll>> nbs;
		ll now = 0;
		while (now < bs.size()) {
			auto[nl, nr] = bs[now];
			now++;
			while (now < bs.size() && bs[now].first <= nr) {
				assign_max(nr, bs[now].second);
				now++;
			}
			nbs.emplace_back(nl, nr);
		}
		nbs.emplace_back(n, n);
		ll nst = i;
		for (auto[l, r] : nbs) {
			if (nst >= fb) {
				break;
			}
			gs[i].emplace_back(nst, min(l, fb));
			nst = r;
		}
		psgs[i].push_back(0);
		for (auto[l, r] : gs[i]) {
			psb[i >> LK][l - bst[i >> LK]]++;
			psb[i >> LK][r - bst[i >> LK]]--;
			psgs[i].push_back(psgs[i].back() + r - l);
		}
	}
	for (auto& i : psb) {
		vector<ll> sps(1, 0);
		ll nps = 0;
		ll nsps = 0;
		for (auto& j : i) {
			nps += j;
			nsps += nps;
			j = nsps;
		}
	}
}

long long query(ll l, ll r) {
	r++;
	ll sr = r;
	long long ans = 0;
	while (l < r && l % KM1 != 0) {
		ll st = l;
		ll fnf = lower_bound(gs[st].begin(), gs[st].end(), make_pair(sr, sr)) - gs[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs[st][fnf] + min(sr, gs[st][fnf].second) - gs[st][fnf].first;
		}
		l++;
	}
	while (r > l && r & KM1 != 0) {
		ll st = r - 1;
		ll fnf = lower_bound(gs[st].begin(), gs[st].end(), make_pair(sr, sr)) - gs[st].begin() - 1;
		if (fnf >= 0) {
			ans += psgs[st][fnf] + min(sr, gs[st][fnf].second) - gs[st][fnf].first;
		}
		r--;
	}
	for (ll i = (l >> LK); i < (r >> LK); i++) {
		ans += psb[i][sr - 1 - bst[i]];
	}
	return ans;
}

#ifdef LOCAL
int main(){
        std::ios_base::sync_with_stdio(false);
        std::cin.tie(nullptr); std::cout.tie(nullptr);
        int n, q; std::cin >> n >> q;
        std::vector<int> input(n);
        for(int i = 0; i < n; i ++){
                std::cin >> input[i];
        }
        init(n, q, input);
        for(int i = 0; i < q; i ++){
                int l, r;
                std::cin >> l >> r;
                std::cout << query(l, r) << " ";
        }
        std::cout << std::endl;
}
#endif
