#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &blocked) {
    if (m == 2) {
        int cur = 0, y = k;
        while (cur < n) {
            if (blocked[cur][1 - y] || (cur + 1 < n && blocked[cur + 1][1 - y])) {
                goDeeper(y);
            } else {
                if ((cur + 1 < n && blocked[cur + 1][y]) || investigate(1 - y))
                    goDeeper(1 - y), y = 1 - y;
                else
                    goDeeper(y);
            }
            cur++;
        }
        return;
    }
    int cur = 0, y = k;
    while (cur < n) {
        if (y != 0 && (y == m - 1 || !investigate(y + 1))) {
            int l = 0, r = y;
            while (l != r) {
                int mid = (l + r) / 2;
                if (investigate(mid))
                    r = mid;
                else l = mid + 1;
            }
            goDeeper(r);
        } else {
            int l = (y != 0 ? y + 1 : 0), r = m - 1;
            while (r != l) {
                int mid = (l + r) / 2;
                if (investigate(mid))
                    l = mid;
                else r = mid - 1;
            }
            goDeeper(l);
        }
        cur++;
    }
}