#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>> &blocked) {
    if (m == 2) {
        int cur = 0, y = k;
        while (cur < n) {
            if (blocked[cur][1 - y] || (cur + 1 < n && blocked[cur + 1][1 - y])) {
                goDeeper(y);
            } else {
                if ((cur + 1 < n && blocked[cur + 1][y]) || investigate(1 - y))
                    goDeeper(1 - y), y = 1 - y;
                else
                    goDeeper(y);
            }
            cur++;
        }
        return;
    }
    int cur = 0, y = k;
    while (cur < n) {
        int to_go = 0, val = y;
        if (y == 0) to_go = 1;
        else if (y == m - 1) to_go = 0;
        else {
            if (y <= (m + 1) / 2) {
                if (investigate(y - 1))
                    to_go = 0, val = y - 1;
                else
                    to_go = 1;
            } else {
                if (investigate(y + 1))
                    to_go = 1, val = y + 1;
                else
                    to_go = 0;
            }
        }
        if (to_go == 0) {
            int l = 0, r = val;
            while (l != r) {
                int mid = (l + r) / 2;
                if (investigate(mid))
                    r = mid;
                else l = mid + 1;
            }
            goDeeper(r);
        } else {
            int l = val, r = m - 1;
            while (r != l) {
                int mid = (l + r) / 2;
                if (investigate(mid))
                    l = mid;
                else r = mid - 1;
            }
            goDeeper(l);
        }
        cur++;
    }
}