#include <bits/stdc++.h>

using namespace std;

vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
    int val = 0;
    for (int i = 0; i < 5; i++)
        if (data[i]) val += (1 << i);
    vector<pair<int, int>> e;
    e.emplace_back(0, 1), e.emplace_back(0, 2), e.emplace_back(0, 3);
    for (int j = 4; j < 4 + val; j++)
        e.emplace_back(1, j);
    for (int j = 4 + val; j < 4 + 2 * val; j++)
        e.emplace_back(2, j);
    for (int j = 4 + 2 * val; j < 4 + 3 * val; j++)
        e.emplace_back(4, j);
    for (int j = 4 + 3 * val; j < 200; j++)
        e.emplace_back(0, j);
    return e;
}

vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
    int one = 0, deg[n];
    for (int i = 0; i < n; i++) deg[i] = 0;
    for (auto [u, v]: tree) deg[u]++, deg[v]++;
    int cnt[n + 1];
    for (int i = 0; i <= n; i++) cnt[i] = 0;
    for (int i = 0; i < n; i++) cnt[deg[i]]++;
    vector<bool> res(2 * n, false);
    for (int i = n; i >= 0; i--) {
        if (cnt[i] >= 2) {
            int val = i - 1;
            for (int k = 0; k < 5; k++)
                res[k] = ((val >> k) & 1);
        }
    }
    return res;
}