#include <bits/stdc++.h>

using namespace std;

vector<int> p = {2, 3, 5, 7, 19};

int bits = 12;

vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
    int val = 0;
    for (int i = 0; i < bits; i++)
        if (data[i])
            val += (1 << i);
    vector<pair<int, int>> e;
    int cur = 1, add = 0;
    for (auto pr: p) {
        int r = val % pr;
        e.emplace_back(0, cur);
        e.emplace_back(0, cur + 1);
        e.emplace_back(0, cur + 2);
        int t = cur + 3;
        for (int j = cur; j <= cur + 2; j++) {
            for (int x = t; x < t + add + r; x++)
                e.emplace_back(j, x);
            t += add + r;
        }
        cur = t;
        add += pr;
    }
    for (int j = cur; j < n; j++)
        e.emplace_back(0, j);
    return e;
}

vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
    int deg[n + 1];
    for (int i = 0; i <= n; i++) deg[i] = 0;
    for (auto [u, v]: tree) deg[u]++, deg[v]++;
    int cnt[n + 1], cur = (int) p.size() - 1;
    for (int i = 0; i <= n; i++) cnt[i] = 0;
    for (int i = 0; i <= n; i++) cnt[deg[i]]++;
    vector<bool> res(2 * n, false);
    vector<int> r((int) p.size()), add((int) p.size());
    for (int i = 1; i < (int) p.size(); i++)
        add[i] = add[i - 1] + p[i - 1];
    for (int i = n; i >= 0; i--) {
        if (cur == -1) break;
        if (cnt[i] >= 2) {
            r[cur] = i - add[cur] - 1;
            cur--;
        }
    }
    int val, mul = 1;
    for (auto pr: p) mul *= pr;
    for (val = 0; val < mul; val++) {
        bool good = true;
        for (int j = 0; j < (int) p.size(); j++)
            if (val % p[j] != r[j])
                good = false;
        if (good) {
            for (int i = 0; i < bits; i++)
                res[i] = ((val >> i) & 1);
            break;
        }
    }
    return res;
}