#include <bits/stdc++.h>

using namespace std;
long long cnt = 0;

const int C = 780;

vector<long long> add, pref, st, ed;
int N;

void init(int n, int q, const vector<int> &a) {
    N = n;
    set<int> diff;
    multiset<int> ers;
    vector<int> pos[n + 1], calc(n + 1);
    add.resize(n);
    pref.resize(n), st.resize(n), ed.resize(n);
    for (int i = 0; i < n; i++)
        pos[a[i]].emplace_back(i);
    for (int i = 1; i <= n; i++)
        for (int j = 0; j < (int) pos[i].size(); j++)
            calc[pos[i][j]] = j;
    int r = -1;
    set<pair<int, pair<int, int>>> fst;
    for (int l = 0; l < n; l++) {
        while (r + 1 < n && (int) diff.size() <= C) {
            ++r;
            if (diff.find(a[r]) == diff.end())
                fst.insert({r, {a[r], calc[r]}});
            ers.insert(a[r]), diff.insert(a[r]);
        }
        auto cur = fst.begin();
        int indL = l, indR = r - ((int) diff.size() > C);
        long long sum = 0;
        while (indL <= indR) {
            if (indL - l + 1 == sum) {
                st[l]++, ed[indL]++;
                add[l]++, add[indL]--;
                indL++, cnt++;
            }
            if (cur == fst.end()) break;
            int val = cur->second.first, it = cur->second.second;
            if (indL > indR || it + val - 1 >= (int) pos[val].size()) break;
            int newL = pos[val][it + val - 1], newR = (it + val < (int) pos[val].size() ?
                                                       pos[val][it + val] - 1 : n - 1);
            indL = max(indL, newL), indR = min(indR, newR), cur++;
            sum += val;
        }
        ers.erase(ers.find(a[l]));
        int it = fst.begin()->second.second;
        fst.erase(fst.begin());
        if (ers.find(a[l]) == ers.end()) {
            diff.erase(a[l]);
        } else {
            fst.insert({pos[a[l]][it + 1], {a[l], it + 1}});
        }
    }
    for (int i = 0; i < n; i++)
        pref[i] = (i > 0 ? pref[i - 1] : 0) + add[i];
    for (int i = n - 2; i >= 0; i--)
        st[i] += st[i + 1];
    for (int i = 1; i < n; i++)
        ed[i] += ed[i - 1];
}

long long get_sum(int l, int r) {
    return pref[r] - (l > 0 ? pref[l - 1] : 0);
}

long long query(int l, int r) {
    return cnt + get_sum(l, N - 1) - get_sum(0, r) - (r + 1 < N ? st[r + 1] : 0) - (l > 0 ? ed[l - 1] : 0);
}