#include <bits/stdc++.h>

using namespace std;
long long cnt = 0;

const int C = 780;

const int maxN = (int) 1e5 * 3 + 10;
vector<pair<int, int>> sub;

vector<int> t[4 * maxN];

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {sub[l].second};
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid), build(v * 2 + 1, mid + 1, r);
    t[v].resize(t[v * 2].size() + t[v * 2 + 1].size());
    merge(t[v * 2].begin(), t[v * 2].end(), t[v * 2 + 1].begin(), t[v * 2 + 1].end(),
          t[v].begin());
}
int N;

void init(int n, int q, const vector<int> &a) {
    set<int> diff;
    multiset<int> ers;
    vector<int> pos[n + 1], calc(n + 1);
    for (int i = 0; i < n; i++)
        pos[a[i]].emplace_back(i);
    for (int i = 1; i <= n; i++)
        for (int j = 0; j < (int) pos[i].size(); j++)
            calc[pos[i][j]] = j;
    int r = -1;
    set<pair<int, pair<int, int>>> fst;
    for (int l = 0; l < n; l++) {
        while (r + 1 < n && (int) diff.size() <= C) {
            ++r;
            if (diff.find(a[r]) == diff.end())
                fst.insert({r, {a[r], calc[r]}});
            ers.insert(a[r]), diff.insert(a[r]);
        }
        auto cur = fst.begin();
        int indL = l, indR = r - ((int) diff.size() > C);
        long long sum = 0;
        while (indL <= indR) {
            if (indL - l + 1 == sum) {
                sub.emplace_back(l, indL);
                indL++, cnt++;
            }
            if (cur == fst.end()) break;
            int val = cur->second.first, it = cur->second.second;
            if (indL > indR || it + val - 1 >= (int) pos[val].size()) break;
            int newL = pos[val][it + val - 1], newR = (it + val < (int) pos[val].size() ?
                                                       pos[val][it + val] - 1 : n - 1);
            indL = max(indL, newL), indR = min(indR, newR), cur++;
            sum += val;
        }
        ers.erase(ers.find(a[l]));
        int it = fst.begin()->second.second;
        fst.erase(fst.begin());
        if (ers.find(a[l]) == ers.end()) {
            diff.erase(a[l]);
        } else {
            fst.insert({pos[a[l]][it + 1], {a[l], it + 1}});
        }
    }
    sort(sub.begin(), sub.end());
    N = (int) sub.size();
    build(1, 0, N - 1);
}

long long get(int v, int l, int r, int tl, int tr, int x) {
    if (l > tr || r < tl)
        return 0;
    if (l >= tl && r <= tr)
        return lower_bound(t[v].begin(), t[v].end(), x + 1) - t[v].begin();
    int mid = (l + r) / 2;
    return get(v * 2, l, mid, tl, tr, x) + get(v * 2 + 1, mid + 1, r, tl, tr, x);
}

long long query(int l, int r) {
    int L = lower_bound(sub.begin(), sub.end(), pair<int, int>{l, -1}) - sub.begin();
    return get(1, 0, N - 1, L, N - 1, r);
}