#include <bits/stdc++.h>

using namespace std;

const int C = 20;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    data.resize(C);
    int dp[n+1][n+1][n+1];
    for(int j = 0;j < n+1;++j)
    {
        for(int k = 0;k < n+1;++k)
        {
            for(int l = 0;l < n+1;++l)
            {
                if(j == 0 && k == 0)
                {
                    dp[j][k][l] = 1;
                }
                else if(j == 0)
                    dp[j][k][l] = 0;
                if(j != 0)
                {
                    dp[j][k][l] = (k >= l ? dp[j-1][k-l][l] : 0) + (l == 0 ? 0 : dp[j][k][l-2]);
                }
            }
        }
    }
    //cout << dp[n-2][198][0] << endl;
    //cout << "!" << endl;
    vector<int> numbers;
    int tnum = 0;
    for(int j = 0;j < C;++j)
    {
        tnum *= 2;
        tnum += data[j];
    }
    int sum = 198;
    int mx = 198;
    //cout << dp[n-1][198][0] << endl;
    for(int i = 0;i < n;++i)
    {
        mx = min(mx,sum);
    //    cout << mx << ' ' << sum << endl;
        for(int tx = 0;tx <= mx;tx+=2)
        {
            //cout << tx << endl;
            if(dp[n-i-1][sum-tx][tx] >= tnum)
            {
                //cout << "!" << endl;
                numbers.push_back(tx);
                sum -= tx;
                mx = tx;
                break;
            }
            else
            {
                tnum -= dp[n-i-1][sum-tx][tx];
            }
        }
    //    cout << "!" << endl;
    }
    int pnt = 1;
    vector<pair<int,int>> g;
    for(int i = 0;i < n;++i)
    {
        if(i == 0)
            numbers[i]++;
        while(numbers[i]--)
        {
            g.push_back({i,pnt++});
        }
    }
    return g;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector<int> numbers;
    vector<vector<int>> g(n+1);
    for(int j = 0;j < tree.size();++j)
    {
        g[tree[j].first].push_back(tree[j].second);
        g[tree[j].second].push_back(tree[j].first);
    }
    for(int j = 0;j < g.size();++j)
    {
        numbers.push_back(g[j].size());
    }
    sort(numbers.rbegin(),numbers.rend());
    numbers.pop_back();
    for(int j = 0;j < numbers.size();++j)
    {
        numbers[j]--;
        if(numbers[j]%2 == 1)
        {
            numbers[j]--;
        }
    }
    int dp[n+1][n+1][n+1];
    for(int j = 0;j < n+1;++j)
    {
        for(int k = 0;k < n+1;++k)
        {
            for(int l = 0;l < n+1;++l)
            {
                if(j == 0 && k == 0)
                {
                    dp[j][k][l] = 1;
                }
                else if(j == 0)
                    dp[j][k][l] = 0;
                if(j != 0)
                {
                    dp[j][k][l] = (k >= l ? dp[j-1][k-l][l] : 0) + (l == 0 ? 0 : dp[j][k][l-2]);
                }
            }
        }
    }
    int tnum = 0;
    int sum = 198;
    int mx = 198;
    for(int i = 0;i < n;++i)
    {
        mx = min(mx,sum);
        for(int tx = 0;tx <= mx;tx+=2)
        {
            if(numbers[i] == tx)
            {
                sum -= tx;
                mx = tx;
                break;
            }
            else
            {
                tnum += dp[n-i-1][sum-tx][tx];
            }
        }
    }
    vector<bool> dec;
    for(int i =0;i < C;++i)
    {
        dec.push_back(tnum%2);
        tnum/=2;
    }   
    reverse(dec.begin(),dec.end());
    return dec;
}   