#include <bits/stdc++.h>
//#include "C.h"

using namespace std;

typedef long long ll;

const int maxn = 300005;
const int sqr = 550;

vector<int> good[maxn];
vector<int> good2[maxn];
ll ans[sqr][sqr];
ll pref[sqr][sqr];
vector<int> pos[maxn];
int rg[maxn];
int cr[maxn];
int pre[maxn];
int np[maxn];


void init(int n,int q,const vector<int>& a)
{   
    for(int i = 0;i < sqr;++i)
    {
        for(int j = 0;j < sqr;++j)
        {
            ans[i][j] = 0;
        }
    }
    for(int i = 0;i < n;++i)
    {
        rg[i] = n;
        cr[i] = i;
        np[i] = 0;
        pre[i] = -1;
    }
    for(int i = 0;i < n;++i)
    {
        pre[i] = (pos[a[i]].size() == 0 ? -1 : pos[a[i]].back());
        pos[a[i]].push_back(i);
        if(pos[a[i]].size() >= a[i])
        {
            rg[pos[a[i]].rbegin()[a[i]-1]] = i;
        }
    }
    // for(int i = 0;i < n;++i)
    // {
    //     cout << rg[i] << ' ' << mp[i] << ' ' << pre[i] << endl;
    // }
    int last = 0;
    for(int i = 0;i < n;++i)
    {
        int lg = max(last,pre[i]+1);
        for(int u = lg;u <= i;++u)
        {
            cr[u] = max(cr[u],rg[i]);
            np[u]+=a[i];
            if(cr[u]-u+1 == np[u])
            {
                good[u].push_back(cr[u]);
                good2[cr[u]].push_back(u);
                ans[u/sqr][cr[u]/sqr]++;
            }
            //cout << np[u] << ' ';
            if(np[u] > n)
            {
                last = u+1;
            }    
        }
    }
    for(int i = sqr-1;i >= 0;--i)
    {
        for(int j = i;j < sqr;++j)
        {
            pref[i][j] = (j == i ? ans[i][j] : ans[i][j] + pref[i][j-1]);
        }
    }
    for(int i = 0;i < sqr;++i)
    {
        for(int j = i;j < sqr;++j)
        {
            ans[i][j] = 0;
            for(int l = i;l <= j;++l)
            {
                ans[i][j] += pref[l][j];
            }
        }
    }
}
long long query(int l,int r)
{
    ll res = 0;
    if(r/sqr == l/sqr)
    {
        for(int j = l;j <= r;++j)
        {
            res += upper_bound(good[j].begin(),good[j].end(),r)-good[j].begin();
        }
        return res;
    }
    res = (r < sqr ? 0 : ans[(l+sqr-1)/sqr][(r+1)/sqr-1]);
    while(r%sqr != sqr-1)
    {
        res += good2[r].size()-(lower_bound(good2[r].begin(),good2[r].end(),l)-good2[r].begin());
        r--;
    }
    while(l%sqr != 0)
    {
        res += upper_bound(good[l].begin(),good[l].end(),r)-good[l].begin();
        l++;
    }
    return res;
}