#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

vector<int> r;
vector<set<int>> nums;

void init(int n, int q, const std::vector<int>& a) {
	vector<vector<int>> cur(n + 1);
	set<pair<int, int>> cur2;
	nums.resize(n + 1);
	r.resize(n + 1, 1e9);
	for (int l = n - 1; l >= 0; --l) {
		if (cur[a[l]].size()) cur2.erase({cur[a[l]].back(), a[l]});
		cur2.insert({l, a[l]});
		cur[a[l]].push_back(l);
		if (a[l] == 1) {
			r[l] = l + 1;
			nums[l].insert(1);
			continue;
		}
		// cout << l << ' ' << cur[a[l]].size() << '\n';
		// if (cur[a[l]].size() < a[l]) continue;
		int t = l;
		int summ = 0;
		for (auto e : cur2) {
			if (e.first != l && e.first >= t) break;
			int xx = e.second;
			if (cur[xx].size() < xx) {
				t = 1e9;
				break;
			}
			// cout << e.first << ' ' << e.second << '\n';
			summ += xx;
			t += xx;
			// t = max(t, cur[xx][cur[xx].size() - xx]);
		}
		// cout << l << ' ' << t << '\n';
		// cout << t + 1 - l << ' ' << summ << '\n';
		// if (t - l != summ) {
		// 	continue;
		// }
		r[l] = t;
		if (r[l] != 1e9) {
			for (auto e : cur2) {
				if (e.first < r[l]) nums[l].insert(e.second);
			}
		}
	}
}

long long query(int ql, int qr) {
	long long ans = 0;
	for (int i = ql; i <= qr; ++i) {
		int t = i;
		set<int> cur;
		while (r[t] <= qr + 1) {
			bool ok = 1;
			for (auto e : nums[t]) {
				if (cur.find(e) != cur.end()) {
					ok = 0;
					break;
				}
				cur.insert(e);
			}
			if (!ok) break;
			ans++;
			t = r[t];
		}
	}
	return ans;
}

#ifdef LOCAL
int main(){
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
#endif