#pragma GCC optimize("Ofast")
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int K = 350;

vector<vector<int>> lol;
vector<int> r, r2;

void init(int n, int q, const std::vector<int>& a) {
	lol.resize(n / K + 5, vector<int>(n));
	vector<vector<int>> cur(n + 1);
	set<pair<int, int>> cur2;
	r.resize(n + 1, 1e9);
	r2.resize(n + 1, 1e9);
	for (int l = n - 1; l >= 0; --l) {
		if (cur[a[l]].size()) cur2.erase({cur[a[l]].back(), a[l]});
		cur2.insert({l, a[l]});
		cur[a[l]].push_back(l);
		vector<int> nums;
		if (a[l] == 1) {
			r[l] = l + 1;
			nums.push_back(1);
			for (auto e : nums) {
				if (cur[e].size() == e) continue;
				r2[l] = min(r2[l], cur[e][cur[e].size() - (e + 1)]);
			}
			r2[l] = min(r2[l], r2[r[l]]);
			continue;
		}
		int t = l;
		int summ = 0;
		for (auto e : cur2) {
			if (e.first != l && e.first >= t) break;
			int xx = e.second;
			if (cur[xx].size() < xx) {
				t = 1e9;
				break;
			}
			// cout << e.first << ' ' << e.second << '\n';
			summ += xx;
			t += xx;
			// t = max(t, cur[xx][cur[xx].size() - xx]);
		}
		// cout << l << ' ' << t << '\n';
		// cout << t + 1 - l << ' ' << summ << '\n';
		// if (t - l != summ) {
		// 	continue;
		// }
		r[l] = t;
		if (r[l] != 1e9) {
			for (auto e : cur2) {
				if (e.first < r[l]) nums.push_back(e.second);
				else break;
			}
		}
		bool ok = 1;
		for (auto e : nums) {
			if (cur[e][cur[e].size() - e] >= r[l]) {
				ok = 0;
				break;
			}
		}
		if (!ok) {
			r[l] = 1e9;
			nums.clear();
		}
		if (r[l] <= n) {
			for (auto e : nums) {
				if (cur[e].size() == e) continue;
				r2[l] = min(r2[l], cur[e][cur[e].size() - (e + 1)]);
			}
			r2[l] = min(r2[l], r2[r[l]]);
		}
	}
	for (int i = 0; i < n; ++i) {
		int t = i;
		while (r[t] <= n && r[t] <= r2[i]) {
			// cout << i << ' ' << r[t] << '\n';
			lol[i / K][r[t] - 1]++;
			t = r[t];
		}
	}
	for (auto &e : lol) {
		for (int i = 1; i < n; ++i) {
			e[i] += e[i - 1];
		}
		// for (auto i : e) cout << i << ' ';
		// cout << '\n';
	}
}

long long query(int ql, int qr) {
	if (qr - ql <= 2 * K) {
		long long ans = 0;
		for (int i = ql; i <= qr; ++i) {
			int t = i;
			while (r[t] <= qr + 1 && r[t] <= r2[i]) {
				ans++;
				t = r[t];
			}
		}
		return ans;
	}
	long long ans = 0;
	int tl = ((ql - 1) / K) + 1;
	if (ql == 0) tl = 0;
	for (int i = tl; i < (qr + 1) / K; ++i) {
		ans += lol[i][qr];
	}
	for (int i = ql; i % K != 0; ++i) {
		int t = i;
		while (r[t] <= qr + 1 && r[t] <= r2[i]) {
			ans++;
			t = r[t];
		}
	}
	for (int i = qr; i % K != K - 1; --i) {
		int t = i;
		while (r[t] <= qr + 1 && r[t] <= r2[i]) {
			ans++;
			t = r[t];
		}
	}
	return ans;
}

#ifdef LOCAL
int main(){
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
#endif