#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <random>

using namespace std;

mt19937 rnd(1329);
const int K = 400;

vector<vector<int>> lol;
vector<vector<int>> rs;
vector<int> block_start, block_num, block_size;
vector<int> kek;
vector<int> r, r2;

void init(int n, int q, const std::vector<int>& a) {
    block_num.resize(n + K + 100);
    int N = 0;
    while (N < n) {
        block_start.push_back(N);
        block_size.push_back(K + rnd() % 100);
        N += block_size.back();
        for (int i = 0; i < block_size.back(); ++i)  block_num[block_start.back() + i] = block_start.size() - 1;
    }
	lol.resize(block_size.size(), vector<int>(n));
	vector<vector<int>> cur(n + 1);
	kek.resize(n + 1);
	set<pair<int, int>> cur2;
	rs.resize(n);
	r.resize(n + 1, 1e9);
	r2.resize(n + 1, 1e9);
	for (int l = n - 1; l >= 0; --l) {
		if (cur[a[l]].size()) cur2.erase({cur[a[l]].back(), a[l]});
		cur2.insert({l, a[l]});
		cur[a[l]].push_back(l);
		vector<int> nums;
		if (a[l] == 1) {
			r[l] = l + 1;
			nums.push_back(1);
			for (auto e : nums) {
				if (cur[e].size() == e) continue;
				r2[l] = min(r2[l], cur[e][cur[e].size() - (e + 1)]);
			}
			r2[l] = min(r2[l], r2[r[l]]);
			continue;
		}
		int t = l;
		int summ = 0;
		for (auto e : cur2) {
			if (e.first != l && e.first >= t) break;
			int xx = e.second;
			if (cur[xx].size() < xx) {
				t = 1e9;
				break;
			}
			// cout << e.first << ' ' << e.second << '\n';
			summ += xx;
			t += xx;
			// t = max(t, cur[xx][cur[xx].size() - xx]);
		}
		// cout << l << ' ' << t << '\n';
		// cout << t + 1 - l << ' ' << summ << '\n';
		// if (t - l != summ) {
		// 	continue;
		// }
		r[l] = t;
		if (r[l] != 1e9) {
			for (auto e : cur2) {
				if (e.first < r[l]) nums.push_back(e.second);
				else break;
			}
		}
		bool ok = 1;
		for (auto e : nums) {
			if (cur[e][cur[e].size() - e] >= r[l]) {
				ok = 0;
				break;
			}
		}
		if (!ok) {
			r[l] = 1e9;
			nums.clear();
		}
		if (r[l] <= n) {
			for (auto e : nums) {
				if (cur[e].size() == e) continue;
				r2[l] = min(r2[l], cur[e][cur[e].size() - (e + 1)]);
			}
			r2[l] = min(r2[l], r2[r[l]]);
		}
	}
	for (int i = 0; i < n; ++i) {
		int t = i;
		while (r[t] <= n && r[t] <= r2[i]) {
			rs[i].push_back(r[t]);
			// cout << i << ' ' << r[t] << '\n';
			kek[r[t] - 1]++;
			lol[block_num[i]][r[t] - 1]++;
			t = r[t];
		}
	}
	for (int i = 1; i < n; ++i) kek[i] += kek[i - 1];
	for (auto &e : lol) {
		for (int i = 1; i < n; ++i) {
			e[i] += e[i - 1];
		}
		// for (auto i : e) cout << i << ' ';
		// cout << '\n';
	}
}

long long query(int ql, int qr) {
	if (qr - ql <= K) {
		long long ans = 0;
		for (int i = ql; i <= qr; ++i) {
			if (r[i] > qr + 1) continue;
            int l = -1, r = rs[i].size();
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (rs[i][m] <= qr + 1) l = m;
                else r = m;
            }
            ans += r;
		}
		return ans;
	}
	long long ans = kek[qr];
	if (ql == 0) return ans;
    for (int i = 0; i < block_num[ql]; ++i) ans -= lol[i][qr];
	for (int i = ql - 1; (i >= 0 && block_num[i] == block_num[ql]); --i) {
		if (r[i] > qr + 1) continue;
		int l = -1, r = rs[i].size();
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (rs[i][m] <= qr + 1) l = m;
			else r = m;
		}
		ans -= r;
	}
	return ans;
}

#ifdef LOCAL
int main(){
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
#endif