#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

const int N = 2 + 2, N1 = 5002, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool used[N][N];
bool investigate(int s);
bool goDeeper(int s);
vector<vector<bool>> b = { {0, 0, 1, 1}, {0, 1, 1, 1}, {0, 1, 0, 0} };
int cur = 0, cnt = 0;
bool investigate(int s) {
    ++cnt;
    return b[cur][s];
}
bool goDeeper(int s) {
    cout << s << '\n';
    ++cur;
    return true;
}
int dp[N1][N], dp2[N1][N][N], opt[N1][N][N];

void solve(int n, int m, int pos, const vector<vector<bool>>& a) {
    for (int i = 0; i < m; ++i) {
        used[n][i] = true;
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (!a[i][j] && used[i + 1][j]) used[i][j] = true;
        }
        for (int j = 1; j < m; ++j) {
            if (!a[i][j]) used[i][j] |= used[i][j - 1];
        }
        for (int j = m - 2; j >= 0; --j) {
            if (!a[i][j]) used[i][j] |= used[i][j + 1];
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        vector<int> bad;
        bad.push_back(-1);
        for (int j = 0; j < m; ++j) {
            if (!used[i][j]) bad.push_back(j);
        }
        bad.push_back(m);
        for (int j = 0; j + 1 < bad.size(); ++j) {
            int lg = bad[j] + 1, rg = bad[j + 1];
            for (int r = lg + 1; r <= rg; ++r) {
                if (used[i + 1][r - 1]) dp2[i][r - 1][r] = dp[i + 1][r - 1];
                else
                    dp2[i][r - 1][r] = -1;
                opt[i][r - 1][r] = r - 1;
                for (int l = r - 2; l >= lg; --l) {
                    dp2[i][l][r] = inf;
                    for (int x = max(l + 1, opt[i][l][r - 1]); x <= min(r - 1, opt[i][l + 1][r]); ++x) {
                        if (max(dp2[i][l][x], dp2[i][x][r]) + (dp2[i][l][x] != -1 && dp2[i][x][r] != -1) < dp2[i][l][r]) {
                            dp2[i][l][r] = max(dp2[i][l][x], dp2[i][x][r]) + (dp2[i][l][x] != -1 && dp2[i][x][r] != -1);
                            opt[i][l][r] = x;
                        }
                    }
                }
            }
            for (int l = lg; l < rg; ++l) dp[i][l] = dp2[i][lg][rg];
        }
    }
    for (int i = 0; i < n; ++i) {
        int l = pos, r = pos;
        for (; l > 0 && a[i][l - 1] == 0; --l);
        for (; r + 1 < m && a[i][r + 1] == 0; ++r);
        ++r;
        while (l + 1 < r) {
            int x = opt[i][l][r];
            if (dp2[i][l][x] == -1) l = x;
            else if (dp2[i][x][r] == -1) r = x;
            else if (pos >= x) {
                if (investigate(x - 1)) r = x;
                else
                    l = x;
            }
            else {
                if (investigate(x)) l = x;
                else
                    r = x;
            }
        }
        pos = l;
        goDeeper(pos);
    }
}

void solve() {
    solve(3, 4, 2, { {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0} });
    cout << cnt;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << endl;
    }
    return 0;
}