#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<bitset>
#include<stack>
#include<algorithm>
#include<ctime>
#include<random>
#include<unordered_map>
#include<unordered_set>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int N = 200 + 2, C = 63;
const ll llinf = 1e18 + 1000;

vector<pair<int, int>> encode(int n, vector<bool> a) {
    vector<pair<int, int>> g(n);
    int pt = C + 3;
    for (int i = 0; i <= C + 1; ++i) g.push_back({ i, i + 1 });
    for (int i = 0; i < C; ++i) {
        if (a[i]) {
            g.push_back({ i + 1, pt++ });
            g.push_back({ i + 1, pt++ });
        }
    }
    while (pt < n) g.push_back({ 0, pt++ });
    return g;
}
vector<int> g[N];
int mxh[N];
void dfs(int v, int p) {
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        mxh[v] = max(mxh[v], mxh[to] + 1);
    }
}
vector<bool> decode(int n, vector<pair<int, int>> edges) {
    ++n;
    g.resize(n);
    for (auto i : edges) {
        g[i.first].push_back(i.second);
        g[i.second].push_back(i.first);
    }
    vector<int> a;
    for (int v = 0; v < n; ++v) {
        bool isroot = false, f = false;
        for (auto to : g[v]) {
            if (g[to].size() >= 6) isroot = true;
            else if (g[to].size() > 1) f = true;
        }
        if (isroot && f) {
            a.push_back(v);
            break;
        }
    }
    dfs(a[0], -1);
    for (int it = 0; it + 1 < C; ++it) {
        int v = a.back();
        for (auto to : g[v]) {
            if (mxh[to] + 1 == mxh[v]) {
                v = to;
                break;
            }
        }
        a.push_back(v);
    }
    vector<bool> ans;
    for (auto v : a) {
        if (g[v].size() <= 3) ans.push_back(0);
        else
            ans.push_back(1);
    }
    while (ans.size() < 400) ans.push_back(0);
    return ans;
}

//void solve() {
//    
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//
//    int tt = 1;
//    //cin >> tt;
//    while (tt--) {
//        solve();
//        cout << endl;
//    }
//    return 0;
//}