#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    int x = k;
    for (int i = 0; i < n; i++) {
        int l = x;
        for (; l > 0 && !blocked[i][l - 1]; l--);
        int r = x;
        for (; r < n - 1 && !blocked[i][r + 1]; r++);
        while (r - l > 0) {
            int m = (l + r) / 2;
            if (m == x) {
                if (m == l) m++;
                else m--;
            }
            if (investigate(m)) {
                if (m < x) {
                    r = m;
                } else {
                    l = m;
                }
            } else {
                if (m < x) {
                    l = m + 1;
                } else {
                    r = m + 1;
                }
            }
        }
        goDeeper(l);
        x = l;
    }
}