#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    int x = k;
    for (int i = 0; i < n; i++) {
        int l = x;
        for (; l > 0 && !blocked[i][l - 1]; l--);
        int r = x;
        for (; r < m - 1 && !blocked[i][r + 1]; r++);
        int curx = -1;
        vector<int> tmp;
        for (int j = l; j <= r; j++) {
            if (i == n - 1 || !blocked[i + 1][j]) {
                if (j == x) curx = tmp.size();
                tmp.push_back(j);
            }
        }
        l = 0;
        r = tmp.size() - 1;
        while (r - l > 0) {
            int m = (l + r) / 2;
            if (m == curx) {
                if (m != r) m++;
                else m--;
            }
            if (investigate(tmp[m])) {
                if (m < x) {
                    r = m;
                } else {
                    l = m;
                }
            } else {
                if (m < x) {
                    l = m + 1;
                } else {
                    r = m + 1;
                }
            }
        }
        goDeeper(tmp[l]);
        x = tmp[l];
    }
}