#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> encode(int n, vector<bool> data) {
    int cnt_b = 60;
    vector<pair<int, int>> edges;
    for (int i = 0; i < cnt_b; ++i) {
        edges.emplace_back(i, i + 1);
    }
    int pos = cnt_b + 1;
    for (int i = 0; i < cnt_b; ++i) {
        if (data[i]) {
            edges.emplace_back(i + 1, pos);
            edges.emplace_back(pos, pos + 1);
            pos += 2;
        }
    }
    while (pos < n) {
        edges.emplace_back(0, pos);
    }
    return edges;
}

void calc_mx_d(int v, int pr, vector<int> &d, vector<int> &mx_d, vector<vector<int>> &g) {
    mx_d[v] = d[v];
    for (auto u : g[v]) {
        if (u != pr) {
            d[u] = d[v] + 1;
            calc_mx_d(u, v, d, mx_d, g);
            mx_d[v] = max(mx_d[v], mx_d[u]);
        }
    }
}

vector<bool> decode(int n, vector<pair<int, int>> tree) {
    int cnt_b = 60;
    vector<vector<int>> g(n + 1);
    for (auto [a, b] : tree) {
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int root = 0;
    for (int i = 0; i <= n; ++i) {
        if (g[i].size() > g[root].size()) {
            root = i;
        }
    }
    vector<int> d(n + 1), mx_d(n + 1);
    calc_mx_d(root, -1, d, mx_d, g);
    vector<int> path = {root};
    while (true) {
        bool check = false;
        for (auto nxt : g[path.back()]) {
            if (d[nxt] > d[path.back()] && mx_d[nxt] == mx_d[path.back()]) {
                path.push_back(nxt);
                check = true;
                break;
            }
        }
        if (!check) {
            break;
        }
    }
    vector<bool> ans(cnt_b);
    for (int i = 0; i < cnt_b; ++i) {
        for (auto j : g[path[i + 1]]) {
            if (d[j] > d[path[i]] && g[j].size() != 1 && (i + 2 == (int)path.size() || j != path[i + 2])) {
                ans[i] = true;
            }
        }
    }
    return ans;
}
