#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    vector<vector<int>> dist(n + 1, vector<int>(m, -1));
    queue<pair<int, int>> q;
    q.push({n, 0});
    dist[n][0] = 0;
    while (!q.empty()) {
        auto [i, j] = q.front(); 
        q.pop();
        if (i == n) {
            for (int jj = 0; jj < m; jj++) {
                if (!blocked[n - 1][jj] && dist[n - 1][jj] == -1) {
                    dist[n - 1][jj] = dist[i][j] + 1;
                    q.push({n - 1, jj});
                }
            }
        } else {
            if (j + 1 < m && !blocked[i][j + 1] && dist[i][j + 1] == -1) {
                dist[i][j + 1] = dist[i][j] + 1;
                q.push({i, j + 1});
            }
            if (j - 1 >= 0 && !blocked[i][j - 1] && dist[i][j - 1] == -1) {
                dist[i][j - 1] = dist[i][j] + 1;
                q.push({i, j - 1});
            }
            if (i - 1 >= 0 && !blocked[i - 1][j] && dist[i - 1][j] == -1) {
                dist[i - 1][j] = dist[i][j] + 1;
                q.push({i - 1, j});
            }
        }
    }
    int i = 0, j = k;
    while (i < n) {
        vector<int> poss;
        for (int jj = j - 1; jj >= 0; jj--) {
            if (blocked[i][jj]) break;
            if (i == n - 1) {
                poss.pb(jj);
                continue;
            }
            if ((i + 1 == n || !blocked[i + 1][jj]) && (i + 1 == n || dist[i + 1][jj] != -1)) poss.pb(jj);
        }
        reverse(all(poss)); 
        if (i == n - 1) poss.pb(j);
        else if (!blocked[i + 1][j] && dist[i + 1][j] != -1) poss.pb(j);
        for (int jj = j + 1; jj < m; jj++) {
            if (blocked[i][jj]) break;
            if (i == n - 1) {
                poss.pb(jj); continue;
            }
            if ((i + 1 == n || !blocked[i + 1][jj]) && (i + 1 == n || dist[i + 1][jj] != -1)) poss.pb(jj);
        }
        // cout << j << endl;
        // for(int u : poss) cout << u << ' ';
        // cout << endl;
        int L = 0, R = sz(poss) - 1;
        while (R - L >= 1) {
            int mid = (L + R) / 2;
            if (poss[mid] == j) {
                if (mid + 1 <= R) mid++;
                else mid--;
            }
            if (poss[mid] > j) {
                if (mid == (L + R) / 2 && L % 2 != R % 2) mid++;
            }
            if (investigate(poss[mid])) {
                if (poss[mid] > j) {
                    L = mid;
                } else {
                    R = mid;
                }
            } else {
                if (poss[mid] > j) {
                    R = mid - 1;
                } else {
                    L = mid + 1;
                }
            }
        }
        j = poss[L];
        i++;
        goDeeper(j);
    }
    return;
}