#include <bits/stdc++.h>
#include <cassert>
using namespace std;
using ll = long long;

vector<pair<int, int>> segs;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int) (x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void init(int N, int Q, const vector<int> &a) {
    vector<vector<int>> rnum(N + 1);
    vector<int> cnt(N + 1);
    for (int u : a) cnt[u]++;
    for (int x = 1; x <= N; x++) {
        rnum[x].assign(min(x, cnt[x]), 0);
        int xr = 0;
        for (int j = 0; j < min(x - 1, sz(rnum[x])); j++) {
            rnum[x][j] = rnd() % 1000000000;
            xr ^= rnum[x][j];
        }
        if (rnum[x].size() == x) {
            rnum[x][x - 1] = xr;
        }
    }
    int n = N;
    vector<int> curcnt(N + 1, 0);
    vector<int> pref(N + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] ^ rnum[a[i]][curcnt[a[i]] % sz(rnum[a[i]])];
        curcnt[a[i]]++;
    }

    map<int, vector<int>> poss;
    poss[pref[n]].pb(n);
    set<int> st;
    curcnt.assign(n + 1, 0);
    vector<vector<int>> pos(n + 1);
    for (int i = 0; i < n; i++) pos[a[i]].pb(i);
    vector<int> id(n + 1);
    for (int i =0; i <= n; i++) id[i] = sz(pos[i]) - 1;
    for (int i = n - 1; i >= 0; i--) {
        if (curcnt[a[i]] > a[i]) {
            st.erase(pos[a[i]][id[a[i]]]);
            id[a[i]]--;
        }
        curcnt[a[i]]++;
        if (curcnt[a[i]] > a[i]) {
            st.insert(pos[a[i]][id[a[i]]]);
        }
        if (poss.find(pref[i]) != poss.end()) {
            int I = sz(poss[pref[i]]) - 1;
            while (I >= 0 && poss[pref[i]][I] <= (st.empty() ? n : *st.begin())) {
                segs.pb({i, poss[pref[i]][I] - 1});
                I--;
            }
        }   
        poss[pref[i]].pb(i);
    }
}

ll query(int l, int r) {
    int cnt = 0;
    for (int i = 0; i < sz(segs); i++) {
        cnt += (segs[i].first >= l && segs[i].second <= r);
    }
    return cnt;
}