#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include "tunnels.h"
using namespace std;
//bool investigate(int s);
//bool goDeeper(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& bl) {
	vector<vector<int>> t(n, vector<int>(m));
	queue<pair<int, int>> q;
	for (int i = 0; i < m; ++i) {
		if (!bl[n - 1][i]) {
			q.push({n - 1, i});
			t[n - 1][i] = 1;
		}
	}
	while (!q.empty()) {
		auto xy = q.front();
		q.pop();
		if (xy.first > 0) {
			if (!bl[xy.first - 1][xy.second]) {
				if (!t[xy.first - 1][xy.second]) {
					q.push({ xy.first - 1, xy.second });
					t[xy.first - 1][xy.second] = 1;
				}
			}
		}
		if (xy.second > 0) {
			if (!bl[xy.first][xy.second - 1]) {
				if (!t[xy.first][xy.second - 1]) {
					q.push({ xy.first, xy.second - 1 });
					t[xy.first][xy.second - 1] = 1;
				}
			}
		}
		if (xy.second < m -  1) {
			if (!bl[xy.first][xy.second + 1]) {
				if (!t[xy.first][xy.second + 1]) {
					q.push({ xy.first, xy.second + 1 });
					t[xy.first][xy.second + 1] = 1;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		vector<int> ls, mr;
		int x = k - 1;
		while (x >= 0 && !bl[i][x]) {
			if (i == n - 1 || t[i + 1][x]) {
				ls.push_back(x);
			}
		}
		reverse(ls.begin(), ls.end());
		x = k + 1;
		while (x < m && !bl[i][x]) {
			if (i == n - 1 || t[i + 1][x]) {
				mr.push_back(x);
			}
		}
		int lt = -1, rt = 52;
		bool fl = 0;
		if (mr.empty()) {
			fl = 1;
		}
		else if (!ls.empty()) {
			int xt = ls.size() + mr.size();
			xt /= 2;
			if (ls.size() > mr.size()) {
				if (investigate(ls[xt])) {
					rt = xt;
				}
				else {
					rt = mr.size();
					fl = 1;
				}
			}
			else {
				if (investigate(mr[xt - ls.size()])) {
					rt = mr.size();
					lt = xt - ls.size();
					fl = 1;
				}
				else {
					rt = ls.size();
				}
			}
		}
		if (fl) {
			while (rt - lt > 1) {
				int md = (lt + rt) / 2;
				if (investigate(mr[md])) {
					lt = md;
				}
				else {
					rt = md;
				}
			}
			if (lt == -1) {
				goDeeper(k);
			}
			else {
				goDeeper(mr[lt]);
				k = mr[lt];
			}
		}
		else {
			while (rt - lt > 1) {
				int md = (lt + rt) / 2;
				if (investigate(ls[md])) {
					rt = md;
				}
				else {
					lt = md;
				}
			}
			if (rt = ls.size()) {
				goDeeper(k);
			}
			else {
				goDeeper(ls[rt]);
				k = ls[rt];
			}
		}
	}
}