#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

const int INF = 1e9;
void solve(int n, int m, int k, const vector<vector<bool> > &blocked) {
    vector<vi> Reach(n + 1, vi(m, 0));
    Reach[n] = vi(m, 1);

    for(int i = n - 1; i >= 0; --i) {
        for(int j = 0; j < m; ++j) {
            if(!blocked[i][j]) {
                Reach[i][j] |= Reach[i + 1][j];
                if(j)
                    Reach[i][j] |= Reach[i][j - 1];
            }
        }
        for(int j = m - 2; j >= 0; --j) {
            if(!blocked[i][j])
                Reach[i][j] |= Reach[i][j + 1];
        }
    }

    array<vector<vi>, 2> DP{vector(m + 1, vi(m + 1, INF)), vector(m + 1, vi(m + 1, INF))};
    array<vector<vi>, 2> Tip{vector(m + 1, vi(m + 1, 0)), vector(m + 1, vi(m + 1, 0))};
    array<vector<vi>, 2> PozQ{vector(m + 1, vi(m + 1, 0)), vector(m + 1, vi(m + 1, 0))};
    //vector<vi> Tip(m + 1, vi(m + 1, 0)), PozQ(m + 1, vi(m + 1, 0));
    DP[0][0][0] = 0; /// nu are sens
    DP[0][0][1] = 0; 
    DP[0][1][0] = 0;  /// p nu se poate

    DP[1][0][0] = 0;

//    for(int i = 1; i <= m; ++i) {
   //     DP[0][0][i] = DP[0][i][0] = 31 - __builtin_clz(i); /// p nu se poate
   //     DP[1][0][i] = DP[1][i][0] = 31 - __builtin_clz(i + 1); /// p se poate
        //cerr << "Pt " << i << " " << DP[0][i] << "\n";
 //   }

    for(int tip = 0; tip < 2; ++tip) {
        for(int l2 = 0; l2 <= m; ++l2) {
            int best_i = 0;
            for(int l1 = 1; l1 <= m; ++l1) {
                while(best_i + 1 < l1 &&
                    max(DP[tip][best_i][0], DP[tip][l1 - 1 - best_i][l2]) >=
                    max(DP[tip][best_i + 1][0], DP[tip][l1 - 1 - best_i - 1][l2]))
                     ++best_i;
                int v = max(DP[tip][best_i][0], DP[tip][l1 - 1 - best_i][l2]);
                if(DP[tip][l1][l2] > v) {
                    DP[tip][l1][l2] = v;
                    Tip[tip][l1][l2] = 0;
                    PozQ[tip][l1][l2] = best_i;
                }
            }
        }
        for(int l1 = 0; l1 <= m; ++l1) {
            int best_i = 0;
            for(int l2 = 1; l2 <= m; ++l2) {
                while(best_i + 1 < l2 &&
                    max(DP[tip][0][best_i], DP[tip][l1][l2 - 1 - best_i]) >=
                    max(DP[tip][0][best_i + 1], DP[tip][l1][l2 - 1 - best_i - 1])) ++best_i;

                int v = max(DP[tip][0][best_i], DP[tip][l1][l2 - 1 - best_i]);
                if(DP[tip][l1][l2] > v) {
                    DP[tip][l1][l2] = v;
                    Tip[tip][l1][l2] = 1;
                    PozQ[tip][l1][l2] = best_i;
                }
            }
        }
    }

    auto play = [&](int niv, int p) -> int {
        ///returns next position in layer niv + 1(and calls goDeeper)
        int l1_orig = 0, l2_orig = 0;
        while(p - l1_orig > 0 && !blocked[niv][p - l1_orig - 1]) ++l1_orig;
        while(p + l2_orig + 1 < m && !blocked[niv][p + l2_orig + 1]) ++l2_orig;
        int l1 = 0, l2 = 0;
        vi PozL1, PozL2, PozL;
        for(int j = p - l1_orig; j < p; ++j) {
            if(Reach[niv][j] && Reach[niv + 1][j]) {
                PozL1.push_back(j);
                PozL.push_back(j);
            }
        }

        PozL.push_back(p); // Nu are sens efectiv, nu se poate p uneori
        int p_reach = (int)PozL.size() - 1;
        for(int j = p + l2_orig; j > p; --j) {
            if(Reach[niv][j] && Reach[niv + 1][j]) {
                PozL2.push_back(j);
                PozL.push_back(j);
            }
        }
        sort(PozL.begin(), PozL.end());

        l1 = (int)PozL1.size(); l2 = (int)PozL2.size();


        while(l1 || l2) {
            int tip_intrare = (Reach[niv][PozL[p_reach]] && Reach[niv + 1][PozL[p_reach]]);
            if(!tip_intrare) {
                if(l1 == 1 && !l2) {
                    p_reach--;
                    break;
                }
                if(!l1 && l2 == 1) {
                    p_reach++;
                    break;
                }
            }
            int tip = Tip[tip_intrare][l1][l2], poz_rel = PozQ[tip_intrare][l1][l2];
            int poz_query = 0, i = poz_rel;
            if(!tip) {
                poz_query = p_reach - l1 + poz_rel;
            } else {
                poz_query = p_reach + l2 - poz_rel;
            }
            int v = investigate(PozL[poz_query]);
            if(v) {
                if(!tip) {
                    l1 = i; l2 = 0; p_reach = poz_query;
                } else {
                    l1 = 0; l2 = i; p_reach = poz_query;
                }
            } else {
                if(!tip) {
                    l1 -= i + 1;
                } else {
                    l2 -= i + 1;
                }
            }
        }

        /// should have remained with a single p hopefully

        goDeeper(PozL[p_reach]);
        return PozL[p_reach];
    };

    int p = k;
    for(int i = 0; i < n; ++i) {
        p = play(i, p);
    }
}

//int main() {
//    cin.tie(0);
//    ios_base::sync_with_stdio(0);
//
//    return 0;
//}