#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX = 405;

vector<pair<int, int>> encode(int n, vector<bool> b)
{
    vector<int> v[MAX];
    int op = n - 1;
    set<int> s;
    for (int i = 5; i < n; i++)
    {
        s.insert(i);
    }
    for (int i = 1; i <= 4; i++)
    {
        v[0].push_back(i);
        op--;
    }
    if (b[0] == 1)
    {
        v[0].push_back(*s.begin());
        s.erase(s.begin());
        v[0].push_back(*s.begin());
        s.erase(s.begin());
        op -= 2;
    }
    int p = 0;
    for (int i = 1; i < n; i++)
    {
        if (op == 0)
            break;
        v[p].push_back(*s.begin());
        p = *s.begin();
        op--;
        if (b[i] == 1) // or different
        {
            if (op == 0)
                break;
            v[p].push_back(*s.begin());
            s.erase(s.begin());
            op--;
            if (op == 0)
                break;
            op--;
            v[p].push_back(*s.begin());
            s.erase(s.begin());
        }
    }
    vector<pair<int, int>> enc;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            enc.push_back({i, v[i][j]});
        }
    }
    return enc;
}

vector<int> v[MAX], path;
bool used[MAX];
int p[MAX];

void Dfs(int g)
{
    used[g] = 1;
    p[g] = 0;
    int nb;
    for (int i = 0; i < v[g].size(); i++)
    {
        nb = v[g][i];
        if (!used[nb])
        {
            Dfs(nb);
            p[g] = max(p[g], p[nb] + 1);
        }
    }
}

void Dfs2(int g)
{
    used[g] = 1;
    int nb, op = -1;
    for (int i = 0; i < v[g].size(); i++)
    {
        nb = v[g][i];
        if (!used[nb])
        {
            if (op == -1 || p[nb] > p[op])
                op = nb;
        }
    }
    if (op != -1)
    {
        path.push_back(op);
        Dfs2(op);
    }
}

vector<bool> decode(int n, vector<pair<int, int>> tree)
{
    for (int i = 0; i < tree.size(); i++)
    {
        v[tree[i].first].push_back(tree[i].second);
        v[tree[i].second].push_back(tree[i].first);
    }
    int root;
    for (int i = 0; i <= n; i++)
    {
        if (v[i].size() >= 5)
            root = i;
    }
    Dfs(root);
    for (int i = 0; i <= n; i++)
        used[i] = 0;
    Dfs2(root);
    vector<bool> dec;
    for (int i = 0; i < 2 * n; i++)
    {
        dec.push_back(0);
    }
    for (int i = 0; i < path.size(); i++)
    {
        if (i == 0)
        {
            if (v[path[i]].size() >= 7)
                dec[i] = 1;
        }
        else
        {
            if (v[path[i]].size() >= 3)
                dec[i] = 1;
        }
    }
    return dec;
}