#include <bits/stdc++.h>
using namespace std;

const int MAX = 405;

vector<pair<int, int>> encode(int n, vector<bool> b)
{
    vector<int> v[MAX];
    int op = n - 1;
    set<int> s;
    for (int i = 5; i < n; i++)
    {
        s.insert(i);
    }
    for (int i = 1; i <= 4; i++)
    {
        v[0].push_back(i);
        op--;
    }
    if (b[0] == 1)
    {
        v[0].push_back(*s.begin());
        s.erase(s.begin());
        v[0].push_back(*s.begin());
        s.erase(s.begin());
        op -= 2;
    }
    int p = 0;
    for (int i = 1; i < n; i++)
    {
        if (op == 0)
            break;
        v[p].push_back(*s.begin());
        p = *s.begin();
        s.erase(*s.begin());
        op--;
        if (b[i] == 1)
        {
            if (op == 0)
                break;
            v[p].push_back(*s.begin());
            s.erase(s.begin());
            op--;
            if (op == 0)
                break;
            op--;
            v[p].push_back(*s.begin());
            s.erase(s.begin());
        }
    }
    vector<pair<int, int>> enc;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            enc.push_back({i, v[i][j]});
        }
    }
    return enc;
}

vector<int> v[MAX], path;
bool used[MAX];
int p[MAX];

void Dfs(int g)
{
    used[g] = 1;
    p[g] = 0;
    int nb;
    for (int i = 0; i < v[g].size(); i++)
    {
        nb = v[g][i];
        if (!used[nb])
        {
            Dfs(nb);
            p[g] = max(p[g], p[nb] + 1);
        }
    }
}

void Dfs2(int g)
{
    used[g] = 1;
    int nb, op = -1;
    for (int i = 0; i < v[g].size(); i++)
    {
        nb = v[g][i];
        if (!used[nb])
        {
            if (op == -1 || p[nb] > p[op])
                op = nb;
        }
    }
    if (op != -1)
    {
        path.push_back(op);
        Dfs2(op);
    }
}

vector<bool> decode(int n, vector<pair<int, int>> tree)
{
    for (int i = 0; i < tree.size(); i++)
    {
        v[tree[i].first].push_back(tree[i].second);
        v[tree[i].second].push_back(tree[i].first);
    }
    int root;
    for (int i = 0; i <= n; i++)
    {
        if (v[i].size() >= 5)
            root = i;
    }
    for (int i = 0; i <= n; i++)
        used[i] = 0;
    vector<bool> dec;
    for (int i = 0; i < 2 * n; i++)
    {
        dec.push_back(0);
    }
    int g = root, next, nb, op, nb2, pp = 0;
    while (true)
    {
        used[g] = 1;
        next = -1;
        for (int i = 0; i < v[g].size(); i++)
        {
            nb = v[g][i];
            if (!used[nb])
            {
                op = 0;
                for (int i = 0; i < v[nb].size(); i++)
                {
                    nb2 = v[nb][i];
                    if (!used[nb2])
                        op++;
                }
                if (op != 0)
                {
                    next = nb;
                }
            }
        }
        if (next == -1)
            break;
        if (g == root)
        {
            if (v[g].size() >= 7)
                dec[pp] = 1;
            pp++;
        }
        else
        {
            if (v[g].size() >= 4)
                dec[pp] = 1;
            pp++;
        }
        g = next;
    }
    for (int i = 0; i < path.size(); i++)
    {
        if (i == 0)
        {
            if (v[path[i]].size() >= 7)
                dec[i] = 1;
        }
        else
        {
            if (v[path[i]].size() >= 3)
                dec[i] = 1;
        }
    }
    return dec;
}

static void dfs(int u, vector<bool> &vis, const vector<vector<int>> &adj)
{
    vis[u] = true;

    for (int to : adj[u])
    {
        if (vis[to])
        {
            continue;
        }

        dfs(to, vis, adj);
    }
}

static bool forms_tree(vector<pair<int, int>> edges, int n)
{
    vector<vector<int>> adj(n);
    for (auto [u, v] : edges)
    {

        if (u < 0 || v < 0 || u >= n || v >= n)
        {
            return false;
        }
        if (u == v)
        {
            return false;
        }

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    vector<bool> vis(n, false);

    dfs(0, vis, adj);

    for (int i = 0; i < n; ++i)
    {
        if (!vis[i])
        {
            return false;
        }
    }

    return true;
}

const int RANDOM_SEED = 0;
mt19937 random_generator(RANDOM_SEED);

static vector<pair<int, int>> corrupt(vector<pair<int, int>> edges, int n, int node_to_attach_to)
{
    edges.push_back({node_to_attach_to, n});

    vector<int> permutation(n + 1);
    for (int i = 0; i <= n; ++i)
    {
        permutation[i] = i;
    }

    shuffle(permutation.begin(), permutation.end(), random_generator);
    shuffle(edges.begin(), edges.end(), random_generator);

    for (auto &[u, v] : edges)
    {
        u = permutation[u];
        v = permutation[v];

        if (random_generator() % 2)
        {
            swap(u, v);
        }
    }

    return edges;
}

static int runTest()
{
    int n;
    cout << "n: ";
    cin >> n;

    int data_length;
    cout << "data_length: ";
    cin >> data_length;

    vector<bool> data(data_length);
    cout << "data: ";
    for (int i = 0; i < data_length; ++i)
    {
        char bit;
        cin >> bit;

        data[i] = bit == '1';
    }

    vector<pair<int, int>> tree_edges = encode(n, data);
    for (int i = 0; i < tree_edges.size(); i++)
    {
        cout << tree_edges[i].first << " " << tree_edges[i].second << endl;
    }

    assert(forms_tree(tree_edges, n));

    int min_prefix = 1e9;

    for (int node_to_attach_to = 0; node_to_attach_to < n; ++node_to_attach_to)
    {
        vector<pair<int, int>> corrupted_edges = corrupt(tree_edges, n, node_to_attach_to);
        for (int i = 0; i < corrupted_edges.size(); i++)
        {
            cout << corrupted_edges[i].first << " " << corrupted_edges[i].second << endl;
        }
        cout<<endl;

        vector<bool> decoded_data = decode(n, corrupted_edges);
        for (int i = 0; i < decoded_data.size(); i++)
        {
            cout << decoded_data[i];
        }
        cout << endl;

        int correct_prefix = 0;
        while (correct_prefix < (int)std::min(decoded_data.size(), data.size()) && decoded_data[correct_prefix] == data[correct_prefix])
        {
            ++correct_prefix;
        }
        min_prefix = min(min_prefix, correct_prefix);
    }

    return min_prefix;
}

int main()
{
    cout << "t: ";
    int t;
    cin >> t;

    int min_bits_guessed = 1e9;
    for (int i = 0; i < t; i++)
    {
        int bits = runTest();
        cerr << "Guessed " << bits << " bits correctly in test #" << i << endl;

        min_bits_guessed = min(min_bits_guessed, bits);
    }
    cerr << endl;
    cerr << "Guessed a minimum of " << min_bits_guessed << " correctly" << endl;

    return 0;
}
