#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 5000 + 2;
const int INF = 1e9 + 2;

int NN, MM;

void solve(int N, int M, int k, const vector<vector<bool>>& blocked) {
    NN = N;
    MM = M;

    int currentX = k, currentY = 0;
    while (currentY < NN) {
        int l = 0, r = M - 1, mid, ans = currentX;

        while (l <= r) {
            mid = (l + r) / 2;
            if (mid == currentX) mid--;
            if (mid < l) mid = currentX + 1;
            if (mid > r) {
                break;
            }

            if (investigate(mid)) {
                ans = mid;
                if (currentX < mid) {
                    l = mid + 1;
                } else {
                    r = mid - 1;
                }
            } else {
                if (currentX < mid) {
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }
        }

        currentX = ans;
        currentY++;
        goDeeper(currentX);
    }
}