#include <bits/stdc++.h>

#include "tunnels.h"

using namespace std;

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const long long MAX_N = 5000 + 2;
const long long INF = 1e9 + 2;

long long NN, MM;

void getPositions(long long x, long long y, long long dx, const vector<vector<bool>>& blocked, vector<long long>& v) {
    while (x >= 0 && x < MM) {
        if (blocked[y][x]) break;
        if (y < NN - 1 && blocked[y + 1][x]) {
            x += dx;
            continue;
        }
        v.push_back(x);
        x += dx;
    }
}

void solve(long long N, long long M, long long k, const vector<vector<bool>>& blocked) {
    NN = N;
    MM = M;

    long long currentX = k, currentY = 0;
    while (currentY < NN) {
        vector<long long> pos;
        getPositions(currentX - 1, currentY, -1, blocked, pos);
        getPositions(currentX + 1, currentY, 1, blocked, pos);
        sort(pos.begin(), pos.end());

        if (pos.size() == 1) {
            currentX = pos[0];
            currentY++;
            goDeeper(currentX);
            continue;
        }

        // cerr << "Level " << currentY << " -> ";
        // for (long long i = 0; i < pos.size(); i++) cerr << pos[i] << " ";
        // cerr << endl;

        long long l = 0, r = pos.size() - 1, mid, ans = currentX;

        while (l <= r) {
            mid = (l + r) / 2;

            if (investigate(pos[mid])) {
                ans = pos[mid];
                if (currentX < pos[mid]) {
                    l = mid + 1;
                } else {
                    r = mid - 1;
                }
            } else {
                if (currentX < pos[mid]) {
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }
        }

        currentX = ans;
        currentY++;
        goDeeper(currentX);
    }
}