#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 5000 + 2;
const int INF = 1e9 + 2;

int cnt[MAX_N][MAX_N];
vector<int> v;

void init(int N, int Q, const vector<int>& a) {
    v = a;

    if (v[0] > N) {
        v[0] = INF;
    } else {
        cnt[0][v[0]] = 1;
    }

    cerr << v[0] << " ";

    for (int i = 1; i < N; i++) {
        if (v[i] > N) v[i] = INF;
        for (int j = 0; j < N; j++) {
            cnt[i][j] = cnt[i - 1][j];
        }
        if (v[i] < N) cnt[i][v[i]]++;
        cerr << v[i] << " ";
    }

    cerr << endl;
}

int pref(int ind, int number) {
    if (ind < 0) return 0;
    return cnt[ind][number];
}

int count(int l, int r, int number) {
    return pref(r, number) - pref(l - 1, number);
}

long long query(int l, int r) {
    long long ans = 0;

    for (int ll = l; ll <= r; ll++) {
        vector<int> numbers;
        bool isOk = true;
        for (int rr = ll; rr <= r; rr++) {
            if (v[rr] > v.size()) break;

            int cnt = count(ll, rr, v[rr]);
            if (cnt > v[rr]) break;

            numbers.push_back(v[rr]);

            if (cnt == v[rr]) {
                if (isOk) {
                    ans++;
                    cerr << "(" << ll << ", " << rr << ") - I" << endl;
                    continue;
                }
                isOk = true;
                for (int i = 0; i < numbers.size(); i++) {
                    if (count(ll, rr, numbers[i]) != numbers[i]) {
                        isOk = false;
                        break;
                    }
                }
                if (isOk) {
                    ans++;
                    cerr << "(" << ll << ", " << rr << ") - II" << endl;
                    continue;
                }
            }
            if (cnt < v[rr]) isOk = false;
        }
    }

    return ans;
}
