# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "tunnels.h"
//# include "Lgrader.cpp"

const int MAX=5e3+11;

bool B[MAX][MAX];

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++) B[i][j]=blocked[i][j];
    }
    for(int j=0;j<m;j++) B[n][j]=0;

    int now=k;
    for(int i=0;i<n;i++)
    {
        if(B[i][now^1] or B[i+1][now^1])
        {
            goDeeper(now);
        }
        else if(B[i+1][now])
        {
            now^=1;
            goDeeper(now);
        }
        else
        {
            if(investigate(now)) goDeeper(now);
            else
            {
                now^=1;
                goDeeper(now);
            }
        }
    }
}
