# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;
# include "bits_and_tree.h"
//# include "Lgrader.cpp"

const int MAX=211;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> edges;
    if(data[0]==0)
    {
        for(int i=0;i<n-1;i++) edges.push_back({i,i+1});
    }
    else
    {
        for(int i=0;i<=3;i++) edges.push_back({i,4});
        for(int i=4;i<n-1;i++) edges.push_back({i,i+1});
    }

    return edges;
}

int deg[MAX];

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    for(int i=0;i<=n;i++) deg[i]=0;

    for(pair<int,int> pa: tree)
    {
        int u=pa.first,v=pa.second;
        deg[u]++;
        deg[v]++;
    }

    for(int i=0;i<=n;i++)
    {
        if(deg[i]>=4) return {1};
    }

    return {0};
}


