# include <iostream>
# include <vector>
# include <algorithm>
# include <cmath>
using namespace std;

const int MAX=3e5+11;

int A[MAX];

void init(int N, int Q, const std::vector<int>& a)
{
    for(int i=1;i<=N;i++) A[i]=a[i-1];
}

int cnt[MAX];

long long query(int l, int r)
{
    l++;r++;

    int sz=(r-l+1);
    int S=(int)sqrt(sz)+1;

    int ans=0;
    for(int i=l;i<=r;i++)
    {
        int diff=0,J=i,br=0;
        for(int j=i;j<=r;j++)
        {
            J=j;
            cnt[A[j]]++;
            if(cnt[A[j]]==1) diff++;
            //if(diff>S) break;
            if(cnt[A[j]]==A[j]) br++;
            if(cnt[A[j]]>A[j]) break;

            if(diff==br) ans++;
        }

        for(int j=i;j<=J;j++)
        {
            cnt[A[j]]--;
        }
    }

    return ans;
}