# include <bits/stdc++.h>
# include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, vector<vector<bool>>& blocked)
{
    int level = 0;

    while(level < n)
    {
        vector<int> possible;

        for(int i = k; i >= 0; i--)
        {
            if(!blocked[level][i])
            {
                if(level <= n - 2 && !blocked[level + 1][i] || level == n - 1)
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        for(int i = k + 1; i < m; i++)
        {
            if(!blocked[level][i])
            {
                if(level <= n - 2 && !blocked[level + 1][i] || level == n - 1)
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        if((int)possible.size() == 1)
        {
            goDeeper(possible[0]);
            k = possible[0];
            level++;
        }
        else
        {
            for(auto& i : possible)
            {
                if(investigate(i))
                {
                    goDeeper(i);
                    k = i;
                    level++;
                    break;
                }
            }
        }
    }
}
