# include <bits/stdc++.h>
# include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int level = 0;
    int in = k;

    while(level < n)
    {
        vector<int> possible;

        for(int i = in; i >= 0; i--)
        {
            if(!blocked[level][i])
            {
                if(level <= n - 2 && !blocked[level + 1][i] || level == n - 1)
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        for(int i = in + 1; i < m; i++)
        {
            if(!blocked[level][i])
            {
                if(level <= n - 2 && !blocked[level + 1][i] || level == n - 1)
                {
                    possible.push_back(i);
                }
            }
            else
            {
                break;
            }
        }

        int left = (int)possible.size();
        for(auto& i : possible)
        {
            if(left == 1 || investigate(i))
            {
                goDeeper(i);
                in = i;
                level++;
                break;
            }

            left--;
        }
    }
}

/*
5 2 0
0 0
0 0
0 0
0 0
0 0
*/
