#include "tunnels.h"
#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

const int MAXN = 5e3 + 10;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    if(m > 2)
    {
        int from = -1;
        int cur = k;

        int level = 0;

        while(level < n)
        {
            if(0 < cur && from != cur - 1 && investigate(cur - 1))
            {
                cur = cur - 1;
                from = cur + 1;
                continue;
            }

            if(cur < m - 1 && from != cur + 1 && investigate(cur + 1))
            {
                cur = cur + 1;
                from = cur - 1;
                continue;
            }

            from = -1;
            goDeeper(cur);
            level++;
        }

        return;
    }
        

    int cur = k;

    for(int level = 0; level < n; level++)
    {
        //cout << "Currently on level : " << level << " in chamber " << cur << endl;
        if(blocked[level][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(level == n - 1)
        {
            if(investigate(!cur))
                goDeeper(!cur);
            else
                goDeeper(cur);
                
            continue;
        }
        
        if(blocked[level + 1][cur])
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }

        if(blocked[level + 1][!cur])
        {
            goDeeper(cur);
            continue;
        }

        if(investigate(!cur))
        {
            cur = !cur;
            goDeeper(cur);
            continue;
        }
        else
        {
            goDeeper(cur);
            continue;
        }
    }
}