#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAXN=1e5+1;
ll tree[4*MAXN],a[MAXN];


void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void init(int l, int r, ll idx)
{
    if(l==r)
    {
        tree[idx]=a[l];
        return;
    }
    ll m=(l+r)/2;
    init(idx*2,l,m);
    init(idx*2+1,m+1,r);
    tree[idx]=tree[idx*2]+tree[idx*2+1];
}

void update(ll idx,ll l,ll r,ll pos,ll val)
{
    if(pos>r || pos>l)return;
    if(l==r)
    {
        tree[idx]=pos;
        return;
    }
    ll m=(l+r)/2;
    update(idx*2,l,m,pos,val);
    update(idx*2+1,m+1,r,pos,val);
    tree[idx]=tree[idx*2]+tree[idx*2+1];
}

ll query(ll l,ll r)
{
    ll idx;
    ll ql;
    ll qr;
    if(l>qr || r<ql)return 0;
    if(l<=ql && r>qr)
    {
        return tree[idx];
    }
    return tree[idx]=tree[idx*2]+tree[idx*2+1];
}