#include <bits/stdc++.h>
#define ll unsigned long long int
using namespace std;
const int maxn = 5e4 + 20;



int tree[4*maxn];
int b[maxn];
void build(int l, int r, int v)
{
    if(l == r)
    {
        tree[v] = b[l];
        return;
    }
    int mid = l + (r - l)/2;
    build(l, mid, 2*v);
    build(mid+1, r, 2*v+1);
    tree[v] = max(tree[2*v], tree[2*v+1]);
}

int query(int l, int r, int v, int ql, int qr)
{
    if(ql > r || qr < l)return -1;
    if(ql <= l && qr >= r)return tree[v];
    int mid = l + (r - l)/2;
    return max(query(l, mid, 2*v, ql, qr), query(mid+1, r, 2*v+1, ql, qr));
}
int ans = 0;
void init(int n, int q, const vector<int>& a)
{
    for(int i = 0; i < n; i++)
    {
        b[i+1] = a[i];
    }
    build(1, n, 1);


    // l - 0, r - n-1
    for(int i = 0; i < n; i++)
    {
        for(int j = i; j <= n; j++)
        {
            int mx = query(1, n, 1, i+1, j+1);
            //cout << mx << " " << i << " " << j << endl;
            if(mx < 1 + (j - i))
            {
                vector<int> cnt(n);
                set<int>s;
                int br = 0;
                for(int k = i; k < j; k++)
                {
                    cnt[a[k]]++;
                    s.insert(a[k]);
                }

                for(auto x : s)
                {
                    if(cnt[x] == x)br++;
                }
                if(s.size() == br && br > 0)
                {
                    ans++;
                    //cout << i << " " << j << endl;
                }
            }
        }
    }
}

int query(int l, int r)
{
    return ans;
}


int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    std::vector<int> input(n);
    for(int i = 0; i < n; i ++)
    {
        std::cin >> input[i];
    }
    init(n, q, input);
    //cout << endl;
    for(int i = 0; i < q; i ++)
    {
        int l, r;
        std::cin >> l >> r;
        std::cout << query(l, r) << " ";
    }
    std::cout << std::endl;
}
