#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

vector<vector<bool>> poss, bl;
int N, M;

bool setPoss(int curY, int curX, int par) {
    if (curY == N) {
        poss[curY][curX] = 1;
        return 1;
    }
    if (curX < 0 || curX >= M) { return false; }
    if (bl[curY][curX]) { return false; }
    if (par != -1) {
        if (setPoss(curY, curX - 1, 1)) {
            poss[curY][curX] = 1;
        }
    }
    if (par != 1) {
        if (setPoss(curY, curX + 1, -1)) {
            poss[curY][curX] = 1;
        }
    }
    if (setPoss(curY + 1, curX, 0)) {
        poss[curY][curX] = 1;
    }
    return poss[curY][curX];
}

void a(int curY, int curX) {
    if (curY == N) { return; }
    vector<int> lvlPoss;
    for (int x = curX - 1; x >= 0; x--) {
        if (bl[curY][x]) { break; }
        if (poss[curY + 1][x]) {
            lvlPoss.push_back(x);
        }
    }
    if (lvlPoss.size() == 0 || !investigate(lvlPoss[0])) {
        ///Rabbit went right
        lvlPoss.clear();
        for (int x = curX + 1; x < M; x++) {
            if (bl[curY][x]) { break; }
            if (poss[curY + 1][x]) {
                lvlPoss.push_back(x);
            }
        }
    }

    int l = -1, r = lvlPoss.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (investigate(lvlPoss[m])) {
            l = m;
        } else {
            r = m;
        }
    }
    if (l == -1) {
        goDeeper(curX);
        a(curY + 1, curX);
    } else {
        goDeeper(lvlPoss[l]);
        a(curY + 1, lvlPoss[l]);
    }
}

void solve(int _N, int _M, int K, const vector<vector<bool>>& _BLOCKED) {
    poss.clear();
    poss.resize(N + 1);
    for (int i = 0; i < N + 1; i++) {
        poss[i].resize(M);
    }
    bl = _BLOCKED;
    N = _N; M = _M;

    setPoss(0, K, 0);
    a(0, K);
}

