#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "tunnels.h"
using namespace std;

vector<vector<bool>> poss, bl, vis;
int N, M;

void setPoss() {
//    cout  << "???";
    for (int j = 0; j < M; j++) {
        poss[N][j] = 1;
    }
    for (int i = N - 1; i >= 0; i--) {
//        cout << "a" << i << '\n';
        for (int j = 0; j < M; j++) {
            if (!bl[i][j] && poss[i + 1][j]) {
                poss[i][j] = 1;
            }
        }
//        cout << "s";
        for (int j = 1; j < M; j++) {
            if (!bl[i][j] && poss[i][j - 1]) {
                poss[i][j] = 1;
            }
        }
//        cout << "d";
        for (int j = M - 2; j >= 0; j--) {
            if (!bl[i][j] && poss[i][j + 1]) {
                poss[i][j] = 1;
            }
        }
//        cout << "f";
    }
}

void a(int curY, int curX) {
    if (curY == N) { return; }
    vector<int> lvlPoss, possL, possR;
    for (int x = curX - 1; x >= 0; x--) {
        if (bl[curY][x]) { break; }
        if (poss[curY + 1][x]) {
            possL.push_back(x);
        }
    }
    for (int x = curX + 1; x < M; x++) {
        if (bl[curY][x]) { break; }
        if (poss[curY + 1][x]) {
            possR.push_back(x);
        }
    }
    reverse(possL.begin(), possL.end());
    lvlPoss = possL;
    for (int i : possR) {
        if (i == curX) { continue; }
        lvlPoss.push_back(i);
    }

    int l = -1, r = lvlPoss.size();
    bool lj = 0, rj = 0;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (investigate(lvlPoss[mid])) {
            if (curX < lvlPoss[mid]) {
                l = mid;
                lj = 0;
            } else {
                rj = 0;
                r = mid;
            }
        } else {
            if (curX < lvlPoss[mid]) {
                rj = 0;
                if (lvlPoss[mid] < curX && curX < lvlPoss[r]) { rj = true; }
                r = mid - 1;
            } else {
                lj = 0;
                if (lvlPoss[l] < curX && curX < lvlPoss[mid]) { lj = true; }
                l = mid + 1;
            }
        }
    }
    if (lvlPoss[l] < curX && curX < lvlPoss[r]) {
        int spot = 0;
        if (investigate(lvlPoss[l])) {
            spot = l;
        } else {
            if (investigate(lvlPoss[r])) {
                spot = r;
            } else {
                spot = curX;
            }
        }
        goDeeper(spot);
        a(curY + 1, spot);
        return;
    }
    int spot = (lvlPoss[l] < curX ?  lvlPoss[l] : lvlPoss[r]);
    if (l == r) {
        if ((lvlPoss[l] == curX + 1 && curX == 0) || (lvlPoss[l] == curX - 1 && curX == M - 1) ||
            (lvlPoss[l] < curX && rj) || (lvlPoss[r] > curX && lj)) {
            if (investigate(lvlPoss[l])) {
                spot = lvlPoss[l];
            } else {
                spot = curX;
            }
        }
    }
    goDeeper(spot);
    a(curY + 1, spot);
}

void solve(int _N, int _M, int K, const vector<vector<bool>>& _BLOCKED) {
    N = _N; M = _M;
    poss.clear();
    vis.clear();
    poss.resize(N + 1);
    vis.resize(N + 1);
    for (int i = 0; i < N + 1; i++) {
        poss[i].resize(M);
        vis[i].resize(M);
    }
    bl.clear();
    bl = _BLOCKED;

    setPoss();
    a(0, K);
}
