#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int>>r;
    int bit=0,last=-1;
    while(bit<data.size()&&r.size()<n-1)
    {
        if(!data[bit])
        {
            if(last!=-1)
                r.push_back({last,bit});
            last=bit;
        }
        bit++;
    }

    if(r.size()==n-1)
        return r;

    for(int i=0;i<2*n;i++)
    {
        if(data[i])
            r.push_back({i,last});
        if(r.size()==n-1)
            return r;
    }
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    vector<bool>s(2*n,true);
    for(pair<int,int>i : tree)
    {
        s[i.first]=false;
        s[i.second]=false;
    }
    return s;
}
