#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;

int dp[5001][5001];
pair<int,int> idk[101][101][101];

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& haha) {
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(haha[i][j]) {
                dp[i][j] = -1;
            }
            else {
                dp[i][j] = 0;
            }
        }
    }
    for(int i = 0; i < m; i++) {
        if(dp[n-1][i] == 0) {
            dp[n-1][i] = 1;
        }
    }
    for(int i = n-2; i >= 0; i--) {
        for(int j = 0; j < m; j++) {
            if(dp[i][j] == 0 && dp[i+1][j] == 1) {
                dp[i][j] = 1;
            }
            if(j > 0 && dp[i][j-1] == 1 && dp[i][j] != -1) {
                dp[i][j] = 1;
            }
        }
        for(int j = m-2; j >= 0; j--) {
            if(dp[i][j+1] == 1 && dp[i][j] != -1) {
                dp[i][j] = 1;
            }
        }
    }
    for(int i = n-1; i >= 0; i--) {
        for(int j = 0; j < m; j++) {
            if(i == n-1) {
                if(dp[i][j] == -1) {
                    idk[i][j][j] = {-INT_MAX,-1};
                }
                else {
                    idk[i][j][j] = {0,j};
                }
            }
            else {
                if(dp[i+1][j] != 1 || dp[i][j] == -1) {
                    idk[i][j][j] = {-INT_MAX,-1};
                }
                else {
                    int l = j,r = j;
                    while(l > 0 && dp[i+1][l-1] != -1) {
                        l--;
                    }
                    while(r < m-1 && dp[i+1][r+1] != -1) {
                        r++;
                    }
                    idk[i][j][j] = idk[i+1][l][r];
                }
            }
        }
        for(int j = 1; j < m; j++) {
            for(int y = 0; y < m-j; y++) {
                int l = y,r = y+j;
                pair<int,int> ans = {INT_MAX,-1};
                int c = idk[i][l][r-1].second,d = idk[i][l+1][r].second;
                if(c == -1) {
                    c = l;
                }
                if(d == -1) {
                    d = r-1;
                }
                for(int z = c; z <= d; z++) {
                    int br = 0;
                    pair<int,int> a = idk[i][l][z];
                    pair<int,int> b = idk[i][z+1][r];
                    if(a.second == -1 && b.second == -1) {
                        continue;
                    }
                    if(a.second != -1) {
                        br = a.first;
                    }
                    if(b.second != -1) {
                        br = max(b.first,br);
                    }
                    br++;
                    if(a.second == -1 || b.second == -1) {
                        br--;
                    }
                    ans = min(ans,{br,z});
                }
                if(ans.first == INT_MAX) {
                    idk[i][l][r] = {-INT_MAX,-1};
                }
                else {
                    idk[i][l][r] = ans;
                }
            }
        }
    }
   /* for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    for(int i = 0; i < n; i++) {
        int y1 = k,y2 = k;
        while(y1 > 0 && dp[i][y1-1] == 1) {
            y1--;
        }
        while(y2 < m-1 && dp[i][y2+1] == 1) {
            y2++;
        }
        int l = y1,r = y2;
        while(l < r) {
            int p = idk[i][l][r].second;
            if(idk[i][l][p].second == -1) {
                l = p+1;
                continue;
            }
            if(idk[i][p+1][r].second == -1) {
                r = p;
                continue;
            }
            if(p >= k) {
                p++;
            }
            if(investigate(p)) {
                if(p < k) {
                    r = p;
                }
                else {
                    l = p;
                }
            }
            else {
                if(p < k) {
                    l = p+1;
                }
                else {
                    r = p-1;
                }
            }
        }
        goDeeper(l);
        k = l;
    }
}
