#include "bits_and_tree.h"
#include<bits/stdc++.h>
using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data) {
    int br = 199;
    vector<pair<int,int>> ans(0);
    for(int i = 0; i < 5; i++) {
        ans.push_back({0,br});
        br--;
    }
    const int z = 60;
    for(int i = 0; i < z; i++) {
        ans.push_back({i,i+1});
    }
    for(int i = 0; i < 7; i++) {
        ans.push_back({z,br});
        br--;
    }
    for(int i = 1; i < z; i++) {
        if(data[i-1]) {
            ans.push_back({i,br});
            br--;
            ans.push_back({i,br});
            br--;
        }
    }
    while(br > z) {
        ans.push_back({br,z});
        br--;
    }
    cout << ans.size() << endl;
    return ans;
}

vector<int> haha[1000];
vector<int> wut(0);

bool dfs(int a, int t, int x) {
    wut.push_back(a);
    if(a == x) {
        return true;
    }
    for(int v: haha[a]) {
        if(v != t) {
            if(dfs(v,a,x)) {
                return true;
            }
        }
    }
    wut.pop_back();
    return false;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree) {
    for(int i = 0; i <= n; i++) {
        haha[i].clear();
    }
    for(int i = 0; i < n; i++) {
        haha[tree[i].first].push_back(tree[i].second);
        haha[tree[i].second].push_back(tree[i].first);
    }
    int s,t;
    for(int i = 0; i <= n; i++) {
        int a = haha[i].size();
        if(a >= 8) {
            t = i;
        }
        else if(a >= 6) {
            s = i;
        }
    }
    wut.clear();
    dfs(s,-1,t);
    vector<bool> ans(0);
    for(int i = 1; i < wut.size()-1; i++) {
        int a = wut[i];
        if(haha[a].size() >= 4) {
            ans.push_back(1);
        }
        else {
            ans.push_back(0);
        }
    }
    return ans;
}
