#include "bits_and_tree.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 205;

vector<int> g[maxn];

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int, int>> edges;

    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }

    int cnt = 0;

    if (data[0] == 0)
    {
        g[0].push_back(1);
        g[0].push_back(2);
        g[0].push_back(3);
        g[0].push_back(4);
        g[0].push_back(5);
        cnt = 6;
    }
    else
    {
        g[0].push_back(1);
        cnt = 2;
    }

    while (cnt != 200)
    {
        g[cnt - 1].push_back(cnt);
        ++cnt;
    }

    for (int i = 0; i < 200; ++i)
    {
        for (auto to : g[i])
        {
            edges.push_back({i, to});
        }
    }

    return edges;
}

vector<int> newG[maxn];
int deg[maxn];
vector<bool> v;

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    v.clear();

    for (int i = 0; i <= n; ++i)
    {
        newG[i].clear();
        deg[i] = 0;
    }

    int root = -1;

    for (auto [x, y] : tree)
    {
        newG[x].push_back(y);
        newG[y].push_back(x);
        ++deg[x];
        ++deg[y];
    }

    int curr = *max_element(deg, deg + n + 1);
    if (curr >= 5) v.push_back(0);
    else v.push_back(1);

    while (v.size() < 2 * n) v.push_back(false);

    return v;
}
