#include "tunnels.h"

#include<iostream>
#include<vector>
int indOneR(int l, int n, int level, const std::vector<std::vector<bool>>& blocked){
    for(int i = l; i < n; i ++){
        if(blocked[level][i] == 1){
            return i;
        }
    }
    return -1;
}
int indOneL(int r, int n, int level, const std::vector<std::vector<bool>>& blocked){
    for(int i = r; i >= 0; i --){
        if(blocked[level][i] == 1){
            return i;
        }
    }
    return -1;
}
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    goDeeper(k);
    int ind = k;
    bool left = false, right = false, here = false;
    for(int i = 1; i < n; i ++){
        if(ind != 0 && blocked[i][ind-1] != 1){
            if(investigate(ind-1)){
                left = true;
                right = false;
                here = false;
            }else{
                if(ind != m - 1 && blocked[i][ind + 1] != 1){
                    if(investigate(ind + 1)){
                        right = true;
                        left = false;
                        here = false;
                    }else{
                        here = true;
                        right = false;
                        left = false;
                    }
                }else{
                    here = true;
                    right = false;
                    left = false;
                }
            }
        }else{
            left = false;
            if(ind != m - 1 && blocked[i][ind + 1] != 1){
                if(investigate(ind + 1)){
                    right = true;
                    here = false;
                }else{
                    here = true;
                    right = false;
                }
            }else{
                here = true;
                right = false;
            }
        }
        if(here){
            goDeeper(ind);
        }else{
            if(left){
                int l, r, mid;
                int YesNo = 0;
                r = ind - 1;
                if(indOneL(r, m, i, blocked) == -1){
                    l = 0;
                }else{
                    l = indOneL(r, m, i, blocked) + 1;
                }
                mid = (l + r) / 2;
                while(YesNo == 0){
                    if(l == r){
                        goDeeper(l);
                        ind = l;
                        YesNo = 1;
                    }else{
                        if(l + 1 == r){
                            if(investigate(l)){
                                goDeeper(l);
                                ind = l;
                                YesNo = 1;
                            }else{
                                goDeeper(r);
                                ind = r;
                                YesNo = 1;
                            }
                        }else{
                            if(investigate(mid)){
                                r = mid;
                                mid = (l + r) / 2;
                            }else{
                                if(mid + 1 == r){
                                    goDeeper(r);
                                    YesNo = 1;
                                }
                                l = mid;
                                mid = (l + r) / 2;
                            }
                        }
                    }
                }
            }else{
                int l, r, mid;
                int YesNo = 0;
                l = ind + 1;
                if(indOneR(l, m, i, blocked) == -1){
                    r = m - 1;
                }else{
                    r = indOneR(l, m, i, blocked) - 1;
                }
                mid = (l + r + 1) / 2;
                while(YesNo == 0){
                    if(l == r){
                        goDeeper(l);
                        ind = l;
                        YesNo = 1;
                    }else{
                        if(l + 1 == r){
                            if(investigate(r)){
                                goDeeper(r);
                                ind = r;
                                YesNo = 1;
                            }else{
                                goDeeper(l);
                                ind = l;
                                YesNo = 1;
                            }
                        }else{
                            if(investigate(mid)){
                                l = mid;
                                mid = (l + r + 1) / 2;
                            }else{
                                if(mid - 1 == l){
                                    goDeeper(l);
                                    YesNo = 1;
                                }
                                r = mid;
                                mid = (l + r + 1) / 2;
                            }
                        }
                    }
                }
            }
        }
    }
}
