#include <bits/stdc++.h>
using namespace std;

#ifdef GIGO_DEBUG
#include "Lgrader.cpp"
#else
#include "bits_and_tree.h"
#define cout if(false)cout
#endif // GIGO_DEBUG

const int MAXN = 207;

void appendEdge(vector<pair<int, int>>& ret, pair<int, int> edg){
    cout << "adding edge " << edg.first << "-" << edg.second << '\n';
    ret.push_back(edg);
}

vector<pair<int, int>> encode(int n, vector<bool> data){
    vector<pair<int, int>> ret;

    appendEdge(ret, {0, 1});
    appendEdge(ret, {0, 2});
    appendEdge(ret, {0, 3});
    int start = 0;

    appendEdge(ret, {4, 5});
    appendEdge(ret, {4, 6});
    appendEdge(ret, {4, 7});
    appendEdge(ret, {4, 8});
    appendEdge(ret, {4, 9});
    int fin = 4;

    int idx = 0;
    int linkTo = start, last = 9;
    int left = n-10;
    while(left > 0 && idx < data.size()){
        cout << "bit: " << data[idx] << '\n';
        if(data[idx] == 0){
            appendEdge(ret, {linkTo, ++last});
            linkTo = last;
            left--;
        }else{
            if(left >= 3){
                int tail = ++last;
                int mid = ++last;
                int bone = ++last;

                appendEdge(ret, {tail, mid});
                appendEdge(ret, {mid, bone});
                appendEdge(ret, {bone, linkTo});
                left -= 3;
                linkTo = bone;
            }else{
                cout << "quit\n";
                break;
            }
        }
        idx++;
    }
    appendEdge(ret, {linkTo, fin});

    cout << "all left...\n";
    linkTo = 9;
    while(left){ /// tova ne go pisheshe v uslovieto i trqbvashe da gledam gradera
        appendEdge(ret, {linkTo, ++last});
        linkTo = last;
        left--;
    }
    return ret;
}

void countChildren(const vector<vector<int>>& G, vector<int>& children, vector<int>& next, int curr, int prev=-1){
    int ch = 0;
    int mxC = 0, mxNxt = -1;
    for(int nxt : G[curr]){
        if(nxt == prev){ continue; }
        ch++;
        countChildren(G, children, next, nxt, curr);
        ch += children[nxt];
//        cout << curr << " -> nxt " << nxt << " has " << children[nxt] << '\n';
        if(children[nxt] > mxC){
            mxC = children[nxt];
            mxNxt = nxt;
        }
    }
    children[curr] = ch;
    next[curr] = mxNxt;
}

vector<bool> decode(int n, vector<pair<int, int>> tree){
    n++;
    vector<vector<int>> G(n);
    vector<int> deg(n);
    for(pair<int, int> p : tree){
        G[p.first].push_back(p.second);
        G[p.second].push_back(p.first);

        deg[p.first]++;
        deg[p.second]++;
    }

    int start = -1, fin = -1;
    for(int i = 0; i < n+1 && (start == -1 || fin == -1); i++){
        if(start == -1 && (deg[i] == 4 || deg[i] == 5)) {
            int leafCnt = 0;
            for(int neigh : G[i]){
                if(deg[neigh] == 1){
                    leafCnt++;
                    if(leafCnt >= 2){ break; }
                }
            }
            if(leafCnt >= 2){
                start = i;
            }
        }
        if(fin == -1 && (deg[i] == 6 || deg[i] == 7)){
            int leafCnt = 0;
            for(int neigh : G[i]){
                if(deg[neigh] == 1){
                    leafCnt++;
                    if(leafCnt >= 2){ break; }
                }
            }
            if(leafCnt >= 2){
                fin = i;
            }
        }
    }

    cout << "start: " << start << ", fin: " << fin << '\n';

    vector<int> children(n), next(n);
    countChildren(G, children, next, start);
    int curr = next[start];
    vector<bool> ret;
    while(curr != fin){
        int extra = children[curr] - children[next[curr]];
        cout << extra << '\n';
        ret.push_back(extra == 3 || extra == 4);
        curr = next[curr];
    }

    return ret;
//
//
//
//    /// smqtam deg i koj e leaf
//    nachalo e tozi s deg=4/5 i 2/3 lista
//    pochva v posoka na naj-dulgiq mu
//
//    kraj e tozi s deg=6/7 i
//
//    root v nach
//    count children, poddurjam v koj e kraq
//    chld =
}
