#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;

int pos;
void bs(int r, int l, bool dir) {
    //r, l are inclusive
    //dir 1 = right, 0 = left
    //std::cout << "searching " << l << ", " << r << ", " << (dir ? "right" : "left") << std::endl;
    if(r == l) {
        pos = r;
        goDeeper(r);
        return;
    }
    int m = (r + l)/2; // offset to the left

    if(investigate(m)) {
        if(dir) { //check right
            bs(r, m, dir);
        } else {
            bs(l, m, dir);
        }
    } else {
        if(dir) {
            bs(l, m-1, dir);
        } else {
            bs(r, m+1, dir);
        }
    }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    pos = k;
    for(int level = 0; level < n; level++) {
        //find left and right limits
        int r = pos;
        int l = pos;
        if(pos+1 < m && !blocked[level][pos+1]) {
                //not blocked to the right
            if(investigate(pos+1)) {
                //found trail to the right
                l = pos+1;
                while(r < m-1 && blocked[level][r] != 1) {
                    r++;
                }
                bs(r, l, 1);
            } else {
                //no trail to the right
                if(pos-1 >= 0 && !blocked[level][pos-1]) {
                    //not blocked to the left (continue left)
                    r = pos;
                    while(l > 0 && blocked[level][l] != 1) {
                        l--;
                    }
                    bs(r, l, 0);
                } else {
                    //blocked to the left, only way is down
                    goDeeper(pos);
                }
            }
        } else {
            //blocked to the right
            if(pos-1 >= 0 && !blocked[level][pos-1]) {
                //not blocked to the left
                    r = pos;
                    while(l > 0 && blocked[level][l] != 1) {
                        l--;
                    }
                    bs(r, l, 0);
            } else {
                //blocked to the left, only way is down
                goDeeper(pos);
            }
        }



    }
}
