#include <bits/stdc++.h>
#include "bits_and_tree.h"
using namespace std;
#include <vector>

vector<pair<int, int>> encode(int n, vector<bool> data)
{
    vector<pair<int, int>> ret;
    if ( data[0] == 0 )
    {
        for ( int i=1; i<=6; i++ )  ret.push_back({0, i});
        for (int i=7; i<n; i++)
            ret.push_back({i-1, i});
    }
    else
    {
        for ( int i=1; i<=4; i++ )  ret.push_back({0, i});
        for (int i=5; i<n; i++)
            ret.push_back({i-1, i});
    }
return ret;
}

vector<bool> decode(int n, vector<pair<int, int>> tree)
{
    vector<int> edges[209];

    for (auto [v, u] : tree)
    {
        edges[v].push_back(u);
        edges[u].push_back(v);
    }

    int first = -1;
    for (int i=0; i<=n; i++)
    {
        //cerr << i << ":" << edges[i].size() << endl;
        if ( edges[i].size() == 7 || edges[i].size()==6 )  first = 0;
        if ( edges[i].size() == 5 || edges[i].size()==4 )  first = 1;
    }


vector<bool>  ret(2*n, 1);
ret[0] = first;

return ret;


}
