#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5005;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int pos = k;

    for(int i = 0; i <= n-1; i++)
    {
        int l = pos, r = pos;
        while(l > 0 && !blocked[i][l-1]) l--;
        while(r < m-1 && !blocked[i][r+1]) r++;

        if(i != n-1)
        {
            while(l < pos && blocked[i+1][l]) l++;
            while(r > pos && blocked[i+1][r]) r--;
        }


        int kude = 0;
        if(l == pos && r == pos)
        {
            goDeeper(pos);
            pos = pos;
            continue;
        }
        if(l == pos) kude = 1;
        else if(r == pos) kude = -1;
        else
        {
            if(pos-l > r-pos)
            {
                if(investigate(pos+1)) kude = 1;
                else kude = -1;
            }
            else if(investigate(pos-1)) kude = -1;
            else kude = 1;
        }

        int L = l;
        int R = r;
        if(kude == 1)
        {
            l = pos+1;
            r = R;

            if(pos-L > R-pos) l = pos+2;

            int mid;
            while(l <= r)
            {
                mid = (l+r)/2;
                if(investigate(mid)) l = mid+1;
                else r = mid-1;
            }
            pos = r;
            goDeeper(pos);
        }
        else
        {
            l = L;
            r = pos-1;

            if(pos-L <= R-pos) r = pos-2;

            int mid;
            while(l <= r)
            {
                mid = (l+r)/2;
                if(investigate(mid)) r = mid-1;
                else l = mid+1;
            }
            pos = l;
            goDeeper(pos);
        }
    }
    return;
}
