#include <iostream>
#include <vector>
#include "tunnels.h"

#define PB push_back
#define X first
#define Y second
#define maxn 5005
#define maxlog 20
#define control std::cout << "passed" << "\n";

typedef std::pair <int, int> pii;


bool ans[maxn][maxn];

bool did[maxn][maxn];
std::vector<std::vector<bool>> a;

bool my_inv(int x, int y)
{
    if(did[x][y] == true)
        return ans[x][y];

    if(a[x][y] == true)
        return false;

    did[x][y] = true;

    return ans[x][y] = investigate(y);
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    pii pos = {0, k};

    a = blocked;

    while(pos.X < n)
    {
        if(m == 1)
        {
            goDeeper(0);
            pos.X++;

            continue;
        }

        int pp; /// 0 - left , 1 - right , 2 - down

        if(pos.Y == 0)
        {
            if(my_inv(pos.X , 1) == true)
                pp = 1;
            else
                pp = 2;
        }
        else if(pos.Y == m - 1)
        {
            if(my_inv(pos.X , m - 2) == true)
                pp = 0;
            else
                pp = 2;
        }
        else
        {
            bool l = my_inv(pos.X , pos.Y - 1);
            if(l == true)
            {
                pp = 0;
            }
            else
            {
                bool r = my_inv(pos.X , pos.Y + 1);
                if(r == true)
                    pp = 1;
                else
                    pp = 2;
            }
        }

        if(pp == 2)
        {
            goDeeper(pos.Y);
            pos.X++;
            continue;
        }

        if(pp == 0)
        {
            int j = pos.Y - 2;
            bool lamp = false;

            while(j >= 0)
            {
                if(my_inv(pos.X , j) == false)
                {
                    lamp = true;
                    goDeeper(j + 1);
                    pos.Y = j + 1;
                    pos.X++;

                    break;
                }
            }

            if(lamp == false)
            {
                goDeeper(0);
                pos.Y = 0;
                pos.X++;
            }

            continue;
        }

        if(pp == 1)
        {
            int j = pos.Y + 2;
            bool lamp = false;

            while(j <= m - 1)
            {
                if(my_inv(pos.X , j) == false)
                {
                    lamp = true;
                    goDeeper(j - 1);
                    pos.Y = j - 1;
                    pos.X++;

                    break;
                }
            }

            if(lamp == false)
            {
                goDeeper(m - 1);
                pos.Y = m - 1;
                pos.X++;
            }

            continue;
        }
    }
}
