void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    //vector<vector<bool>>b=blocked;
    int i=0;
    while(i<n)
    {
        bool on=0,l=0,r=0;
        vector<int>lt,rt;
        if(i==n-1)on=1;
        else if(blocked[i+1][k]==0)on=1;
        for(int j=k-1;j>=0;j--)
        {
            if(blocked[i][j])j=-1;
            else
            {
                if(i==n-1)
                {
                    l=1;
                    lt.push_back(j);
                }
                else if(blocked[i+1][j]==0)
                {
                    l=1;
                    lt.push_back(j);
                }
            }
        }
        for(int j=k+1;j<m;j++)
        {
            if(blocked[i][j])j=m;
            else
            {
                if(i==n-1)
                {
                    r=1;
                    rt.push_back(j);
                }
                else if(blocked[i+1][j]==0)
                {
                    r=1;
                    rt.push_back(j);
                }
            }
        }
        if(on)
        {
            //if neither
            if(!l&&!r)
            {
                goDeeper(k);
                i++;
            }
            //if on left
            else if(!r)
            {
                if(!investigate(lt[0]))
                {
                    goDeeper(k);
                    i++;
                }
                else
                {
                    int sz=lt.size(),j;
                    bool ch=0;
                    for(j=1;j<sz;j++)
                    {
                        if(!investigate(lt[j]))
                        {
                            k=lt[j-1];
                            goDeeper(k);
                            j=sz;
                            i++;
                            ch=1;
                        }
                    }
                    if(!ch)
                    {
                        k=lt[j];
                        goDeeper(k);
                        i++;
                    }
                }
            }
            //if on right
            else if(!l)
            {
                if(!investigate(rt[0]))
                {
                    goDeeper(k);
                    i++;
                }
                else
                {
                    int sz=rt.size(),j;
                    bool ch=0;
                    for(j=1;j<sz;j++)
                    {
                        if(!investigate(rt[j]))
                        {
                            k=rt[j-1];
                            goDeeper(k);
                            j=sz;
                            i++;
                            ch=1;
                        }
                    }
                    if(!ch)
                    {
                        k=rt[j];
                        goDeeper(k);
                        i++;
                    }
                }
            }
            //if both
            else
            {
                if(!investigate(rt[0]))
                {
                    //neither
                    if(!investigate(lt[0]))
                    {
                        goDeeper(k);
                        i++;
                    }
                    //left
                    else
                    {
                        int sz=lt.size(),j;
                        bool ch=0;
                        for(j=1;j<sz;j++)
                        {
                            if(!investigate(lt[j]))
                            {
                                k=lt[j-1];
                                goDeeper(k);
                                j=sz;
                                i++;
                                ch=1;
                            }
                        }
                        if(!ch)
                        {
                            k=lt[j];
                            goDeeper(k);
                            i++;
                        }
                    }
                }
                //right
                else
                {
                    int sz=rt.size(),j;
                    bool ch=0;
                    for(j=1;j<sz;j++)
                    {
                        if(!investigate(rt[j]))
                        {
                            k=rt[j-1];
                            goDeeper(k);
                            j=sz;
                            i++;
                            ch=1;
                        }
                    }
                    if(!ch)
                    {
                        k=rt[j];
                        goDeeper(k);
                        i++;
                    }
                }
            }
        }
        else //if no path straight down
        {
            if(!r)
            {
                int sz=lt.size(),j;
                bool ch=0;
                for(j=1;j<sz;j++)
                {
                    if(!investigate(lt[j]))
                    {
                        k=lt[j-1];
                        goDeeper(k);
                        j=sz;
                        i++;
                        ch=1;
                    }
                }
                if(!ch)
                {
                    k=lt[j];
                    goDeeper(k);
                    i++;
                }
            }
            else if(!l)
            {

                int sz=rt.size(),j;
                bool ch=0;
                for(j=1;j<sz;j++)
                {
                    if(!investigate(rt[j]))
                    {
                        k=rt[j-1];
                        goDeeper(k);
                        j=sz;
                        i++;
                        ch=1;
                    }
                }
                if(!ch)
                {
                    k=rt[j];
                    goDeeper(k);
                    i++;
                }
            }
            //if both
            else
            {
                if(!investigate(rt[0]))
                {
                    //left
                    int sz=lt.size(),j;
                    bool ch=0;
                    for(j=1;j<sz;j++)
                    {
                        if(!investigate(lt[j]))
                        {
                            k=lt[j-1];
                            goDeeper(k);
                            j=sz;
                            i++;
                            ch=1;
                        }
                    }
                    if(!ch)
                    {
                        k=lt[j];
                        goDeeper(k);
                        i++;
                    }
                }
                //right
                else
                {
                    int sz=rt.size(),j;
                    bool ch=0;
                    for(j=1;j<sz;j++)
                    {
                        if(!investigate(rt[j]))
                        {
                            k=rt[j-1];
                            j=sz;
                            goDeeper(k);
                            i++;
                            ch=1;
                        }
                    }
                    if(!ch)
                    {
                        k=rt[j];
                        goDeeper(k);
                        i++;
                    }
                }
            }
        }
    }
}