#define ll int

#include<bits/stdc++.h>
#include "bits_and_tree.h"
using namespace std;

const ll gr=48;

vector<pair<int, int> > encode(int n, vector<bool> data){
    vector<pair<ll,ll> > tree;

    for(ll i=0;i<gr-1;i++) tree.push_back({i,i+1});

    ll p=gr;
    for(ll i=1;i<gr;i++){
        if(data[i]==0){
            tree.push_back({i,p});
            p++;
            if(i==gr-1){
                tree.push_back({i,p});
                p++;
            }
        }
        else{
            for(ll j=0;j<3;j++){
                tree.push_back({i,p});
                p++;
            }
            if(i==gr-1){
                tree.push_back({i,p});
                p++;
            }
        }
    }

    if(data[0]==0){
        for(ll i=p;i<n;i++) tree.push_back({0,i});
    }
    else{
        for(ll i=p;i<n-2;i++) tree.push_back({0,i});
        tree.push_back({p,n-2});
        tree.push_back({p+1,n-1});
    }

    return tree;
}

vector<bool> decode(int n, vector<pair<int, int>> tree){
    vector<ll> br(n+1,0);
    vector<ll> v[n+1];
    for(auto edge : tree){
        v[edge.first].push_back(edge.second);
        v[edge.second].push_back(edge.first);
        br[edge.first]++;
        br[edge.second]++;
    }
    ll ma=0,indx;
    for(ll i=0;i<=n;i++){
        if(br[i]>ma){
            ma=br[i];
            indx=i;
        }
    }

    vector<bool> data(2*n);

    ll br2;
    for(auto j : v[indx]){
        if(br[j]==2) br2++;
    }
    if(br2>=2) data[0]=1;

    ll pr=-1;
    for(ll i=1;i<gr;i++){
        for(auto j : v[indx]){
            if(br[j]>2 && j!=pr){
                pr=indx;
                indx=j;
                break;
            }
        }
        if(br[indx]>=5) data[i]=1;
    }

    return data;
}
