//#pragma once
//#include "Lgrader.cpp"
#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;
int level=0,N,M;
vector<int>lef,rig;
vector<vector<bool>> mat;
void go_left(int pos)
{
    for(int i=pos-1; i>=0; i--)
    {
        if(mat[level][i]==1)break;
        if(level==N-1||mat[level+1][i]==0)lef.push_back(i);
    }
}
void go_right(int pos)
{
    for(int i=pos; i<M; i++)
    {
        if(mat[level][i]==1)break;
        if(level==N-1||mat[level+1][i]==0)rig.push_back(i);
    }
}
void find_l()
{
    int l=0,r=lef.size()-1,mid;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(investigate(lef[mid]))l=mid+1;
        else r=mid-1;
    }
    goDeeper(lef[l-1]);
    level++;
}
void find_r()
{
    int l=0,r=rig.size()-1,mid;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(investigate(rig[mid]))l=mid+1;
        else r=mid-1;
    }
    goDeeper(rig[l-1]);
    level++;
}
void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    goDeeper(k);
    mat=blocked;
    N=n;
    M=m;
    int pos=k;
    for(int i=0; i<n; i++)
    {
        go_left(pos);
        go_right(pos);
        if(lef.size()+rig.size()==1)
        {
            if(lef.size())
            {
                pos=lef[0];
                goDeeper(pos);
                lef.clear();
            }
            else
            {
                pos=rig[0];
                goDeeper(pos);
                rig.clear();
            }
            level++;
            continue;
        }

        if(!lef.size())
        {
            find_r();
            continue;
        }

        if(!rig.size())
        {
            find_l();
            continue;
        }

        if(investigate(lef[0]))
        {
            find_l();
            continue;
        }
        else
        {
            find_r();
            continue;
        }
    }
    return;
}
