#include<iostream>
#include<set>
#include<vector>
#include "bits_and_tree.h"
using namespace std;
set<int>g[10000];
vector<bool>ans,testans;
int allmxchain;
std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int>>tree;

    vector<pair<bool,int>>comp;

    comp.push_back({data[0],1});

    int chain=5+(data[0]==1 ? 1 : 0)*2;

    int len=(n-chain-1)/2;

    for(int i=1;i<len;i++)
    {
        if(data[i]==data[i-1])comp.back().second++;
        else comp.push_back({data[i],1});
    }

    int vert=0;

    for(int i=1;i<=chain;i++)
    {
        tree.push_back({vert,vert+1});
        vert++;
    }

    int nowvert;

    for(int idx=0;idx<comp.size();idx++)
    {
        nowvert=vert;
        for(int x=1;x<=2*comp[idx].second;x++)
        {
            tree.push_back({nowvert,++vert});
        }
    }

    return tree;
}
bool dfs(int u,int par,bool f)
{
    int degs=g[u].size()-1;

    if(degs%2==1)return 0;

    for(int i=1;i<=degs/2;i++)testans.push_back(f);

    for(int v:g[u])
    {
        if(v==par)continue;
        if((g[v].size()-1)%2==1) return 0;
        if(g[v].size()>1)return dfs(v,u,1-f);
    }

    return 1;
}
int no;
void checkbad(int x)
{
    testans.clear();

    vector<int>rem;
    for(int u:g[x])
    {
        rem.push_back(u);
        g[u].erase(x);
    }
    g[x].clear();


    int mxchain=0;
    int pa,root;

    for(int i=0;i<=no;i++)
    {
        if(g[i].size()==1)
        {
            int cnt=0;
            int pre=-1,cur=i;
            while(g[cur].size()<=2)
            {
                cnt++;
                for(int u:g[cur])
                {
                    if(u!=pre)
                    {
                        pre=cur;
                        cur=u;
                        break;
                    }
                }

            }
            if(cnt>mxchain)
            {
                mxchain=cnt;
                root=cur;
                pa=pre;
            }
        }
    }

    if(!(mxchain==3 or mxchain==5))
    {
        for(int u:rem){g[u].insert(x);g[x].insert(u);}
        return;
    }

    bool f=(mxchain==5 ? 0 : 1);

    if(dfs(root,pa,f)==0)
    {
        for(int u:rem){g[u].insert(x);g[x].insert(u);}
        return;
    }

    if(mxchain>allmxchain)
    {
        allmxchain=mxchain;
        ans=testans;
    }

    for(int u:rem){g[u].insert(x);g[x].insert(u);}

    return;
}
std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    ans.clear();

    allmxchain=0;

    no=n;

    for(int i=0;i<=n;i++)g[i].clear();

    for(auto [u,v]:tree)
    {
        g[u].insert(v);
        g[v].insert(u);
    }

    for(int i=0;i<=n;i++)
    {
        if(g[i].size()==1)
        {
            checkbad(i);
        }
    }

    return ans;
}

