#include <bits/stdc++.h>
#include "tunnels.h"

#define pb push_back
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int curr = k;
    for (int i = 0; i < n; ++ i)
    {
       // cout << i << " !!! " << curr << endl;
        int l = -1, r = m;
        for (int j = curr-1; j >= 0; -- j)
        {
            if(blocked[i][j])
            {
                l = j;
                break;
            }
        }
        for (int j = curr+1; j <= m - 1; ++ j)
        {
            if(blocked[i][j])
            {
                r = j;
                break;
            }
        }
        int toleft = 0, toright = 0;
        if(curr - 1 > l)
        {
            toleft = investigate(curr-1);
        }
        else toleft = 0;
        if(curr + 1 < r)
        {
            toright = investigate(curr + 1);
        }
        else toright = 0;
        if(!toleft && !toright)
        {
            goDeeper(curr);
            continue;
        }
        if(toleft)
        {
            int last = curr - 1;
            int bl = l + 1, br = curr - 2, mid, ans = curr - 1;
            while(bl <= br)
            {
                mid = (bl + br)/2;
                if(investigate(mid))
                {
                    ans = mid;
                    br = mid - 1;

                }
                else bl = mid + 1;
            }

            curr = ans;
            goDeeper(ans);
        }
        else
        {
            int last = curr + 1;
            int bl = curr + 2, br = r-1, mid, ans = curr + 1;
            while(bl <= br)
            {
                mid = (bl + br)/2;
                if(investigate(mid))
                {
                    ans = mid;
                    bl = mid + 1;
                }
                else br = mid - 1;
            }
            curr = ans;
            goDeeper(ans);
        }
    }
}
