#include<iostream>
#include<vector>
#include "tunnels.h"
#define MAXN 5010
using namespace std;
bool tab[MAXN][MAXN];
bool check(int x, int y, int n, int m)
{
    if(x>n || y<0 || y>=m)return 0;
    if(x==n)return 1;
    if(tab[x][y])return 0;
    if(check(x+1,y,n,m))return 1;
    if(check(x,y-1,n,m))return 1;
    if(check(x,y+1,n,m))return 1;
    return 0;
}
void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    int curr=k;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)tab[i][j]=blocked[i][j];
    }
    for(int i=0;i<n;i++)
    {
        int l=0,r=m-1;
        vector<int> poss;
        vector<int> poss2;
        for(int j=curr;j>=0;j--)if(blocked[i][j]){l=j+1;break;}
        for(int j=curr;j<m;j++)if(blocked[i][j]){r=j-1;break;}
        for(int j=curr;j<=r;j++)if(check(i+1,j,n,m))poss2.push_back(j);
        bool fl=0;
        if(l<curr)
        {
            for(int j=curr-1;j>=l;j--)if(check(i+1,j,n,m))poss.push_back(j);
            if(poss.size()==1 && poss2.size()==0){curr=poss[0];fl=1;}
            else if(poss.size()==2 && poss2.size()==0)
            {
                l=0;r=1;
                if(investigate(poss[r]))l=r;
                curr=poss[l];
                fl=1;
            }
            if(fl==0 && poss.size()>0 && investigate(poss[0]))
            {
                l=0;r=poss.size()-1;
                while(r-l>1)
                {
                    int mid=(l+r)>>1;
                    if(investigate(poss[mid]))l=mid;
                    else r=mid-1;
                }
                if(r-l==1)
                {
                    if(investigate(poss[r]))l=r;
                }
                curr=poss[l];
                fl=1;
            }
            poss.clear();
        }
        if(r>curr && fl==0)
        {
            fl=0;
            for(int j=curr+1;j<=r;j++)if(check(i+1,j,n,m))poss.push_back(j);
            if(poss.size()==1 && check(i+1,curr,n,m)==0){curr=poss[0];fl=1;}
            else if(poss.size()==2 && check(i+1,curr,n,m)==0)
            {
                l=0;r=1;
                if(investigate(poss[r]))l=r;
                curr=poss[l];
                fl=1;
            }
            if(fl==0 && poss.size()>0 && investigate(poss[0]))
            {
                l=0;r=poss.size()-1;
                while(r-l>1)
                {
                    int mid=(l+r)>>1;
                    if(investigate(poss[mid]))l=mid;
                    else r=mid-1;
                }
                if(r-l==1)
                {
                    if(investigate(poss[r]))l=r;
                }
                curr=poss[l];
            }
        }

        goDeeper(curr);
    }
}