#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);


void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper( k ) ;
    int j1 , j2 , j ;

    for ( int i = 1 ; i < n ; i++ )
    {
        j1 = k + 1 ;
        for ( j = k+1 ; j < m ; j++ )
        {
            if ( blocked[i][j] == 1 ) break ;
            if ( blocked[i+1][j] == 0 && investigate(j) ) j1 = j ;
        }

        if ( j1 > k )
        {
            k = j1 ;
            goDeeper( k ) ;
            continue ;
        }

        j2 = k - 1 ;
        for ( j = k-1 ; j >= 0 ; j-- )
        {
            if ( blocked[i][j] == 1 ) break ;
            if ( blocked[i+1][j] == 0 && investigate(j) ) j2 = j ;
        }

        if ( j2 < k )
        {
            k = j2 ;
            goDeeper( k ) ;
            continue ;
        }

        goDeeper( k ) ;
    }

}
