#include <bits/stdc++.h>
#include "bits_and_tree.h"
#define pb push_back
using namespace std;
int maxn=48;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    vector<pair<int,int> > t;

    for(int i=1;i<maxn;i++)
    {
        t.pb({i-1,i});
    }

    int id=maxn;
    for(int i=0;i<maxn;i++)
    {
        if(data[i])
        {
            t.pb({i,id++});
            t.pb({id,id++});
        }
    }
    int h=id++;
    t.pb({h,0});
    for(int i=1;i<=4;i++)
        t.pb({h,id++});

    h=id++;
    t.pb({maxn-1,h});
    while(id<n)
        t.pb({h,id++});
}

vector<int> v[256];
int sz[256];

void prec(int i,int p)
{
    sz[i]=1;
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(nb==p)continue;
        prec(nb,i);
        sz[i]+=sz[nb];
    }
    //cout<<i<<" + "<<sz[i]<<endl;
}

int used[256];
int c[256];
void dfs(int i,int id,int tp)
{
    //cout<<"- "<<i<<" "<<id<<" "<<v[i].size()<<endl;
    used[i]=1;
    if(v[i].size()==1)return;
    int maxx=v[i][0];
    if(used[maxx])maxx=v[i][1];
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(used[nb])continue;
        if(sz[nb]>sz[maxx])maxx=nb;
    }

    dfs(maxx,id+1,tp);
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(!used[nb]&&v[nb].size()==2)c[id]=1;
        else c[id]=0;
    }
}
std::vector<bool> decode(int n, std::vector<std::pair<int, int>> t)
{
    int maxx=0;
    for(int i=0;i<t.size();i++)
    {
        v[t[i].first].pb(t[i].second);
        v[t[i].second].pb(t[i].first);
    }

    for(int i=0;i<n;i++)
        if(v[i].size()==5)maxx=i;

    prec(maxx,-1);

    used[maxx]=1;
    int nb1=0,nb2=0;
    for(int i=0;i<v[maxx].size();i++)
    {
        //cout<<v[maxx][i]<<" - "<<sz[v[maxx][i]]<<endl;
        if(sz[v[maxx][i]]>2)
        {
            if(nb1)nb2=v[maxx][i];
            else nb1=v[maxx][i];
        }
    }
    //cout<<"here"<<endl;

    dfs(nb1,1,0);
    dfs(nb2,1,1);
    vector<bool> ans;

    for(int i=1;i<=maxn;i++)
        ans.pb(c[i]);

    //cout<<"done"<<endl;

    for(int i=0;i<t.size();i++)
    {
        v[t[i].first].clear();
        v[t[i].second].clear();
    }
    memset(used,0,sizeof(used));
    return ans;
}
