#include <iostream>
#include <queue>
#include <vector>
#include "tunnels.h"
using namespace std;

vector<int> x_arr = {-1, 0, 1};

int check(int startx, int starty, int &m,  const std::vector<std::vector<bool>>& blocked){
        for(int i = 0; i < 3; i++){
            if(startx + x_arr[i] >= 0 && startx + x_arr[i] < m && blocked[starty][startx + x_arr[i]] == 0){
                if(investigate(startx + x_arr[i])){
                    goDeeper(startx + x_arr[i]);
                    break;
                }
            }
    }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    goDeeper(k);
    for(int i = 1; i < n; i++){
        check(i, k, m, blocked);
    }
}