#include<bits/stdc++.h>
#include "tunnels.h"

#define MAXN 5007
using namespace std;

int n,m,pos;
int t[MAXN][MAXN];
int ans[MAXN],li[MAXN],tim;

bool query(int x){
    if(li[x]==tim)return ans[x];
    li[x]=tim;
    ans[x]=investigate(x-1);

    return ans[x];
}

void solve(int N, int M, int K, const vector< vector<bool> >& blocked){
    n=N; m=M;
    
    for(int i=0;i<=n+1;i++){
        for(int f=0;f<=m+1;f++)t[i][f]=1;
    }

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            t[i][f]=blocked[i-1][f-1];
        }
    }

    pos=K+1;

    for(int i=1;i<=n;i++){
        tim++;
        int where=0;

        if(t[i][pos-1]==1)where=1;
        else if(t[i][pos+1]==1)where=0;
        else{
            if(query(pos-1)){
                where=0;
            }else{
                where=1;
            }
        }

        if(where==0){
            int l=0,r=pos,tt;

            while(l+1<r){
                tt=(l+r)/2;

                if(query(tt)){
                    r=tt;
                }else{
                    l=tt;
                }
            }

            goDeeper(r-1);
            pos=r;
        }else{
            int l=pos,r=m+1,tt;

            while(l+1<r){
                tt=(l+r)/2;

                if(query(tt)){
                    l=tt;
                }else{
                    r=tt;
                }
            }

            goDeeper(l-1);
            pos=l;
        }
    }
}