#include<bits/stdc++.h>
#include "bits_and_tree.h"

#define MAXN 1000

using namespace std;

int n;
const int len=50;

vector< pair<int,int> > pairs;
vector<int> v[MAXN],path;
bool ban[MAXN];

void reset(){
    pairs.clear();
    path.clear();

    for(int i=1;i<=n+1;i++){
        v[i].clear();
        ban[i]=false;
    }
}

void add_edge(int x,int y){
    pairs.push_back({x-1,y-1});
}

vector<pair<int, int>> encode(int N, vector<bool> data){
    n=N;
    reset();

    for(int i=1;i<=6;i++)add_edge(7,i);
    for(int i=8;i<=8+len;i++)add_edge(i,i-1);
    for(int i=8+len+1;i<=8+len+4;i++)add_edge(8+len,i);

    int num=8+len+4;
    for(int i=0;i<len;i++){
        if(data[i]){
            add_edge(8+i,num+1);
            add_edge(num+1,num+2);
            num+=2;
        }
    }

    num++;
    while(num<=n){
        add_edge(7,num);
        num++;
    }

    return pairs;
}

bool dfs(int x,int p,int y){
    if(x==y){
        path.push_back(y);
        return true;
    }

    for(int i:v[x]){
        if(i==p)continue;

        if(dfs(i,x,y)){
            path.push_back(x);
            return true;
        }
    }

    return false;
}

int dfs2(int x,int p){
    int d=0;

    for(int i:v[x]){
        if(ban[i] or i==p)continue;
        d=max(d,dfs2(i,x)+1);
    }

    return d;
}

vector<bool> decode(int N, vector<pair<int, int>> tree){
    n=N;
    reset();

    for(int i=0;i<tree.size();i++){
        v[tree[i].first+1].push_back(tree[i].second+1);
        v[tree[i].second+1].push_back(tree[i].first+1);
    }

    int st,et;
    for(int i=1;i<=n+1;i++){
        if(v[i].size()>=7)st=i;
        if(int(v[i].size())>=5 and int(v[i].size())<=6)et=i;
    }

    dfs(et,0,st);
    for(int i:path)ban[i]=true;

    vector<bool> res(n,0);
    for(int i=1;i<path.size()-1;i++){

        if(dfs2(path[i],0)>=2)res[i-1]=true;
    }

    return res;
}
