#include<bits/stdc++.h>
#include "bits_and_tree.h"

#define MAXN 1000

using namespace std;

mt19937 rng(42069);

int n;
const int len=174;

int xorr[30],cc[30],cnt[MAXN],sz;
vector< pair<int,int> > pairs;
vector<int> v[MAXN],path;
bool ban[MAXN];

vector<int> bits;

void reset(){
    if(bits.empty()){
        for(int i=0;i<400;i++)bits.push_back(rng()%2);
    }

    pairs.clear();
    path.clear();

    for(int i=0;i<=n+1;i++)cnt[i]=0;
    for(int i=0;i<30;i++)xorr[i]=cc[i]=0;

    for(int i=1;i<=n+1;i++){
        v[i].clear();
        ban[i]=false;
    }
}

void add_edge(int x,int y){
    pairs.push_back({x-1,y-1});
}

vector<pair<int, int>> encode(int N, vector<bool> data){
    n=N;
    reset();

    int pt=0;
    for(int i=0;i<len;i++){
        if(!data[i])pt++;
        else cnt[pt]++;
    }

    for(int i=0;i<=pt;i++){
        for(int f=0;f<8;f++){
            if((1<<f)&i)xorr[f]^=(cnt[i]%2);
        }
    }

    for(int i=1;i<=6;i++)add_edge(7,i);
    
    for(int i=8;i<=15;i++)add_edge(i,i-1);
    int num=15;

    for(int i=0;i<8;i++){
        if(xorr[i]){
            add_edge(8+i,num+1); num++;
        }
    }

    add_edge(15,num+1); num++;
    int curr=num;
    for(int i=0;i<len;i++){
        if(data[i]){
            add_edge(num,num+1);
            num++;
        }else{
            add_edge(curr,num+1);
            num++; curr=num;
        }
    }

    add_edge(curr,num+1);
    num++;

    for(int i=num+1;i<=num+4;i++)add_edge(num,i);
    num+=4;

    num++;
    while(num<=n){
        add_edge(7,num);
        num++;
    }

    return pairs;
}

bool dfs(int x,int p,int y){
    if(x==y){
        path.push_back(y);
        return true;
    }

    for(int i:v[x]){
        if(i==p)continue;

        if(dfs(i,x,y)){
            path.push_back(x);
            return true;
        }
    }

    return false;
}

int dfs2(int x,int p){
    int d=0;

    for(int i:v[x]){
        if(ban[i] or i==p)continue;
        d=max(d,dfs2(i,x)+1);
    }

    return d;
}

vector<bool> decode(int N, vector<pair<int, int>> tree){
    n=N;
    reset();

    for(int i=0;i<tree.size();i++){
        v[tree[i].first+1].push_back(tree[i].second+1);
        v[tree[i].second+1].push_back(tree[i].first+1);
    }

    int st,et;
    for(int i=1;i<=n+1;i++){
        if(v[i].size()>=7)st=i;
        if(int(v[i].size())>=5 and int(v[i].size())<=6)et=i;
    }

    dfs(et,0,st);
    for(int i:path)ban[i]=true;

    vector<bool> res;
    for(int i=1;i<=8;i++){
        if(dfs2(path[i],0)>=1)xorr[i-1]=1;
        else xorr[i-1]=0;
    }

    sz=int(path.size())-10;
    for(int i=9;i<path.size()-1;i++){
        cnt[i-9]=dfs2(path[i],0);
    }

    int sum=0;
    for(int i=0;i<=sz;i++){
        sum+=cnt[i];
    }

    if(sum + sz-1 > len){

        for(int i=0;i<=sz;i++){
            for(int f=0;f<8;f++){
                if((1<<f)&i)cc[f]^=(cnt[i]%2);
            }
        }

        int bad=0;
        for(int i=0;i<8;i++){
            if(cc[i]!=xorr[i])bad|=(1<<i);
        }

        cnt[bad]--;
    }

    for(int i=0;i<cnt[0];i++)res.push_back(1);

    for(int i=1;i<=sz;i++){
        res.push_back(0);

        for(int f=0;f<cnt[i];f++)res.push_back(1);
    }

    return res;
}
