#include "tunnels.h"

#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "


typedef long long ll;
typedef long double ld;

void solve(int N, int M, int K, const std::vector<std::vector<bool>>& blocked){

	int currPos = K;
	for( int i=0 ; i < N ; i++ ){
		cerr << out( i ) << out( currPos ) << endl;
		/*
		if( !i ){
			goDeeper( K );
			continue;
		}
		*/
		std::vector< int > ind;
		int left, right;
		left = right = -1;
		for( int j=0 ; j < N ; j++ ){
			if( blocked[i][j] ){
				if( j < currPos ) left = j;
				else if( right == -1 ){
					right = j;
					break;
				}
			}
		}
		if( right == -1 ) right = M;
		cerr << out( left ) << out( right ) << out( currPos ) << endl;
		bool dir = 0;
		if( left != currPos -1 ){
			if( !investigate( currPos-1 ) ) dir = 1;
		}else dir = 1;

		cerr << out( dir ) << endl;

		if( dir ){
		// right
			int l = currPos;
			int r = right;
			while( l < r-1 ){
				int m = ( l + r ) >> 1;
				if( investigate( m ) ) l = m;
				else r = m;
			}

			cerr << out( l ) << endl;
			goDeeper( l );
			currPos = l;
		}else{
			int l = left;
			int r = currPos -1;
			while( l < r-1 ){
				int m = ( l + r ) >> 1;
				if( investigate( m ) ) r = m;
				else l = m;
			}

			cerr << out( r ) << endl;
			goDeeper( r );
			currPos = r;
		}
	}
}
