#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;
const ll mod = 1e9 + 7;
std::vector< int > a;

ll pw[MAX_N];
ll query(int l, int r){
	
	ll nas = 0;
	for( int i=l ; i <= r ; i++ ){
		for( int j=i ; j <= r ; j++ ){
			std::vector< int > cnt( MAX_N );
			int inv = 0;
			for( int k=i ; k <= j ; k++ ){
				cnt[ a[k] ] ++;
				if( cnt[ a[k] ] > a[k] ) break;
				if( cnt[ a[k] ] == 1 ) inv ++;
				if( cnt[ a[k] ] == a[k] ) inv --;
			}

			if( !inv ) nas ++;
		}
	}

	return nas;
}

const int C = 39;
void init(int N, int Q, const std::vector<int>& b){

	a.resize( N );
	a = b;
	pw[0] = 1;
	for( int i=1 ; i < MAX_N ; i ++ ) pw[i] = ( pw[i-1] * C ) % mod;

}

int main(){
#ifndef LOCAL
		std::ios_base::sync_with_stdio( false); cin.tie( NULL ); cout.tie( NULL );
#endif

	int n, q;
	std::cin >> n >> q;

	std::vector< int > b( n );
	for( auto& j : b ) std::cin >> j;

	init( n, q, b );

	while( q --> 0 ){
		int l, r;
		std::cin >> l >> r;
		ll nas = query( l, r );
		std::cout << nas << endl;
	}


	return 0;
}

