#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 42;
const ll mod = 1e10 + 7;
std::vector< ll > a;

ll pw[MAX_N];
ll pw2[MAX_N];
long long query(int l, int r){

	if( l == r ){
		if( a[l] == 1 ) return 1LL;
		else return 0;
	}

	cerr << endl << endl << out( l ) << out( r ) << endl;

	int m = ( l + r ) >> 1;

	std::vector< int > cnt( MAX_N, 0 );
	std::vector< int > ind( MAX_N, -1 );
	ll need = 0;
	ll need2 = 0;
	std::map< std::pair< ll, ll >, int > mm;
	int currInd;
	for( int i=m ; i >= l ; i-- ){

		cerr << out( i ) << out( a[i] ) << out( cnt[ a[i] ] ) << endl;
		if( cnt[ a[i] ] +1 > a[i] ) break;
		cnt[ a[i] ] ++;
		currInd = i;

		if( cnt[ a[i] ] == 1 ){
			need = ( need + ( ll( a[i] -1 ) * pw[ a[i] ] ) % mod ) % mod;
			need2 = ( need2 + ( ll( a[i] -1 ) * pw2[ a[i] ] ) % mod ) % mod;

			ind[ a[i] ] = i;
		}else{
			need = ( need - pw[ a[i] ] ) % mod;
			while( need < 0 ) need += mod;
			need2 = ( need2 - pw2[ a[i] ] ) % mod;
			while( need2 < 0 ) need2 += mod;
		}
		cerr << out( need ) << endl;
		mm[{ need, need2 }] ++;
	}


	cerr << endl << " ananasko " << endl;
	
	ll nas = 0;
	std::vector< int > cnt2( MAX_N, 0 );
	ll curr = 0;
	ll curr2 = 0;
	for( int i=m+1 ; i <= r ; i++ ){
		cnt2[ a[i] ] ++;
		cerr << out( a[i] ) << out( cnt2[ a[i] ] ) << endl;
		if( cnt2[ a[i] ] > a[i] ) break;
		if( cnt2[ a[i] ] == a[i] ){
			cerr << " = " << out( ind[ a[i] ] ) << endl;
			while( currInd <= ind[ a[i] ] ){
				mm[{ need, need2 }] --;
				cerr << " - " << out( currInd ) << out( need ) << out( a[currInd] ) << out( cnt[ a[currInd] ] ) << endl;
				cnt[ a[currInd] ] --;
				if( a[ currInd ] != 1 ){
					need = ( need + pw[ a[currInd]  ] ) % mod;
					need2 = ( need2 + pw2[ a[currInd]  ] ) % mod;
				}
				currInd ++;
			}
			cerr << out( need ) << endl;

			curr = ( curr - ll( pw[ a[i] ] * ( a[i] - 1 ) ) % mod ) % mod;
			curr2 = ( curr2 - ll( pw2[ a[i] ] * ( a[i] - 1 ) ) % mod ) % mod;
			if( curr < 0 ) curr += mod;
		}else{
			curr = ( curr + pw[ a[i] ] ) % mod;
			curr2 = ( curr2 + pw2[ a[i] ] ) % mod;
		}
		std::pair< ll, ll > key = { curr, curr2 };
		cerr << out( curr ) << out( mm[ key ] ) << endl;
		nas += mm[{ curr, curr2 }];
	}

	nas += query( l, m );
	nas += query( m+1, r );

	return nas;
}

const int C = 26;
const int C2 = 157;

void init(int N, int Q, const std::vector<int>& b){

	a.resize( N );
	for( int i=0 ; i < N ; i++ ) a[i] = b[i];

	pw[0] = 1;
	pw2[0] = 1;
	for( int i=1 ; i < MAX_N ; i ++ ) pw[i] = ( pw[i-1] * C ) % mod;
	for( int i=1 ; i < MAX_N ; i ++ ) pw2[i] = ( pw2[i-1] * C2 ) % mod;

}
