#include<bits/stdc++.h>
using namespace std;

std::vector<std::pair<int, int>> encode(int n, std::vector<bool> data)
{
    int brb=93, sum=0;
    bool dg=1;
    for(int i=0; i<brb; i++)
    {
        sum+=data[i];
    }
    if(sum>46) dg=0;
    vector<pair<int, int> > res;
    res.push_back({0, 1});
    res.push_back({1, 2});
    res.push_back({2, 3});
    res.push_back({4, 3});
    res.push_back({5, 4});
    res.push_back({3, 6});
    int tv=7, lch=6;
    if(dg)
    {
        res.push_back({6, tv});
        res.push_back({tv, tv+1});
        tv+=2;
    }
    int brpr=0;
    while(tv<=187)
    {
        res.push_back({lch, tv});
        lch=tv;
        tv++;
        if(data[brpr]==dg)
        {
            res.push_back({lch, tv});
            res.push_back({tv, tv+1});
            tv+=2;
        }
        brpr++;
    }
    while(tv<n)
    {
        res.push_back({lch, tv});
        lch=tv;
        tv++;
    }
    ///cout<<res.size()<<endl;
    ///for(int i=0; i<res.size(); i++)
    return res;
}

int N=201;
vector<int> gr[205];
int dist[205], par[205];
bool markp[205];

void dfs(int v)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(dist[nv]<0)
        {
            dist[nv]=dist[v]+1;
            par[nv]=v;
            dfs(nv);
        }
    }
}

int calc_dc(int v)
{
    int brd=1;
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(markp[nv] || par[v]==nv) continue;
        brd+=calc_dc(nv);
    }
    return brd;
}

std::vector<bool> decode(int n, std::vector<std::pair<int, int>> tree)
{
    n++;
    N=n;
    for(int i=0; i<n; i++) {gr[i].resize(0); par[i]=dist[i]=-1; markp[i]=0;}
    for(int i=0; i<n-1; i++)
    {
        gr[tree[i].first].push_back(tree[i].second);
        gr[tree[i].second].push_back(tree[i].first);
    }
    dist[0]=0;
    dfs(0);
    int Lend=0, Rend=0;
    for(int i=0; i<n; i++)
    {
        if(dist[Lend]<dist[i]) Lend=i;
    }
    for(int i=0; i<n; i++) dist[i]=-1;
    dist[Lend]=0;
    dfs(Lend);
    for(int i=0; i<n; i++)
    {
        if(dist[Rend]<dist[i]) Rend=i;
    }
    int pomv=Rend;
    while(pomv!=Lend)
    {
        markp[pomv]=1;
        pomv=par[pomv];
    }
    markp[Lend]=1;
    vector<int> vr={};
    while(Rend!=Lend)
    {
        vr.push_back(calc_dc(Rend)-1);
        Rend=par[Rend];
    }
    vr.push_back(calc_dc(Lend)-1);
    if(vr[0]<2 && vr[1]<2 && vr[2]<2 && vr[3]<2 && vr[4]<2 && vr[5]<2 ) reverse(vr.begin(), vr.end());
    int id=0;
    bool dg=0;
    while(vr[id]<=1) id++;
    id++;
    if(vr[id]>=2) dg=1;
    id++;
    vector<bool> ans={};
    for(;id<80; id++)
    {
        if(vr[id]>=2) ans.push_back(dg);
        else ans.push_back(1-dg);
    }
    return ans;
}

