#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;

vector< vector< bool > > block;
bool Left[5003][5003],Right[5003][5003];

void level(int m, int n, int nivo, int now){
    if(nivo==m)return ;
    if(now>0 && block[nivo][now-1]==false && Left[nivo][now-1]==true && investigate(now-1)==true){
        int l=0,r=now-2,mid=(l+r)/2;
        if(now>1){
            r=now-2;
            while(l<r){
                if(block[nivo][mid]==1)l=mid+1;
                else{
                    if(Left[nivo][mid]==true && investigate(mid)==true)r=mid-1;
                    else l=mid;
                }
            }
        }
        now=r+1;
    }else{
        if(now<n-1 && block[nivo][now+1]==false && Right[nivo][now+1]==true && investigate(now+1)==true){
                int l=now+2,r=n-1,mid=(l+r)/2;
                if(now<n-2){
                    l=now+2;
                    while(l<r){
                        if(block[nivo][mid]==1)r=mid-1;
                        else{
                            if(Right[nivo][mid]==true && investigate(mid)==true)l=mid+1;
                            else r=mid;
                        }
                    }
                }
            now=l-1;
        }
    }

    nivo++;
    goDeeper(now);
    level(m,n,nivo,now);
}


void solve(int n, int m, int k, const vector< vector< bool > >& blocked){

    swap(n,m);
    for(int x=0;x<n;x++){
        if(blocked[m-1][x]==0){
            Left[m-1][x]=true;
            Right[m-1][x]=true;
        }
    }
    for(int y=m-2;y>=0;y--){
        bool yes=false;
        for(int x=0;x<n;x++){
            if(blocked[y][x]==true)yes=false;
            else{
                if(yes==true)Left[y][x]=true;
                else{
                    if(Left[y+1][x]==true || Right[y+1][x]==true){
                        yes=true;
                        Left[y][x]=true;
                    }
                }
            }
        }
    }

    for(int y=m-2;y>=0;y--){
        bool yes=false;
        for(int x=n-1;x>=0;x--){
            if(blocked[y][x]==true)yes=false;
            else{
                if(yes==true)Right[y][x]=true;
                else{
                    if(Left[y+1][x]==true || Right[y+1][x]==true){
                        yes=true;
                        Right[y][x]=true;
                    }
                }
            }
        }
    }

    block=blocked;
    level(m,n,0,k);

}
