#include "tunnels.h"
#include<bits/stdc++.h>
using namespace std;

vector< vector< bool > > block;
bool imaLi[5005][5005],door[5005][5005];

void level(int m, int n, int nivo, int now){
    if(nivo==m)return ;

    int kude=now-1,br=0;

    for(int i=now-1;i>=0 && block[nivo][i]==false;i--)if(door[nivo][i]==true)br++;
    for(int i=now+1;i<n && block[nivo][i]==false;i++)if(door[nivo][i]==true)br++;
    if(door[nivo][now]==true)br++;

    while(kude>=0 && block[nivo][kude]==false)kude--;
    kude++;
    for(;kude<now;kude++){
        if(door[nivo][kude]==true){
            if(br==1 || investigate(kude)==true){
                nivo++;
                goDeeper(kude);
                level(m,n,nivo,kude);
                return ;
            }
        }
    }

    kude=now+1;
    while(kude<n && block[nivo][kude]==false)kude++;
    kude--;
    for(;kude>now;kude--){
        if(door[nivo][kude]==true){
            if(br==1 || investigate(kude)==true){
                nivo++;
                goDeeper(kude);
                level(m,n,nivo,kude);
                return ;
            }
        }
    }

    nivo++;
    goDeeper(now);
    level(m,n,nivo,now);
}


void solve(int n, int m, int k, const vector< vector< bool > >& blocked){

    swap(n,m);
    for(int x=0;x<n;x++){
        if(blocked[m-1][x]==0){
            imaLi[m-1][x]=1;
            door[m-1][x]=1;
        }
    }

    for(int y=m-2;y>=0;y--){
        bool yes=false;
        for(int x=0;x<n;x++){
            if(blocked[y][x]==true)yes=false;
            else{
                if(imaLi[y+1][x]==true){
                    door[y][x]=true;
                    yes=true;
                }
                imaLi[y][x]=yes;
            }
        }

        for(int x=n-2;x>=0;x--){
            if(blocked[y][x]==true)yes=false;
            else{
                if(imaLi[y+1][x]==true)yes=true;
                imaLi[y][x]=yes;
            }
        }
    }

    /**
    for(int y=0;y<m;y++){
        for(int x=0;x<n;x++){
            cout<<imaLi[y][x];
        }
        cout<<endl;
    }

    for(int y=0;y<m;y++){
        for(int x=0;x<n;x++){
            cout<<door[y][x];
        }
        cout<<endl;
    }
    **/

    block=blocked;
    level(m,n,0,k);

}