#include<bits/stdc++.h>
#include "tunnels.h"

using namespace std;
typedef long long ll;

const int MAXN = 5010;

int dp[MAXN][MAXN], fp[MAXN];
pair < int, int > from_dp[MAXN][MAXN];
void solve(int n, int m, int k, const vector< vector<bool > > &blocked)
{
    fp[0] = 0;
    for (int i = 1; i <= m; i ++)
    {
        fp[i] = fp[i / 2] + 1;
    }



    for (int i = 0; i <= m; i ++)
        for (int j = 0; j <= m; j ++)
        {
            if (i == 0 && j == 0)
            {
                dp[i][j] = 0;
                from_dp[i][j] = {i, j};
                continue;
            }
            dp[i][j] = 2 * m + 1;

            for (int d = 1; d <= min(50, i); d ++)
            {
                int cur = dp[d - 1][j] + 1;
                cur = max(cur, 1 + fp[i - d]);

                if (cur < dp[i][j])
                {
                    dp[i][j] = cur;
                    from_dp[i][j] = {d, 0};
                }
            }

            for (int d = 1; d <= min(50, j); d ++)
            {
                int cur = dp[i][d - 1] + 1;
                cur = max(cur, 1 + fp[j - d]);

                if (cur < dp[i][j])
                {
                    dp[i][j] = cur;
                    from_dp[i][j] = {d, 1};
                }
            }
        }
    ///cout << from_dp[m / 2][m].first << " " << from_dp[m / 2][m].second << endl;


    for (int row = 0; row < n; row ++)
    {
        int i = k;
        int j = m - k - 1;

        bool went = false;
        while(i > 0 || j > 0)
        {
            pair < int, int > step = from_dp[i][j];

            int d = step.first;
            if (step.second == 0)
            {
                bool tf = investigate(k - d);
                if (tf)
                {
                    int lb = k - i - 1;
                    int rb = k - d;
                    while(lb  + 1 < rb)
                    {
                        int mb = (lb + rb) / 2;
                        if (investigate(mb))
                            rb = mb;
                        else
                            lb = mb;
                    }

                    k = rb;
                    goDeeper(k);
                    went = true;
                    break;
                }
                else
                {
                    i = d - 1;
                }
            }
            else
            {
                bool tf = investigate(k + d);
                if (tf)
                {
                    int lb = k + d, rb = k + j + 1;

                    while(lb + 1 < rb)
                    {
                        int mb = (lb + rb) / 2;
                        if (investigate(mb))
                            lb = mb;
                        else
                            rb = mb;
                    }

                    k = lb;
                    goDeeper(k);
                    went = true;
                    break;
                }
                else
                {
                    j = d - 1;
                }
            }
        }


        if (!went)
            goDeeper(k);

    }

}
