#include<bits/stdc++.h>
#include "bits_and_tree.h"


using namespace std;
typedef long long ll;


const int MARK_NEC = 5;
vector < pair < int, int > > encode(int n, vector < bool > data)
{
    vector < pair < int, int > > edges;
    int root = 0, next_ver = 1;
    /// mark root


    int main_bit = 0;
    int cnt_bit[2];
    cnt_bit[0] = cnt_bit[1] = 0;
    int expected_bits = 100; /// lower for tests
    for (int i = 0; i < expected_bits; i ++)
    {
        if (data[i] == 0)
            cnt_bit[0] ++;
        else
            cnt_bit[1] ++;
    }

    if (cnt_bit[0] < cnt_bit[1])
        main_bit = 1;
    for (int i = 0; i < MARK_NEC * (main_bit + 1); i ++)
    {
        edges.push_back({root, next_ver ++});
    }

    int cur_ver = root;
    for (int i = 0; i < (int)(data.size()); i ++)
    {
        bool bit = data[i];
        if (bit == main_bit)
        {
            if (next_ver < n)
            {
                edges.push_back({cur_ver, next_ver ++});
                cur_ver = next_ver - 1;
            }
        }
        else
        {
            if (next_ver + 2 < n)
            {
                edges.push_back({cur_ver, next_ver ++});
                edges.push_back({cur_ver, next_ver ++});
                edges.push_back({cur_ver, next_ver ++});

                cur_ver = next_ver - 1;
            }
        }
    }

    return edges;

}

const int MAXN = 210;
vector < int > adj[MAXN];
vector < int > child[MAXN];
int sub[MAXN];

void trav(int v, int p)
{
    sub[v] = 1;
    for (int u : adj[v])
    {
        if (u != p)
        {
            child[v].push_back(u);
            trav(u, v);
            sub[v] += sub[u];
        }
    }
}

vector < bool > decode (int n, vector < pair < int, int > > tree)
{
    for (int i = 0; i <= n; i ++)
    {
        adj[i].clear();
        child[i].clear();
        sub[i] = 0;
    }

    assert((int)tree.size() == n);
    for (int i = 0; i < n; i ++)
    {
        adj[tree[i].first].push_back(tree[i].second);
        adj[tree[i].second].push_back(tree[i].first);
    }

    int root = 0;
    for (int i = 0; i <= n; i ++)
    {
        if (adj[i].size() > adj[root].size())
            root = i;
    }

    trav(root, - 1);

    int cur = root, main_bit = 0;
    vector < bool > data;
    if ((int)child[root].size() >= 2 * MARK_NEC)
        main_bit = 1;
    while(true)
    {
        int real_child = (int)(child[cur].size());
        if (real_child == 0)
            break;

        if (cur == root)
            real_child -= MARK_NEC * (main_bit + 1);

        if (real_child < 3)
            data.push_back(main_bit);
        else
            data.push_back((main_bit ^ 1));

        int to = child[cur][0];
        for (int u : child[cur])
        {
            if (sub[u] > sub[to])
                to = u;
        }
        cur = to;
    }

    return data;

}
