#include<iostream>
#include "tunnels.h"
using namespace std;
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    goDeeper(k);

    int l,r,mid,p=k,j;
    for(int i=1;i<n;i++)
    {
        if(p>0 && !blocked[i][p-1] && investigate(p-1))
        {
            for(j=p-2;j>=0;j--)
                if(blocked[i][j])
                 break;
            j++;

            l=j;r=p-1;

            while(l<=r)
            {
                //cout<<"le: "<<l<<" "<<r<<" "<<mid<<endl;
                mid=(l+r)/2;
                if(!investigate(mid))
                    l=mid+1;
                else
                    r=mid-1;
            }
        }
        else
        {
            for(j=p+2;j<=m-1;j++)
                if(blocked[i][j])
                 break;
            j--;
            l=p+1;r=j;

            while(l<=r)
            {
               //  cout<<"ri: "<<l<<" "<<r<<" "<<mid<<endl;

                mid=(l+r)/2;
                if(!investigate(mid))
                     r=mid-1;
                else
                   l=mid+1;
            }
            l=r;
        }

       /* int rl,ll;
        if(i<n && blocked[i+1][l])
        {
            if(p>l)
            {
                for(int j=l+1;j<=p;j++)
                {
                    if(!blocked[i+1][j])
                    {
                        l=j;
                        break;
                    }
                }
                break;
            }
            if(p<l)
            {
                for(int j=l-1;j>=p;j--)
                {
                    if(!blocked[i+1][j])
                    {
                        l=j;
                        break;
                    }
                }
                break;
            }
        }
        */
        goDeeper(l);

        p=l;
    }
    return;
}
