#include<iostream>
#include "tunnels.h"
using namespace std;

long long le[5005][5005], ri[5005][5005];

long long bins1(long long lev, long long f,long long la,long long d)
{
    long long l=f, r=la, mid;

    while(l<=r)
    {
        mid=(l+r)/2;
        if(mid==d || investigate(mid))l=mid+1;
        else r=mid-1;
    }
    return l+1;

}
long long bins2(long long lev, long long f,long long la,long long d)
{
    long long l=f, r=la, mid;

    while(l<=r)
    {
        mid=(l+r)/2;
        if(mid==d||investigate(mid))r=mid-1;
        else l=mid+1;
    }
    return l;

}


void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    long long i,j,lastp=-1,last2=-1,lev;

    for(i=0;i<n;i++)
    {
        lastp=-1;
        for(j=0;j<m;j++)
        {
            if(blocked[i][j])lastp=j;
            le[i][j]=lastp;
        }
        last2=m;
        for(j=m-1;j>=0;j--)
        {
            if(blocked[i][j])last2=j;
            ri[i][j]=last2;
        }

        j=0;
        if(i<n-1)
        {
            while(j<m && blocked[i+1][j]){
                le[i][j]=j;
                j++;
            }
            j=m-1;
            while(j>=0 && blocked[i+1][j])
            {
                ri[i][j]=j;
                j--;
            }

            for(j=1;j<m;j++)le[i][j]=max(le[i][j],le[i][j-1]);
            for(j=m-2;j>=0;j--)ri[i][j]=min(ri[i][j],ri[i][j+1]);
        }
    }

   /* for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)cout<<le[i][j];
        cout<<endl;
    }
     for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)cout<<ri[i][j];
        cout<<endl;
    }*/

    lev=0;

    while(lev<n)
    {
        long long p1=le[lev][k];
        long long p2=ri[lev][k];

        long long a1;
        if(p2-1>k && k<m-1 && !blocked[lev][k+1] && investigate(k+1))a1=bins1(lev,k,p2-1,k);
        else if(k>=p1+1 && k>0 && !blocked[lev][k-1])a1=bins2(lev,p1+1,k,k);
        else a1=k;
        k=a1; goDeeper(k); lev++;
        cout<<k<<endl;
    }

}
